/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Button = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Icon = _interopRequireDefault(require("./Icon"));

require("./css/Button.less");

var _Common = _interopRequireDefault(require("./Common"));

var _common = require("./components/common");

var _bootstrap = require("bootstrap");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Button =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Button, _React$PureComponent);

  function Button(props) {
    var _this$props$id;

    var _this;

    _classCallCheck(this, Button);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Button).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "tip", void 0);

    _defineProperty(_assertThisInitialized(_this), "clickHandler", function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }
    });

    _this.domId = (_this$props$id = _this.props.id) !== null && _this$props$id !== void 0 ? _this$props$id : 'btn-' + _Common["default"].RandomString(16);
    return _this;
  }

  _createClass(Button, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.tip) {
        // console.log(Tooltip);
        this.tip = new _bootstrap.Tooltip(document.getElementById(this.domId), {
          'trigger': 'hover'
        }); // $('#'+this.domId).tooltip({'trigger':'hover'});
        // this.tip.toggle('hover')
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.tip) {
        // $('#'+this.domId).tooltip('dispose');
        this.tip.hide();
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'btn ck-btn';
      var base_style = ['btn']; //is outline theme

      if (this.props.outline) {
        base_style.push('outline');
      } //apply style


      if (this.props.theme !== undefined) {
        var _this$props$theme;

        var themeStr = typeof this.props.theme === 'string' ? this.props.theme : _common.Theme[(_this$props$theme = this.props.theme) !== null && _this$props$theme !== void 0 ? _this$props$theme : 0];
        base_style.push(themeStr);
      } //merge class


      base = (0, _bind["default"])(base, base_style.join('-')); //size

      if (this.props.size !== 'df') {
        if (this.props.size === 'xs') {
          base = (0, _bind["default"])(base, "ck-btn-xs");
        } else {
          base = (0, _bind["default"])(base, "btn-" + this.props.size);
        }
      } //block


      if (this.props.block) {
        base = (0, _bind["default"])(base, 'w-100');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      var base = {};

      if (this.props.width) {
        base.width = this.props.width;
      }

      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.absolute) {
        var _this$props$x, _this$props$y;

        base.position = 'absolute';
        base.left = (_this$props$x = this.props.x) !== null && _this$props$x !== void 0 ? _this$props$x : '';
        base.top = (_this$props$y = this.props.y) !== null && _this$props$y !== void 0 ? _this$props$y : '';
      }

      if (_typeof(this.props.style) === 'object') {
        base = _objectSpread({}, base, this.props.style);
      }

      return base;
    }
  }, {
    key: "render",
    value: function render() {
      var btnProps = _objectSpread({}, this.props);

      delete btnProps.outline;
      delete btnProps.block;
      delete btnProps.loading;
      return _react["default"].createElement("button", _extends({}, btnProps, this.renderTip(), {
        id: this.domId,
        disabled: this.props.disabled,
        onClick: this.clickHandler,
        className: this.getClasses(),
        style: this.getStyles(),
        title: this.props.tip
      }), this.renderIcon(), this.props.children);
    }
  }, {
    key: "renderTip",
    value: function renderTip() {
      if (!this.props.tip) {
        return {};
      }

      return {
        'data-toggle': "tooltip",
        'data-placement': "bottom"
      };
    }
  }, {
    key: "renderIcon",
    value: function renderIcon() {
      if (this.props.loading) {
        return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("span", {
          className: "spinner-border spinner-border-sm",
          role: "status"
        }), " ");
      }

      if (this.props.icon) {
        var _this$props$icon;

        return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_Icon["default"], {
          icon: (_this$props$icon = this.props.icon) !== null && _this$props$icon !== void 0 ? _this$props$icon : ''
        }), " ");
      }

      return null;
    }
  }]);

  return Button;
}(_react["default"].PureComponent);

exports.Button = Button;

_defineProperty(Button, "defaultProps", {
  theme: _common.Theme.primary,
  outline: false,
  size: 'df',
  loading: false
});

var _default = Button;
exports["default"] = _default;
//# sourceMappingURL=Button.js.map
