/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CKModal = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Common = _interopRequireDefault(require("./Common"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _Button = _interopRequireDefault(require("./Button"));

var _Load = _interopRequireDefault(require("./Load"));

require("./css/Modal.less");

var _ButtonGroup = _interopRequireDefault(require("./ButtonGroup"));

var _common = require("./components/common");

var _i18n = _interopRequireDefault(require("./components/i18n"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ModalAlert = 0;
var ModalConfirm = 1;
var ModalLoading = 2;
var ModalView = 3;
var BaseModal = 1050; //Alert options

var defBtns = {
  ok: '确定',
  cancel: '取消'
};

var CKModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CKModal, _React$Component);

  //modal type
  //alert confirm callback function
  function CKModal(props) {
    var _this$props$isCloseBt, _this$props$header, _this$props$center, _this$props$fade, _this$props$shadowClo;

    var _this;

    _classCallCheck(this, CKModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CKModal).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", 'modal-' + _Common["default"].RandomString(16));

    _defineProperty(_assertThisInitialized(_this), "modalType", ModalAlert);

    _defineProperty(_assertThisInitialized(_this), "callback", void 0);

    _defineProperty(_assertThisInitialized(_this), "evtClosed", void 0);

    _defineProperty(_assertThisInitialized(_this), "evtOpened", void 0);

    _defineProperty(_assertThisInitialized(_this), "offsetIndex", document.querySelectorAll(".modal").length * 10);

    _defineProperty(_assertThisInitialized(_this), "is_open", false);

    _defineProperty(_assertThisInitialized(_this), "_modal", void 0);

    _defineProperty(_assertThisInitialized(_this), "_shadow", void 0);

    _defineProperty(_assertThisInitialized(_this), "closeHandler", function () {
      if (typeof _this.props.onClose === 'function') {
        _this.props.onClose();
      }

      if (typeof _this.evtClosed === 'function') {
        _this.evtClosed();

        _this.evtClosed = null;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "openHandler", function () {
      if (typeof _this.props.onOpen === 'function') {
        _this.props.onOpen();
      }
    });

    _this.state = {
      empty: false,
      content: '',
      title: '',
      isCloseBtn: (_this$props$isCloseBt = _this.props.isCloseBtn) !== null && _this$props$isCloseBt !== void 0 ? _this$props$isCloseBt : true,
      header: (_this$props$header = _this.props.header) !== null && _this$props$header !== void 0 ? _this$props$header : true,
      type: ModalAlert,
      center: (_this$props$center = _this.props.center) !== null && _this$props$center !== void 0 ? _this$props$center : true,
      fade: (_this$props$fade = _this.props.fade) !== null && _this$props$fade !== void 0 ? _this$props$fade : false,
      show: false,
      size: 'lg',
      width: null,
      btns: defBtns,
      shadowClose: (_this$props$shadowClo = _this.props.shadowClose) !== null && _this$props$shadowClo !== void 0 ? _this$props$shadowClo : false
    };

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    return _this;
  }

  _createClass(CKModal, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextState.content !== null && nextState.content.props) {
        nextState.content = _react["default"].cloneElement(nextState.content, _objectSpread({}, nextState.content.props, {
          parent: this
        }));
      }

      if (this.state.content !== nextState.content) {
        return true;
      }

      return this.state.show !== nextState.show;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (_i18n["default"].getLang()["short"] === "en") {
        defBtns = {
          ok: 'Ok',
          cancel: 'Cancel'
        };
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {}
  }, {
    key: "hasScrollbar",
    value: function hasScrollbar() {
      return document.body.scrollHeight > (window.innerHeight || document.documentElement.clientHeight);
    }
  }, {
    key: "open",
    value: function open() {
      var _this2 = this;

      this.setState({
        show: true
      }, function () {
        var _document$body$datase;

        if (_this2.is_open) return;
        _this2.is_open = true;
        var modals = parseInt((_document$body$datase = document.body.dataset.modals) !== null && _document$body$datase !== void 0 ? _document$body$datase : '0');

        if (!modals) {
          modals = 0;
        }

        modals += 1;
        _this2.offsetIndex = modals * 10;
        _this2._modal.style.zIndex = "".concat(BaseModal + _this2.offsetIndex + 2);
        _this2._shadow.style.zIndex = "".concat(BaseModal + _this2.offsetIndex + 1);
        document.body.dataset.modals = modals + '';
        document.body.classList.add("modal-open");

        if (_this2.hasScrollbar()) {
          document.body.style.paddingRight = '15px';
        }

        if (_this2.props.blurSelector) {
          var selector = document.querySelector(_this2.props.blurSelector);

          if (selector) {
            selector.classList.add("ck-model-blur");
          }
        }
      }); // if (this.state.fade) {
      //     this._modal.classList.add("ck-modal-fade");
      //     this._shadow.classList.add('ck-modal-shadow-fade');
      // }
      // this._modal.classList.add("visible");
      // this._modal.classList.remove("invisible",'ck-modal-close-an');
      // this._shadow.classList.add('visible');
      // this._shadow.classList.remove("invisible",'ck-modal-shadow-close');
      // document.body.classList.add("ck-model-blur")
    }
  }, {
    key: "close",
    value: function close() {
      var _this3 = this;

      this.setState({
        show: false
      }, function () {
        var _document$body$datase2;

        if (!_this3.is_open) return;
        _this3.is_open = false;
        var modals = parseInt((_document$body$datase2 = document.body.dataset.modals) !== null && _document$body$datase2 !== void 0 ? _document$body$datase2 : '1');
        modals -= 1;
        document.body.dataset.modals = modals + '';

        if (modals === 0) {
          setTimeout(function () {
            document.body.classList.remove("modal-open");

            if (_this3.hasScrollbar()) {
              document.body.style.paddingRight = '0';
            }
          }, _this3.state.fade ? 300 : 0);

          if (_this3.props.blurSelector) {
            var selector = document.querySelector(_this3.props.blurSelector);

            if (selector) {
              selector.classList.remove("ck-model-blur");
            }
          }
        }

        _this3.closeHandler();
      }); // this._modal.classList.remove("visible");
      // this._shadow.classList.remove("visible");
      // this._modal.classList.add("invisible");
      // this._shadow.classList.add("invisible");
      // if (this.state.fade) {
      //     this._modal.classList.add("ck-modal-close-an");
      //     this._shadow.classList.add('ck-modal-shadow-close');
      // }
    }
  }, {
    key: "alert",
    value: function alert(opt, cb) {
      var _opts$title,
          _opts$close,
          _opts$header,
          _opts$center,
          _opts$width,
          _opts$btns,
          _opts$shadowClose,
          _opts$fade,
          _opts$empty,
          _this4 = this;

      var opts = _typeof(opt) === 'object' ? opt : {
        content: opt
      };
      this.callback = opts.callback || cb || null;
      this.modalType = ModalAlert;
      this.setState({
        title: (_opts$title = opts.title) !== null && _opts$title !== void 0 ? _opts$title : '',
        content: opts.content || opt || '',
        isCloseBtn: (_opts$close = opts.close) !== null && _opts$close !== void 0 ? _opts$close : true,
        header: !opts.title ? false : (_opts$header = opts.header) !== null && _opts$header !== void 0 ? _opts$header : this.props.header,
        type: ModalAlert,
        center: (_opts$center = opts.center) !== null && _opts$center !== void 0 ? _opts$center : this.props.center,
        width: (_opts$width = opts.width) !== null && _opts$width !== void 0 ? _opts$width : null,
        btns: (_opts$btns = opts.btns) !== null && _opts$btns !== void 0 ? _opts$btns : defBtns,
        shadowClose: (_opts$shadowClose = opts.shadowClose) !== null && _opts$shadowClose !== void 0 ? _opts$shadowClose : this.props.shadowClose,
        fade: (_opts$fade = opts.fade) !== null && _opts$fade !== void 0 ? _opts$fade : this.props.fade,
        empty: (_opts$empty = opts.empty) !== null && _opts$empty !== void 0 ? _opts$empty : false
      }, function () {
        // this.open({
        //     backdrop:'static',
        //     keyboard:false,
        // });
        _this4.open();
      });
    }
    /**
     * modal confirm method
     * opt example
     * {
     *      title:'',
     *      content:'',
     *      [callback: func]
     * }
     * @param opt
     */

  }, {
    key: "confirm",
    value: function confirm(opt, cb) {
      var _opts$title2,
          _opts$close2,
          _opts$header2,
          _opts$center2,
          _opts$width2,
          _opts$btns2,
          _opts$shadowClose2,
          _opts$fade2,
          _opts$empty2,
          _this5 = this;

      var opts = _typeof(opt) === 'object' ? opt : {
        content: opt
      };
      this.callback = opts.callback || cb || null;
      this.modalType = ModalConfirm;
      this.setState({
        title: (_opts$title2 = opts.title) !== null && _opts$title2 !== void 0 ? _opts$title2 : '',
        content: opts.content || opts || '',
        isCloseBtn: (_opts$close2 = opts.close) !== null && _opts$close2 !== void 0 ? _opts$close2 : true,
        header: !opts.title ? false : (_opts$header2 = opts.header) !== null && _opts$header2 !== void 0 ? _opts$header2 : this.props.header,
        type: ModalConfirm,
        center: (_opts$center2 = opts.center) !== null && _opts$center2 !== void 0 ? _opts$center2 : this.props.center,
        width: (_opts$width2 = opts.width) !== null && _opts$width2 !== void 0 ? _opts$width2 : null,
        btns: (_opts$btns2 = opts.btns) !== null && _opts$btns2 !== void 0 ? _opts$btns2 : defBtns,
        shadowClose: (_opts$shadowClose2 = opts.shadowClose) !== null && _opts$shadowClose2 !== void 0 ? _opts$shadowClose2 : this.props.shadowClose,
        fade: (_opts$fade2 = opts.fade) !== null && _opts$fade2 !== void 0 ? _opts$fade2 : this.props.fade,
        empty: (_opts$empty2 = opts.empty) !== null && _opts$empty2 !== void 0 ? _opts$empty2 : false // show:true,

      }, function () {
        _this5.open();
      });
    }
    /**
     * modal loading method
     * @param opt
     */

  }, {
    key: "loading",
    value: function loading(opt) {
      var _opts$title3,
          _opts$close3,
          _opts$header3,
          _opts$center3,
          _opts$width3,
          _opts$shadowClose3,
          _opts$fade3,
          _opts$empty3,
          _this6 = this;

      var opts = _typeof(opt) === 'object' ? opt : {
        content: opt
      };
      this.modalType = ModalLoading;
      this.setState({
        title: (_opts$title3 = opts.title) !== null && _opts$title3 !== void 0 ? _opts$title3 : '',
        content: opts.content || opt || '',
        isCloseBtn: (_opts$close3 = opts.close) !== null && _opts$close3 !== void 0 ? _opts$close3 : true,
        header: !opts.title ? false : (_opts$header3 = opts.header) !== null && _opts$header3 !== void 0 ? _opts$header3 : this.props.header,
        type: ModalLoading,
        center: (_opts$center3 = opts.center) !== null && _opts$center3 !== void 0 ? _opts$center3 : this.props.center,
        width: (_opts$width3 = opts.width) !== null && _opts$width3 !== void 0 ? _opts$width3 : null,
        shadowClose: (_opts$shadowClose3 = opts.shadowClose) !== null && _opts$shadowClose3 !== void 0 ? _opts$shadowClose3 : this.props.shadowClose,
        fade: (_opts$fade3 = opts.fade) !== null && _opts$fade3 !== void 0 ? _opts$fade3 : this.props.fade,
        empty: (_opts$empty3 = opts.empty) !== null && _opts$empty3 !== void 0 ? _opts$empty3 : false // show:true,

      }, function () {
        _this6.open();
      });
    }
    /**
     * modal view method
     * opt example
     * {
     *      title:'',
     *      content:flex,
     *      [callback:func]
     * }
     * @param opt
     */

  }, {
    key: "view",
    value: function view(opts) {
      var _opts$title4,
          _opts$close4,
          _opts$header4,
          _opts$center4,
          _opts$width4,
          _opts$shadowClose4,
          _opts$fade4,
          _opts$size,
          _opts$empty4,
          _this7 = this;

      this.callback = opts.callback || null;
      this.modalType = ModalView;
      this.setState({
        title: (_opts$title4 = opts.title) !== null && _opts$title4 !== void 0 ? _opts$title4 : '',
        content: opts.content || opts || '',
        isCloseBtn: (_opts$close4 = opts.close) !== null && _opts$close4 !== void 0 ? _opts$close4 : true,
        header: !opts.title ? false : (_opts$header4 = opts.header) !== null && _opts$header4 !== void 0 ? _opts$header4 : this.props.header,
        type: ModalView,
        center: (_opts$center4 = opts.center) !== null && _opts$center4 !== void 0 ? _opts$center4 : this.props.center,
        width: (_opts$width4 = opts.width) !== null && _opts$width4 !== void 0 ? _opts$width4 : null,
        shadowClose: (_opts$shadowClose4 = opts.shadowClose) !== null && _opts$shadowClose4 !== void 0 ? _opts$shadowClose4 : this.props.shadowClose,
        fade: (_opts$fade4 = opts.fade) !== null && _opts$fade4 !== void 0 ? _opts$fade4 : this.props.fade,
        size: (_opts$size = opts.size) !== null && _opts$size !== void 0 ? _opts$size : 'lg',
        // sm,lg(default),xl
        empty: (_opts$empty4 = opts.empty) !== null && _opts$empty4 !== void 0 ? _opts$empty4 : false // show:true,

      }, function () {
        _this7.open();
      });
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'modal d-block';

      if (this.modalType === ModalView) {
        base = (0, _bind["default"])(base, "bd-example-modal-lg");
      }

      if (this.state.fade) {
        base = (0, _bind["default"])(base, 'ck-modal-fade');
      }

      if (this.state.show) {
        base = (0, _bind["default"])(base, 'visible');
      } else {
        base = (0, _bind["default"])(base, 'invisible', this.state.fade ? 'ck-modal-close-an' : '');
      }

      if (this.state.empty) {
        base = (0, _bind["default"])(base, 'ck-modal-empty');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getDialogClasses",
    value: function getDialogClasses() {
      var base = 'modal-dialog';

      if (this.modalType === ModalView) {
        base = (0, _bind["default"])(base, "modal-" + this.state.size);
      }

      if (this.state.center) {
        base = (0, _bind["default"])(base, "modal-dialog-centered");
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getDialogStyles",
    value: function getDialogStyles() {
      var base = {};

      if (this.state.width) {
        base['maxWidth'] = this.state.width;
      }

      return base;
    }
  }, {
    key: "getShadowClasses",
    value: function getShadowClasses() {
      var base = 'modal-backdrop ck-modal-shadow';

      if (this.state.show) {
        base = (0, _bind["default"])(base, 'visible');
      } else {
        base = (0, _bind["default"])(base, 'invisible', this.state.fade ? 'ck-modal-shadow-close' : '');
      }

      if (this.state.fade) {
        base = (0, _bind["default"])(base, 'ck-modal-shadow-fade');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "renderFooter",
    value: function renderFooter() {
      var _this8 = this;

      var content = null;

      switch (this.state.type) {
        case ModalAlert:
          content = _react["default"].createElement(_Button["default"], {
            className: "",
            block: true,
            "data-dismiss": "modal",
            onClick: function onClick() {
              _this8.close();

              if (typeof _this8.callback === 'function') {
                _this8.callback(1);
              }
            }
          }, this.state.btns['ok']);
          break;

        case ModalConfirm:
          content = _react["default"].createElement(_ButtonGroup["default"], {
            className: "w-100"
          }, _react["default"].createElement(_Button["default"], {
            className: "w-100",
            onClick: function onClick() {
              _this8.close();

              if (typeof _this8.callback === 'function') {
                _this8.callback(1);
              }
            }
          }, this.state.btns['ok']), _react["default"].createElement(_Button["default"], {
            className: "w-100",
            onClick: function onClick() {
              _this8.close();

              if (typeof _this8.callback === 'function') {
                _this8.callback(0);
              }
            },
            theme: _common.Theme.secondary
          }, this.state.btns['cancel']));
          break;

        default:
          return null;
      }

      return _react["default"].createElement("div", {
        className: "p-2"
      }, content);
    }
  }, {
    key: "render",
    value: function render() {
      var _this9 = this;

      var content = _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this9._modal = c;
        },
        className: this.getClasses(),
        tabIndex: -1,
        id: this.domId,
        role: "dialog",
        onMouseUp: this.state.shadowClose ? function () {
          _this9.close();
        } : undefined
      }, _react["default"].createElement("div", {
        className: this.getDialogClasses(),
        style: this.getDialogStyles(),
        role: "document",
        onMouseUp: this.state.shadowClose ? function (e) {
          e.stopPropagation();
          e.preventDefault();
        } : undefined
      }, _react["default"].createElement("div", {
        className: "modal-content"
      }, this.state.header ? _react["default"].createElement("div", {
        className: "modal-header"
      }, _react["default"].createElement("h5", {
        className: "modal-title"
      }, this.state.title), this.state.isCloseBtn ? _react["default"].createElement("button", {
        type: "button",
        className: "btn-close",
        onClick: function onClick() {
          _this9.close();
        }
      }) : null) : null, _react["default"].createElement("div", {
        className: "modal-body"
      }, this.state.type === ModalLoading ? _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_Load["default"], null), "\xA0\xA0\xA0", this.state.content) : this.state.content), this.renderFooter()))), _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this9._shadow = c;
        },
        className: this.getShadowClasses(),
        id: "".concat(this.domId, "-shadow")
      })); // }


      return _reactDom["default"].createPortal(content, document.body);
    }
  }]);

  return CKModal;
}(_react["default"].Component);

exports.CKModal = CKModal;

_defineProperty(CKModal, "defaultProps", {
  isCloseBtn: true,
  header: false,
  center: false,
  fade: false,
  shadowClose: false
});

var Modal = CKModal;
var _default = Modal;
exports["default"] = _default;
//# sourceMappingURL=CKModal.js.map
