/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.format = _format;
exports["default"] = exports.Calendar = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/Calender.less");

var _Icon = _interopRequireDefault(require("./Icon"));

var _Common = _interopRequireWildcard(require("./Common"));

var _Button = _interopRequireDefault(require("./Button"));

var _Scroll = _interopRequireDefault(require("./Scroll"));

var _common = require("./components/common");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  'zh': {
    'week': ['日', '一', '二', '三', '四', '五', '六'],
    'month': ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
    'time': {
      'hour': '时',
      'min': '分',
      'sec': '秒',
      'time': '时间',
      'confirm': '确定'
    }
  },
  'en': {
    'week': ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
    'month': ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
    'time': {
      'hour': 'hour',
      'min': 'min',
      'sec': 'sec',
      'time': 'time',
      'confirm': 'Confirm'
    }
  }
};

var Calendar =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Calendar, _React$PureComponent);

  function Calendar(props) {
    var _this$props$value;

    var _this;

    _classCallCheck(this, Calendar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Calendar).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "year", {
      start: 0,
      end: 0
    });

    _defineProperty(_assertThisInitialized(_this), "isClose", true);

    _defineProperty(_assertThisInitialized(_this), "hours", void 0);

    _defineProperty(_assertThisInitialized(_this), "minute", void 0);

    _defineProperty(_assertThisInitialized(_this), "sec", void 0);

    _defineProperty(_assertThisInitialized(_this), "current_date", void 0);

    _defineProperty(_assertThisInitialized(_this), "parentDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "failRange", void 0);

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "show_date", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainTable", void 0);

    _defineProperty(_assertThisInitialized(_this), "clientWidth", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "keyPressHandler", function (e) {
      if (e.keyCode === 13) {
        _this.autoComplete(e.target.value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "selectTimeHandler", function () {
      _this.setState({
        month: false,
        year: false,
        time: !_this.state.time
      }, function () {
        if (!_this.state.time) {
          if (typeof _this.props.onSelect === 'function') _this.props.onSelect(_this.format());
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "hide", function (e) {
      if (e && e.type === 'blur') {
        _this.autoComplete((e === null || e === void 0 ? void 0 : e.target).value);
      } // $(ReactDOM.findDOMNode(this)).hide();


      _this.mainDom.classList.add('ck-calendar-none');

      _this.isClose = true;
      window.removeEventListener('mousedown', _this.hide, false); // this.parentDom.removeEventListener('blur',this.hide,false);
      // this.parentDom.removeEventListener('click',this.checkShow,false);
      // this.parentDom.removeEventListener('keypress',this.keyPressHandler,false);
    });

    _defineProperty(_assertThisInitialized(_this), "checkShow", function () {
      if (_this.isClose) {
        _this.show(_this.parentDom);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "touchStartX", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchStartY", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchScrollX", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchScrollY", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchStartHandler", function (e) {
      if (e.touches.length === 1 && e.currentTarget) {
        var touch = e.touches[0];
        var dom = e.currentTarget;
        _this.touchStartX = touch.pageX;
        _this.touchStartY = touch.pageY;
        _this.touchScrollX = dom.scrollLeft;
        _this.touchScrollY = dom.scrollTop;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "touchMoveHandler", function (e) {
      if (e.touches.length === 1 && e.currentTarget) {
        e.preventDefault();
        var dom = e.currentTarget;
        var touch = e.touches[0];
        var diffX = _this.touchStartX - touch.pageX;
        var diffY = _this.touchStartY - touch.pageY;
        dom.scrollTo({
          left: _this.touchScrollX + diffX,
          top: _this.touchScrollY + diffY,
          behavior: 'auto'
        }); // this.mainDom.scrollLeft = this.touchScrollX + diffX;
        // this.mainDom.scrollTop = this.touchScrollY + diffY;
      }
    });

    _this.setCurrentDate((_this$props$value = _this.props.value) !== null && _this$props$value !== void 0 ? _this$props$value : '');

    _this.hours = _toConsumableArray(Array(24).keys()).map(function (item, idx) {
      return (0, _Common.strpad)(idx.toString(), 2, '0');
    });
    _this.minute = _toConsumableArray(Array(60).keys()).map(function (item, idx) {
      return (0, _Common.strpad)(idx.toString(), 2, '0');
    });
    _this.sec = _this.minute.slice();
    _this.parentDom = _this.props.target;
    _this.failRange = _this.initFailRange(_this.props.limit); // this.failRange = {
    //     start: null,
    //     end: null
    // };

    _this.domId = 'cale-' + _Common["default"].RandomString(8);
    _this.state = {
      days: _this.fillDateList(),
      month: false,
      year: false,
      time: false,
      hour: '00',
      minute: '00',
      second: '00'
    };
    return _this;
  }

  _createClass(Calendar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.clientWidth = this.mainTable.clientWidth;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // $(window).off('mousedown',this.hide);
      window.removeEventListener('mousedown', this.hide, false);

      if (this.parentDom) {
        this.parentDom.removeEventListener('blur', this.hide, false);
        this.parentDom.removeEventListener('keypress', this.keyPressHandler, false);
        this.parentDom.removeEventListener('click', this.checkShow, false);
      }

      this.unTouchScrollHandler();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.time) {
        this.touchScrollHandler();
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProp) {
      if (this.props.value !== nextProp.value) {
        this.setCurrentDate(nextProp.value);
        this.setState({
          days: this.fillDateList(),
          hour: this.current_date.getHours().toString().padStart(2, '0'),
          minute: this.current_date.getMinutes().toString().padStart(2, '0'),
          second: this.current_date.getSeconds().toString().padStart(2, '0')
        });
      }
    }
  }, {
    key: "isTimeBar",
    value: function isTimeBar() {
      var _this$props$format;

      if ((_this$props$format = this.props.format) === null || _this$props$format === void 0 ? void 0 : _this$props$format.includes("HH")) {
        return true;
      }

      return this.props.timeBar;
    }
  }, {
    key: "initFailRange",
    value: function initFailRange(limit) {
      if (!limit) return undefined;
      return {
        start: (limit === null || limit === void 0 ? void 0 : limit.gt) ? new Date(limit.gt) : null,
        end: (limit === null || limit === void 0 ? void 0 : limit.lt) ? new Date(limit.lt) : null
      };
    }
  }, {
    key: "setCurrentDate",
    value: function setCurrentDate(value) {
      if (value) {
        if (/^\d{1,10}$/.test(value)) {
          this.current_date = new Date(value * 1000);
        } else {
          this.current_date = new Date(value);
        }

        if (this.current_date.toDateString() === "Invalid Date") {
          this.current_date = new Date();
        }
      } else {
        this.current_date = new Date();
      }

      this.show_date = new Date(this.current_date);
    }
  }, {
    key: "fillDateList",
    value: function fillDateList() {
      var first = new Date(this.show_date.getFullYear(), this.show_date.getMonth(), 1);
      first.setDate(first.getDay() === 0 ? -7 : -first.getDay());
      var count = 42;
      var date = [];
      var week = new Array(7);

      for (var i = 1; i <= count; i++) {
        first.setDate(first.getDate() + 1);
        var day = {
          value: first.getDate(),
          disabled: this.show_date.getMonth() !== first.getMonth()
        };

        if (!day.disabled && this.failRange) {
          if (this.failRange.start && first < this.failRange.start) {
            day.disabled = true;
          }

          if (this.failRange.end && first > this.failRange.end) {
            day.disabled = true;
          }
        }

        week[first.getDay()] = day;

        if (first.getDay() === 6) {
          date.push(week);
          week = new Array(7);
        }
      }

      return date;
    }
  }, {
    key: "privMonth",
    value: function privMonth() {
      if (this.state.year) {
        this.setYear(this.year.end - 10, true);
      } else {
        this.setMonth(this.show_date.getMonth() - 1);
      }
    }
  }, {
    key: "nextMonth",
    value: function nextMonth() {
      if (this.state.year) {
        this.setYear(this.year.end + 10, true);
      } else {
        this.setMonth(this.show_date.getMonth() + 1);
      }
    }
  }, {
    key: "setMonth",
    value: function setMonth(month) {
      // console.log(month);
      // console.log(this.show_date.toLocaleDateString());
      this.show_date.setDate(1);
      this.show_date.setMonth(month); // console.log(this.show_date.toLocaleDateString());
      // console.log("set month:",this.show_date.getMonth());

      this.setState({
        days: this.fillDateList(),
        month: false,
        year: false
      });
    }
  }, {
    key: "setYear",
    value: function setYear(year, show) {
      this.show_date.setFullYear(year);
      this.setState({
        days: this.fillDateList(),
        month: false,
        year: show
      });
    }
  }, {
    key: "setFailRange",
    value: function setFailRange(start_date, days) {
      if (!start_date.valueOf()) {
        start_date = new Date();
      }

      start_date.setDate(start_date.getDate() - 1);
      var start = new Date(start_date);
      var end = new Date(start_date);
      var showMonth = new Date(start_date);
      showMonth.setDate(showMonth.getDate() + 1);
      end.setDate(end.getDate() + days);
      this.failRange = {
        start: start,
        end: end
      };
      this.show_date = showMonth;
      this.setState({
        days: this.fillDateList()
      });
      return !(this.current_date <= start || this.current_date > end);
    }
  }, {
    key: "choseDay",
    value: function choseDay(year, month, day) {
      var date = new Date(year, month, day, parseInt(this.state.hour), parseInt(this.state.minute), parseInt(this.state.second));
      this.setCurrentDate(date);
      this.setState({
        days: this.fillDateList()
      });

      if (typeof this.props.onSelect === 'function') {
        this.props.onSelect(this.format());
      }

      if (this.props.absolute) {
        this.hide();
      }
    }
  }, {
    key: "format",
    value: function format(formatStr) {
      var time_str = formatStr !== null && formatStr !== void 0 ? formatStr : this.props.format;
      return _format(time_str, this.show_date);
    }
  }, {
    key: "show",
    value: function show(dom) {
      this.parentDom = dom;
      this.isClose = false; // document.querySelectorAll('.ck-calendar-absolute').forEach((item)=>{
      //     item.classList.add('ck-calendar-none');
      // });

      if (this.props.absolute) {
        window.addEventListener('mousedown', this.hide, false); //fixed out window area

        this.fixPosition();
        this.mainDom.classList.remove('ck-calendar-none');
      }

      this.parentDom.addEventListener('blur', this.hide, false);
      this.parentDom.addEventListener('click', this.checkShow, false);
      this.parentDom.addEventListener('keypress', this.keyPressHandler, false);
      this.refreshWidth();
    }
  }, {
    key: "refreshWidth",
    value: function refreshWidth() {
      this.clientWidth = this.mainTable.clientWidth;
    }
  }, {
    key: "fixPosition",
    value: function fixPosition() {
      var _common$hasScrolledPa;

      var scrollParent = (_common$hasScrolledPa = _Common["default"].hasScrolledParent(this.parentDom)) !== null && _common$hasScrolledPa !== void 0 ? _common$hasScrolledPa : document.documentElement;

      var position = _Common["default"].GetDomXY(this.parentDom, null);

      if (position.top + this.parentDom.clientHeight + this.mainDom.offsetHeight > scrollParent.scrollTop + scrollParent.clientHeight) {
        this.mainDom.style.top = -(this.parentDom.offsetHeight + this.mainDom.offsetHeight) + 'px';
        this.mainDom.classList.remove('ck-calendar-up');
        this.mainDom.classList.add('ck-calendar-bottom');

        if (this.props.sm) {
          this.mainDom.classList.remove('ck-calendar-up-sm');
          this.mainDom.classList.add('ck-calendar-bottom-sm');
        }
      } else {
        this.mainDom.style.top = '0';
        this.mainDom.classList.remove('ck-calendar-bottom');
        this.mainDom.classList.add('ck-calendar-up');

        if (this.props.sm) {
          this.mainDom.classList.remove('ck-calendar-bottom-sm');
          this.mainDom.classList.add('ck-calendar-up-sm');
        }
      }
    }
  }, {
    key: "autoComplete",
    value: function autoComplete(val) {
      var reg = /^\d{1,2}(\.|-|\/)\d{1,2}$/g;

      if (reg.test(val)) {
        var arr = val.split(/\.|-|\//);
        var month = parseInt(arr[0]);
        var day = parseInt(arr[1]);

        if (month < 1 || month > 12) {
          return;
        }

        if (day < 1 || day > 31) {
          return;
        }

        var currDate = new Date();
        currDate.setMonth(month - 1);
        currDate.setDate(day);
        this.setCurrentDate(currDate);

        if (typeof this.props.onSelect === 'function') {
          this.props.onSelect(this.format());
        }
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-calendar border p-1'; //display none

      if (this.props.none) {
        base = (0, _bind["default"])(base, 'ck-calendar-none');
      } //shadow


      if (this.props.shadow) {
        base = (0, _bind["default"])(base, 'ck-shadow');
      } //absolute


      if (this.props.absolute) {
        base = (0, _bind["default"])(base, 'ck-calendar-absolute');
      } //triangular


      if (this.props.triangular) {
        var cls = 'ck-calendar-' + this.props.triangular;
        base = (0, _bind["default"])(base, cls);

        if (this.props.sm) {
          base = (0, _bind["default"])(base, cls + '-sm');
        }
      } //small


      if (this.props.sm || this.props.size === 'sm') {
        base = (0, _bind["default"])(base, 'ck-calendar-sm');
      }

      if (this.props.size === 'lg') {
        base = (0, _bind["default"])(base, 'ck-calendar-lg');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "touchScrollHandler",
    //touch scroll event
    value: function touchScrollHandler() {
      if (!this.props.timeBar) return;

      if ('ontouchstart' in document.documentElement) {
        var hdom = document.querySelector('#' + this.domId + '-h');
        hdom === null || hdom === void 0 ? void 0 : hdom.addEventListener('touchstart', this.touchStartHandler);
        hdom === null || hdom === void 0 ? void 0 : hdom.addEventListener('touchmove', this.touchMoveHandler);
        var mdom = document.querySelector('#' + this.domId + '-m');
        mdom === null || mdom === void 0 ? void 0 : mdom.addEventListener('touchstart', this.touchStartHandler);
        mdom === null || mdom === void 0 ? void 0 : mdom.addEventListener('touchmove', this.touchMoveHandler);
        var sdom = document.querySelector('#' + this.domId + '-s');
        sdom === null || sdom === void 0 ? void 0 : sdom.addEventListener('touchstart', this.touchStartHandler);
        sdom === null || sdom === void 0 ? void 0 : sdom.addEventListener('touchmove', this.touchMoveHandler); // this.mainDom.addEventListener('touchstart', this.touchStartHandler);
        // this.mainDom.addEventListener('touchmove', this.touchMoveHandler)
      }
    }
  }, {
    key: "unTouchScrollHandler",
    value: function unTouchScrollHandler() {
      if (!this.props.timeBar) return;

      if ('ontouchstart' in document.documentElement) {
        var hdom = document.querySelector('#' + this.domId + '-h');
        hdom === null || hdom === void 0 ? void 0 : hdom.removeEventListener('touchstart', this.touchStartHandler);
        hdom === null || hdom === void 0 ? void 0 : hdom.removeEventListener('touchmove', this.touchMoveHandler);
        var mdom = document.querySelector('#' + this.domId + '-m');
        mdom === null || mdom === void 0 ? void 0 : mdom.removeEventListener('touchstart', this.touchStartHandler);
        mdom === null || mdom === void 0 ? void 0 : mdom.removeEventListener('touchmove', this.touchMoveHandler);
        var sdom = document.querySelector('#' + this.domId + '-s');
        sdom === null || sdom === void 0 ? void 0 : sdom.removeEventListener('touchstart', this.touchStartHandler);
        sdom === null || sdom === void 0 ? void 0 : sdom.removeEventListener('touchmove', this.touchMoveHandler); // this.mainDom.addEventListener('touchstart', this.touchStartHandler);
        // this.mainDom.addEventListener('touchmove', this.touchMoveHandler)
      }
    }
  }, {
    key: "renderMonth",
    value: function renderMonth() {
      var _this2 = this;

      var divStyle = {
        width: this.clientWidth + 'px'
      };
      var lang = i18n[this.props.lang];
      return _react["default"].createElement("tr", null, _react["default"].createElement("td", {
        colSpan: 7
      }, _react["default"].createElement("div", {
        className: "ck-calendar-list",
        style: divStyle
      }, lang.month.map(function (item, i) {
        var class_name = 'item';

        if (_this2.show_date.getMonth() === i) {
          class_name = 'item active';
        }

        return _react["default"].createElement("span", {
          key: i,
          className: class_name,
          onClick: function onClick() {
            _this2.setMonth(i);
          }
        }, item);
      }))));
    }
  }, {
    key: "renderYear",
    value: function renderYear() {
      var _this3 = this;

      var cur_year = this.show_date.getFullYear();

      while (cur_year % 10 !== 0) {
        cur_year += 1;
      }

      var start_year = cur_year - 11;
      this.year.start = start_year;
      this.year.end = cur_year;
      var year_list = [];

      for (var i = start_year; i < start_year + 12; i++) {
        year_list.push(i);
      }

      var divStyle = {
        width: this.clientWidth + 'px'
      };
      return _react["default"].createElement("tr", null, _react["default"].createElement("td", {
        colSpan: 7
      }, _react["default"].createElement("div", {
        className: "ck-calendar-list",
        style: divStyle
      }, year_list.map(function (item, i) {
        var class_name = 'item';

        if (_this3.show_date.getFullYear() === item) {
          class_name = 'item active';
        }

        return _react["default"].createElement("span", {
          key: i,
          className: class_name,
          onClick: function onClick() {
            _this3.setYear(item, false);
          }
        }, item);
      }))));
    }
  }, {
    key: "renderDays",
    value: function renderDays() {
      var _this4 = this;

      var lang = i18n[this.props.lang];
      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("tr", {
        className: "header"
      }, lang.week.map(function (item, i) {
        return _react["default"].createElement("th", {
          key: i
        }, item);
      })), this.state.days.map(function (row, k) {
        return _react["default"].createElement("tr", {
          key: k
        }, row.map(function (item, i) {
          if (item.disabled) {
            return _react["default"].createElement("td", {
              key: i,
              className: "disable"
            }, item.value);
          }

          var class_name = 'day';

          if (item.value === _this4.current_date.getDate() && _this4.current_date.getFullYear() === _this4.show_date.getFullYear() && _this4.current_date.getMonth() === _this4.show_date.getMonth()) {
            class_name = (0, _bind["default"])(class_name, 'active');
          }

          return _react["default"].createElement("td", {
            key: i,
            className: class_name,
            onClick: function onClick() {
              _this4.choseDay(_this4.show_date.getFullYear(), _this4.show_date.getMonth(), item.value);
            }
          }, item.value);
        }));
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var lang = i18n[this.props.lang];

      var content = _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this5.mainDom = c;
        },
        className: this.getClasses(),
        onMouseDown: function onMouseDown(e) {
          e.stopPropagation();
          e.preventDefault();
        }
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this5.mainTable = c;
        }
      }, _react["default"].createElement("thead", null, _react["default"].createElement("tr", {
        className: "top-header"
      }, _react["default"].createElement("th", {
        className: "th-btn",
        onClick: function onClick() {
          return _this5.privMonth();
        }
      }, _react["default"].createElement(_Icon["default"], {
        icon: "arrow-left"
      })), _react["default"].createElement("th", {
        colSpan: 5
      }, _react["default"].createElement("div", {
        className: "row no-gutters"
      }, _react["default"].createElement("div", {
        className: "col-6 text-center th-btn th-div",
        onClick: function onClick() {
          _this5.setState({
            month: false,
            year: true,
            time: false
          });
        }
      }, this.show_date.getFullYear()), _react["default"].createElement("div", {
        className: "col-6 text-center th-btn th-div",
        onClick: function onClick() {
          _this5.setState({
            month: true,
            year: false,
            time: false
          });
        }
      }, lang['month'][this.show_date.getMonth()]))), _react["default"].createElement("th", {
        className: "th-btn",
        onClick: function onClick() {
          return _this5.nextMonth();
        }
      }, _react["default"].createElement(_Icon["default"], {
        icon: "arrow-right"
      })))), _react["default"].createElement("tbody", null, this.renderContent(), this.isTimeBar() ? this.renderTimeBar() : null)));

      return content;
    }
  }, {
    key: "renderTimeBar",
    value: function renderTimeBar() {
      var lang = i18n[this.props.lang];
      return _react["default"].createElement("tr", null, _react["default"].createElement("td", {
        colSpan: 7
      }, _react["default"].createElement("div", {
        className: "row no-gutters border-top"
      }, _react["default"].createElement("div", {
        className: "col p-1 d-flex align-items-center justify-content-center"
      }, _react["default"].createElement("span", null, this.state.hour, ":", this.state.minute, ":", this.state.second)), _react["default"].createElement("div", {
        className: "col"
      }, _react["default"].createElement(_Button["default"], {
        onClick: this.selectTimeHandler,
        theme: _common.Theme.link,
        size: this.props.sm ? 'sm' : undefined,
        block: true
      }, this.state.time ? lang['time']['confirm'] : lang['time']['time'])))));
    }
  }, {
    key: "renderTime",
    value: function renderTime() {
      var _this6 = this;

      var lang = i18n[this.props.lang];
      return _react["default"].createElement("tr", null, _react["default"].createElement("td", {
        colSpan: 7
      }, _react["default"].createElement("div", {
        className: "row no-gutters bd-highlight"
      }, _react["default"].createElement("div", {
        className: "col bd-highlight"
      }, lang['time']['hour']), _react["default"].createElement("div", {
        className: "col bd-highlight"
      }, lang['time']['min']), _react["default"].createElement("div", {
        className: "col bd-highlight"
      }, lang['time']['sec'])), _react["default"].createElement("div", {
        className: "row no-gutters bd-highlight",
        style: {
          'height': '150px'
        }
      }, _react["default"].createElement("div", {
        className: "col h-100 bd-highlight border position-relative"
      }, _react["default"].createElement("div", {
        id: this.domId + '-h',
        className: "h-100"
      }, this.hours.map(function (item, i) {
        if (item === _this6.state.hour) {
          return _react["default"].createElement("div", {
            key: i,
            className: "ck-calendar-time-item active"
          }, item);
        }

        return _react["default"].createElement("div", {
          key: i,
          className: "ck-calendar-time-item",
          onClick: function onClick() {
            _this6.setState({
              hour: item
            }, function () {
              _this6.show_date.setHours(parseInt(item));
            });
          }
        }, item);
      })), _react["default"].createElement(_Scroll["default"], {
        selector: '#' + this.domId + '-h'
      })), _react["default"].createElement("div", {
        className: "col h-100 bd-highlight border position-relative"
      }, _react["default"].createElement("div", {
        id: this.domId + '-m',
        className: "h-100"
      }, this.minute.map(function (item, i) {
        if (item === _this6.state.minute) {
          return _react["default"].createElement("div", {
            key: i,
            className: "ck-calendar-time-item active"
          }, item);
        }

        return _react["default"].createElement("div", {
          key: i,
          className: "ck-calendar-time-item",
          onClick: function onClick() {
            _this6.setState({
              minute: item
            }, function () {
              _this6.show_date.setMinutes(parseInt(item));
            });
          }
        }, item);
      })), _react["default"].createElement(_Scroll["default"], {
        selector: '#' + this.domId + '-m'
      })), _react["default"].createElement("div", {
        className: "col h-100 bd-highlight border position-relative"
      }, _react["default"].createElement("div", {
        id: this.domId + '-s',
        className: "h-100"
      }, this.sec.map(function (item, i) {
        if (item === _this6.state.second) {
          return _react["default"].createElement("div", {
            key: i,
            className: "ck-calendar-time-item active"
          }, item);
        }

        return _react["default"].createElement("div", {
          key: i,
          className: "ck-calendar-time-item",
          onClick: function onClick() {
            _this6.setState({
              second: item
            }, function () {
              _this6.show_date.setSeconds(parseInt(item));
            });
          }
        }, item);
      })), _react["default"].createElement(_Scroll["default"], {
        selector: '#' + this.domId + '-s'
      })))));
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      if (this.state.month) {
        return this.renderMonth();
      } else if (this.state.year) {
        return this.renderYear();
      } else if (this.state.time) {
        return this.renderTime();
      } else {
        return this.renderDays();
      }
    }
  }]);

  return Calendar;
}(_react["default"].PureComponent);

exports.Calendar = Calendar;

_defineProperty(Calendar, "defaultProps", {
  lang: 'zh',
  format: 'YYYY-MM-DD' //unix,

});

var sortMonth = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sept', 'Oct', 'Nov', 'Dec'];

function _format(formatStr, date) {
  var keys = [{
    key: "unix",
    value: Math.round(date.valueOf() / 1000)
  }, {
    key: "YYYY",
    value: date.getFullYear().toString()
  }, {
    key: "MMM",
    value: sortMonth[date.getMonth()]
  }, {
    key: "MM",
    value: _Common["default"].strpad((date.getMonth() + 1).toString(), 2, "0")
  }, // {key:"M",value: (date.getMonth() + 1).toString()},
  {
    key: "DD",
    value: _Common["default"].strpad(date.getDate().toString(), 2, "0")
  }, // {key:"D",value: common.strpad(date.getDate().toString(), 2, "0")},
  {
    key: "yy",
    value: date.getFullYear().toString().substring(2)
  }, {
    key: "dd",
    value: date.getDate().toString()
  }, {
    key: "HH",
    value: _Common["default"].strpad(date.getHours().toString(), 2, "0")
  }, // "HH": this.state.hour,
  {
    key: "h",
    value: date.getHours().toString()
  }, // "h": this.state.hour,
  {
    key: "II",
    value: _Common["default"].strpad(date.getMinutes().toString(), 2, "0")
  }, {
    key: "mm",
    value: _Common["default"].strpad(date.getMinutes().toString(), 2, "0")
  }, // "II": this.state.minute,
  {
    key: "i",
    value: date.getMinutes().toString()
  }, // "i": this.state.minute,
  {
    key: "SS",
    value: _Common["default"].strpad(date.getSeconds().toString(), 2, "0")
  }, {
    key: "ss",
    value: _Common["default"].strpad(date.getSeconds().toString(), 2, "0")
  }, // "SS": this.state.second,
  {
    key: "s",
    value: date.getSeconds().toString()
  }];
  var time_str = formatStr;
  var regx;
  keys.forEach(function (item) {
    regx = new RegExp(item.key, "g");
    time_str = time_str.replace(regx, item.value);
    regx = null;
  });
  return time_str;
}

var _default = Calendar;
exports["default"] = _default;
//# sourceMappingURL=Calendar.js.map
