/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CalendarRange = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/Input.less");

require("./css/CalendarRange.less");

var _Common = _interopRequireDefault(require("./Common"));

var _index = require("./index");

var _Button = _interopRequireDefault(require("./Button"));

var _common = require("./components/common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var stopEvent = function stopEvent(e) {
  e.stopPropagation();
};

var CalendarRange =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(CalendarRange, _React$PureComponent);

  function CalendarRange(props) {
    var _this$props$data, _this$props$minData, _this$props$maxData, _this$props$disabled;

    var _this;

    _classCallCheck(this, CalendarRange);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CalendarRange).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "isFocus", void 0);

    _defineProperty(_assertThisInitialized(_this), "inputDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "inputMin", void 0);

    _defineProperty(_assertThisInitialized(_this), "inputMax", void 0);

    _defineProperty(_assertThisInitialized(_this), "calendar_panel", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "maxCalendar", void 0);

    _defineProperty(_assertThisInitialized(_this), "minCalendar", void 0);

    _defineProperty(_assertThisInitialized(_this), "show", function () {
      _this.calendar_panel.classList.remove('d-none');

      _this.calendar_panel.style.top = _this.mainDom.offsetHeight + 'px';

      _this.minCalendar.refreshWidth();

      _this.maxCalendar.refreshWidth();
    });

    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      _this.calendar_panel.classList.add('d-none');
    });

    _defineProperty(_assertThisInitialized(_this), "changeHandler", function () {
      if (typeof _this.props.onChange === 'function') {
        _this.props.onChange(_this.state.min, _this.state.max);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "clearHandler", function () {
      _this.setState({
        min: '',
        max: ''
      }, function () {
        _this.changeHandler();
      });
    });

    _this.state = {
      value: (_this$props$data = _this.props.data) !== null && _this$props$data !== void 0 ? _this$props$data : '',
      min: (_this$props$minData = _this.props.minData) !== null && _this$props$minData !== void 0 ? _this$props$minData : '',
      max: (_this$props$maxData = _this.props.maxData) !== null && _this$props$maxData !== void 0 ? _this$props$maxData : '',
      validate: true,
      disabled: (_this$props$disabled = _this.props.disabled) !== null && _this$props$disabled !== void 0 ? _this$props$disabled : false,
      icon: 'calendar-alt'
    };
    _this.domId = 'calendar-range-' + _Common["default"].RandomString(16);

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    _this.isFocus = false;
    return _this;
  }

  _createClass(CalendarRange, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.inputDom.addEventListener('focus', this.show);
      this.inputMin.addEventListener('focus', this.show);
      this.inputMax.addEventListener('focus', this.show);
      this.calendar_panel.addEventListener('mousedown', stopEvent);
      this.inputDom.addEventListener('mousedown', stopEvent);
      this.inputMin.addEventListener('mousedown', stopEvent);
      this.inputMax.addEventListener('mousedown', stopEvent);
      window.addEventListener('mousedown', this.hide, false);
      this.maxCalendar.setFailRange(new Date(this.state.min), this.props.days);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.inputDom.removeEventListener('focus', this.show);
      this.inputMin.removeEventListener('focus', this.show);
      this.inputMax.removeEventListener('focus', this.show);
      this.calendar_panel.removeEventListener('focus', stopEvent);
      this.inputDom.removeEventListener('mousedown', stopEvent);
      this.inputMin.removeEventListener('mousedown', stopEvent);
      this.inputMax.removeEventListener('mousedown', stopEvent);
      window.removeEventListener('mousedown', this.hide, false);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.state.min !== nextProps.minData || this.state.max !== nextProps.maxData) {
        this.setState({
          min: nextProps.minData,
          max: nextProps.maxData
        });
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'form-group ck-calendar-range';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getMainStyles",
    value: function getMainStyles() {
      //default style
      var base = {
        "position": "relative"
      };

      if (this.props.width) {
        base.width = this.props.width;
      }

      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.absolute) {
        base.position = 'absolute';
      }

      if (this.props.x) {
        base.left = this.props.x;
      }

      if (this.props.y) {
        base.top = this.props.y;
      }

      if (!this.props.label) {
        base.marginBottom = '0';
      }

      return _Common["default"].extend(base, this.props.style);
    }
  }, {
    key: "getInputClasses",
    value: function getInputClasses(append) {
      var base = 'form-control d-flex flex-row'; //size

      var size;

      switch (this.props.size) {
        case 'lg':
          size = 'form-control-lg';
          break;

        case 'sm':
          size = 'form-control-sm';
          break;

        case 'xs':
          size = 'form-control-xs';
          break;

        default:
          size = '';
      }

      base = (0, _bind["default"])(base, size);

      if (!this.state.validate) {
        base = (0, _bind["default"])(base, 'ck-input-valid');
      }

      if (this.props.readOnly) {
        base = (0, _bind["default"])(base, 'ck-input-select');
      }

      return (0, _bind["default"])(base, this.props.textClass, append);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this,
          _this$props$placehold,
          _this$props$placehold2;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          _this2.mainDom = c;
        },
        id: this.domId,
        className: this.getClasses(),
        style: this.getMainStyles()
      }, this.renderLabel(), _react["default"].createElement("div", {
        ref: function ref(c) {
          _this2.inputDom = c;
        },
        className: this.getInputClasses(''),
        tabIndex: 1
      }, _react["default"].createElement("input", {
        ref: function ref(c) {
          return _this2.inputMin = c;
        },
        disabled: true,
        value: this.state.min,
        className: "c-input w-50 text-center",
        placeholder: (_this$props$placehold = this.props.placeholderMin) !== null && _this$props$placehold !== void 0 ? _this$props$placehold : this.props.format
      }), _react["default"].createElement("span", null, " - "), _react["default"].createElement("input", {
        ref: function ref(c) {
          return _this2.inputMax = c;
        },
        disabled: true,
        value: this.state.max,
        className: "c-input w-50 text-center",
        placeholder: (_this$props$placehold2 = this.props.placeholderMax) !== null && _this$props$placehold2 !== void 0 ? _this$props$placehold2 : this.props.format
      })), this.renderCalendar());
    }
  }, {
    key: "renderLabel",
    value: function renderLabel() {
      if (this.props.label === '') {
        return null;
      }

      return _react["default"].createElement("label", {
        htmlFor: this.domId,
        className: 'form-label ' + this.props.labelClass
      }, this.props.label);
    }
  }, {
    key: "renderCalendar",
    value: function renderCalendar() {
      var _this3 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this3.calendar_panel = c;
        },
        className: "c-panel d-flex p-1 shadow rounded d-none"
      }, _react["default"].createElement(_index.Calendar, {
        ref: function ref(c) {
          return _this3.minCalendar = c;
        },
        limit: this.props.limit,
        target: this.inputMin,
        value: this.state.min,
        onSelect: function onSelect(val) {
          var max = _this3.state.max;

          var flag = _this3.maxCalendar.setFailRange(new Date(val), _this3.props.days);

          if (!flag) {
            max = '';
          }

          _this3.setState({
            min: val,
            max: max
          }, function () {
            _this3.changeHandler();
          });
        }
      }), _react["default"].createElement(_index.Calendar, {
        ref: function ref(c) {
          return _this3.maxCalendar = c;
        },
        target: this.inputMax,
        value: this.state.max,
        onSelect: function onSelect(val) {
          _this3.setState({
            max: val
          }, function () {
            _this3.changeHandler();
          });
        }
      }), _react["default"].createElement("div", {
        className: "d-flex flex-column"
      }, _react["default"].createElement(_Button["default"], {
        className: "ms-1 mt-1",
        size: "sm",
        theme: _common.Theme.danger,
        icon: "trash-alt",
        tip: "\u6E05\u9664\u9009\u62E9",
        onClick: this.clearHandler
      }), _react["default"].createElement(_Button["default"], {
        className: "ms-1 mt-auto",
        size: "sm",
        theme: _common.Theme.secondary,
        icon: "times-circle",
        tip: "\u5173\u95ED",
        onClick: this.hide
      })));
    }
  }]);

  return CalendarRange;
}(_react["default"].PureComponent);

exports.CalendarRange = CalendarRange;

_defineProperty(CalendarRange, "defaultProps", {
  id: '',
  size: 'df',
  label: '',
  minData: '',
  maxData: '',
  days: 30,
  summary: '',
  readOnly: false,
  disabled: false,
  disableClear: false,
  format: 'YYYY-MM-DD'
});

var _default = CalendarRange;
exports["default"] = _default;
//# sourceMappingURL=CalendarRange.js.map
