/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Card = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Title = _interopRequireDefault(require("./Title"));

require("./css/Card.less");

var _Scroll = _interopRequireDefault(require("./Scroll"));

var _Common = _interopRequireDefault(require("./Common"));

var _HScroll = _interopRequireDefault(require("./HScroll"));

var _common = require("./components/common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Card =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Card, _React$PureComponent);

  function Card(props) {
    var _this;

    _classCallCheck(this, Card);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Card).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _this.domId = 'card-' + _Common["default"].RandomString(16);

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    return _this;
  }

  _createClass(Card, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'card ck-card';

      if (this.props.border) {
        base = (0, _bind["default"])(base, "border border-".concat(this.props.border));
      }

      if (this.props.divider) {
        base = (0, _bind["default"])(base, 'ck-card-divider');
      } //apply style


      if (this.props.theme !== undefined) {
        var _this$props$theme;

        var themeStr = typeof this.props.theme === 'string' ? this.props.theme : _common.Theme[(_this$props$theme = this.props.theme) !== null && _this$props$theme !== void 0 ? _this$props$theme : 0];
        base = (0, _bind["default"])(base, 'bg-' + themeStr);
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getBodyClasses",
    value: function getBodyClasses() {
      return (0, _bind["default"])('card-body', this.props.bodyClass);
    }
  }, {
    key: "getStyle",
    value: function getStyle() {
      var def = {};

      if (this.props.absolute) {
        var _this$props$x, _this$props$y;

        def.left = (_this$props$x = this.props.x) !== null && _this$props$x !== void 0 ? _this$props$x : '';
        def.top = (_this$props$y = this.props.y) !== null && _this$props$y !== void 0 ? _this$props$y : '';
        def.position = 'absolute';
      }

      if (this.props.width) {
        def.width = this.props.width;
      }

      if (this.props.height) {
        def.height = this.props.height;
      }

      return def;
    }
  }, {
    key: "renderHeader",
    value: function renderHeader() {
      if (!this.props.header) {
        return null;
      }

      if (this.props.custom) {
        return _react["default"].createElement(_Title["default"], {
          text: this.props.header
        });
      }

      var base = 'card-header';

      if (this.props.sm) {
        base = (0, _bind["default"])(base, 'ck-card-sm');
      }

      base = (0, _bind["default"])(base, this.props.headClass);
      return _react["default"].createElement("div", {
        className: base
      }, this.props.header);
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: this.getClasses(),
        style: this.getStyle()
      }, this.renderHeader(), _react["default"].createElement("div", {
        id: this.domId,
        className: this.getBodyClasses()
      }, this.props.children), this.props.scroll ? _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_Scroll["default"], {
        selector: "#".concat(this.domId)
      }), _react["default"].createElement(_HScroll["default"], {
        selector: "#".concat(this.domId)
      })) : null);
    }
  }]);

  return Card;
}(_react["default"].PureComponent);

exports.Card = Card;

_defineProperty(Card, "defaultProps", {
  border: 'transparent',
  scroll: false,
  sm: false,
  absolute: false,
  divider: true
});

var _default = Card;
exports["default"] = _default;
//# sourceMappingURL=Card.js.map
