/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Combo = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Table = _interopRequireDefault(require("./Table"));

var _TableHeader = _interopRequireDefault(require("./TableHeader"));

var _Common = _interopRequireWildcard(require("./Common"));

require("./css/Combo.less");

var _Load = _interopRequireDefault(require("./Load"));

var _common = require("./components/common");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Combo =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Combo, _React$Component);

  function Combo(props) {
    var _this$props$empty, _this$props$search;

    var _this;

    _classCallCheck(this, Combo);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Combo).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "isRemote", void 0);

    _defineProperty(_assertThisInitialized(_this), "parentDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "search", void 0);

    _defineProperty(_assertThisInitialized(_this), "isClose", void 0);

    _defineProperty(_assertThisInitialized(_this), "table", void 0);

    _defineProperty(_assertThisInitialized(_this), "nodeList", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "conDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "currentSelect", void 0);

    _defineProperty(_assertThisInitialized(_this), "filterTime", void 0);

    _defineProperty(_assertThisInitialized(_this), "isMobile", void 0);

    _defineProperty(_assertThisInitialized(_this), "checkShow", function () {
      if (_this.isClose) {
        _this.show(_this.search, _this.parentDom);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "keyDownHandler", function (e) {
      if (_this.isClose) {
        _this.show(_this.search, _this.parentDom);
      }

      switch (e.key) {
        case 'ArrowUp':
          //key up
          e.preventDefault();
          e.stopPropagation();

          _this.moveItem(-1);

          break;

        case 'ArrowDown':
          //key down
          e.preventDefault();
          e.stopPropagation();

          _this.moveItem(1);

          break;

        case ' ':
          //key space
          if (_this.props.noSearch) {
            _this.selectItem();
          }

          break;

        case 'Enter':
          //key enter
          _this.selectItem();

          break;

        case 'Escape':
          //key esc
          _this.hide();

          break;

        case 'Tab':
          //key tab
          _this.selectItem();

          break;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      window.removeEventListener('mousedown', _this.hide, false);

      _this.mainDom.classList.add("ck-none");

      if (_this.conDom) {
        _this.conDom.style.overflowY = 'none';
        _this.conDom.style.height = '100%';
      }

      if (typeof _this.props.onClose === 'function') {
        _this.props.onClose();
      }

      if (_this.isRemote) {
        _this.setState({
          loading: true
        });
      }

      _this.clearSelect();

      _this.isClose = true;
    });

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (row, i) {
      var _this$props$searchCol;

      if (_this.props.multi && _this.nodeList) {
        var _node$firstChild;

        var node = _this.nodeList[parseInt(i)];

        (node === null || node === void 0 ? void 0 : (_node$firstChild = node.firstChild) === null || _node$firstChild === void 0 ? void 0 : _node$firstChild.firstChild).click();
        return;
      }

      var searchColumn = (_this$props$searchCol = _this.props.searchColumn) !== null && _this$props$searchCol !== void 0 ? _this$props$searchCol : '';

      if (typeof _this.props.onSelect === 'function') {
        _this.props.onSelect(row[searchColumn], row);
      }

      _this.search = row[searchColumn];

      _this.hide();
    });

    _defineProperty(_assertThisInitialized(_this), "multiSelectHandler", function () {
      if (typeof _this.props.onSelect === 'function') {
        var _this$props$searchCol2;

        var valList = [];
        var searchColumn = (_this$props$searchCol2 = _this.props.searchColumn) !== null && _this$props$searchCol2 !== void 0 ? _this$props$searchCol2 : '';

        _this.table.getSelectRows().forEach(function (item) {
          valList.push(item[searchColumn]);
        });

        _this.props.onSelect(valList.join(','), _this.table.getSelectRows());
      }
    });

    _defineProperty(_assertThisInitialized(_this), "filterFormat", function (val) {
      var _this$search;

      var con = (val !== null && val !== void 0 ? val : '').toString();
      _this.search = ((_this$search = _this.search) !== null && _this$search !== void 0 ? _this$search : '').toString();
      var idx = con.toLowerCase().indexOf(_this.search.toLowerCase());

      if (idx === -1) {
        return val;
      }

      var first = con.substring(0, idx);
      var center = con.substr(idx, _this.search.length);
      var end = con.substr(idx + _this.search.length);
      return _react["default"].createElement(_react["default"].Fragment, null, first, _react["default"].createElement("span", {
        className: "text-danger"
      }, center), end);
    });

    _this.isRemote = !!_this.props.onSearch;
    _this.state = {
      data: _this.props.data,
      loading: _this.isRemote,
      emptyText: (_this$props$empty = _this.props.empty) !== null && _this$props$empty !== void 0 ? _this$props$empty : 'Not Data'
    };
    _this.search = (_this$props$search = _this.props.search) !== null && _this$props$search !== void 0 ? _this$props$search : '';
    _this.isClose = true;
    _this.isMobile = _Common["default"].Version().mobile;
    return _this;
  }

  _createClass(Combo, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // if (this.props.multiDef) {
      //     common.map(this.props.multiDef,(val,key)=>{
      //         this.table.setSelectRows(key,val);
      //     });
      // }
      if (this.isMobile) {
        this.mainDom.addEventListener("click", this.hide);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('mousedown', this.hide, false);

      if (this.parentDom) {
        this.parentDom.removeEventListener('keydown', this.keyDownHandler, false);
        this.parentDom.removeEventListener('blur', this.hide, false);
        this.parentDom.removeEventListener('click', this.checkShow, false);
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.props.data !== nextProps.data) {
        this.setState({
          data: nextProps.data
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.table) {
        var _mainDom$querySelecto, _this$props$showRows;

        var mainDom = this.table.mainDom;
        var height = (_mainDom$querySelecto = mainDom.querySelector('tbody>tr')) === null || _mainDom$querySelecto === void 0 ? void 0 : _mainDom$querySelecto.clientHeight;
        var fixHeader = 0;

        if (this.props.header) {
          var _mainDom$querySelecto2;

          fixHeader = (_mainDom$querySelecto2 = mainDom.querySelector('thead')) === null || _mainDom$querySelecto2 === void 0 ? void 0 : _mainDom$querySelecto2.clientHeight;
        }

        var showRows = (_this$props$showRows = this.props.showRows) !== null && _this$props$showRows !== void 0 ? _this$props$showRows : 1;

        if (this.state.data.length > showRows) {
          // let mainDom = this.table.mainDom;
          // let height = mainDom.querySelector('tr').clientHeight;
          // this.conDom.style.overflowY = 'auto';
          // this.conDom.style.height = (height*this.props.showRows)+'px';
          this.table.setHeight(height * showRows + fixHeader + 'px');
        } else {
          // this.table.setHeight((height*this.state.data.length+fixHeader)+'px');
          this.table.setHeight('auto');
        }

        if (!this.props.multi) {
          this.clearSelect();
        }

        this.nodeList = mainDom.querySelectorAll('tbody tr');
      }
    }
  }, {
    key: "setSelectRows",
    value: function setSelectRows(key, val) {
      this.table.setSelectRows(key, val);
    }
  }, {
    key: "setSearchText",
    value: function setSearchText(text) {
      this.search = text;
    }
  }, {
    key: "show",
    value: function show(search, dom) {
      this.parentDom = dom;
      this.parentDom.addEventListener('keydown', this.keyDownHandler, false);
      this.parentDom.addEventListener('blur', this.hide, false);
      this.parentDom.addEventListener('click', this.checkShow, false);
      window.addEventListener('mousedown', this.hide, false); // document.querySelectorAll('.ck-combo').forEach((item)=>{
      //     item.classList.add('d-none');
      // });

      this.mainDom.classList.remove("ck-none");
      this.filter(search !== null && search !== void 0 ? search : '');

      if (typeof this.props.onShow === 'function') {
        this.props.onShow();
      }

      this.isClose = false;
    }
  }, {
    key: "clearSelect",
    value: function clearSelect() {
      if (!this.currentSelect) {
        return;
      } // let nodeList =? document.querySelectorAll(`${this.table.domId} tbody tr`);


      if (this.nodeList && this.nodeList[this.currentSelect]) {
        var node = this.nodeList[this.currentSelect];
        node.classList.remove('ck-combo-selected');
      }

      this.currentSelect = undefined;
      this.nodeList = undefined;
    }
  }, {
    key: "moveItem",
    value: function moveItem() {
      var step = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      console.log(this.nodeList);

      if (!this.nodeList) {
        return;
      }

      if (!this.currentSelect) {
        this.currentSelect = 0;
      } else {
        if (this.nodeList[this.currentSelect]) {
          this.nodeList[this.currentSelect].classList.remove('ck-combo-selected');
        }

        this.currentSelect += step;

        if (this.currentSelect < 0) {
          this.currentSelect = 0;
        }

        if (this.currentSelect >= this.nodeList.length) {
          this.currentSelect = this.nodeList.length - 1;
        }
      }

      if (this.nodeList[this.currentSelect]) {
        //this.conDom
        var scrollDom = this.table.mainDom;
        var fixHeight = 0;

        if (this.props.header) {
          var _this$table$mainDom, _this$table$mainDom$q;

          fixHeight = (_this$table$mainDom = this.table.mainDom) === null || _this$table$mainDom === void 0 ? void 0 : (_this$table$mainDom$q = _this$table$mainDom.querySelector('thead')) === null || _this$table$mainDom$q === void 0 ? void 0 : _this$table$mainDom$q.clientHeight;
        }

        var node = this.nodeList[this.currentSelect];
        node.classList.add('ck-combo-selected'); // console.log(this.conDom.scrollHeight,this.conDom.scrollTop,this.conDom.clientHeight);

        if (scrollDom.scrollHeight === scrollDom.clientHeight) {
          return;
        }

        var nodePos = _Common["default"].GetDomXY(node, scrollDom);

        var start = nodePos.top - fixHeight;
        var end = start + node.clientHeight;
        var posStart = scrollDom.scrollTop;
        var posEnd = scrollDom.scrollTop + scrollDom.clientHeight - fixHeight;

        if (start > posStart && end < posEnd) {
          return;
        }

        if (start < posStart) {
          // this.conDom.scrollTo(0,start);
          scrollDom.scrollTo(0, start);
        }

        if (end > posEnd) {
          // this.conDom.scrollTo(0,end-this.conDom.clientHeight);
          scrollDom.scrollTo(0, end - (scrollDom.clientHeight - fixHeight));
        }
      }
    }
  }, {
    key: "selectItem",
    value: function selectItem() {
      if (this.nodeList && this.currentSelect && this.nodeList[this.currentSelect]) {
        this.nodeList[this.currentSelect].click();
      }
    }
  }, {
    key: "fixPosition",
    value: function fixPosition() {
      var _common$hasScrolledPa;

      if (this.isMobile) {
        return;
      }

      var scrollParent = (_common$hasScrolledPa = _Common["default"].hasScrolledParent(this.parentDom)) !== null && _common$hasScrolledPa !== void 0 ? _common$hasScrolledPa : document.documentElement;

      var position = _Common["default"].GetDomXY(this.parentDom, null);

      if (position.top + this.parentDom.clientHeight + this.mainDom.offsetHeight > scrollParent.scrollTop + scrollParent.clientHeight) {
        this.mainDom.style.top = -(this.parentDom.offsetHeight + this.mainDom.offsetHeight) + 'px';
        this.mainDom.classList.remove('ck-combo-up');
        this.mainDom.classList.add('ck-combo-bottom');

        if (this.props.sm) {
          this.mainDom.classList.remove('ck-combo-up-sm');
          this.mainDom.classList.add('ck-combo-bottom-sm');
        }
      } else {
        this.mainDom.style.top = '0';
        this.mainDom.classList.remove('ck-combo-bottom');
        this.mainDom.classList.add('ck-combo-up');

        if (this.props.sm) {
          this.mainDom.classList.remove('ck-combo-bottom-sm');
          this.mainDom.classList.add('ck-combo-up-sm');
        }
      }
    }
  }, {
    key: "clearMulti",
    value: function clearMulti() {
      this.table.selectAll(false);
    }
  }, {
    key: "filter",
    value: function filter(search) {
      var _this2 = this;

      this.search = search;

      if (typeof this.props.onSearch === 'function') {
        clearTimeout(this.filterTime);
        this.filterTime = setTimeout(function () {
          _this2.setState({
            loading: true
          }, function () {
            if (_this2.props.onSearch) {
              _this2.props.onSearch(search, function (data) {
                _this2.setState({
                  loading: false,
                  data: data
                });
              });
            }
          });
        }, 300);
        return;
      }

      var data = [];

      if (this.props.noSearch) {
        data = this.props.data;
      } else if (this.props.data) {
        //replace regex key word
        var searchStr = search.replace(/\\/g, "\\\\");
        searchStr = searchStr.replace(/\[/g, '\\[');
        searchStr = searchStr.replace(/\(/g, '\\(');
        searchStr = searchStr.replace(/\)/g, '\\)');
        var reg;

        if (this.props.searchType === 'include') {
          reg = new RegExp(searchStr, 'i');
        } else {
          reg = new RegExp("^" + searchStr, 'i');
        }

        this.props.data.forEach(function (item) {
          var _this2$props$searchCo;

          var searchColumn = (_this2$props$searchCo = _this2.props.searchColumn) !== null && _this2$props$searchCo !== void 0 ? _this2$props$searchCo : '';

          if (reg.test(item[searchColumn])) {
            data.push(item);
          }
        });
      }

      this.setState({
        data: data.length === 0 ? null : data
      }, function () {
        //fixed out window area
        _this2.fixPosition();
      });
    }
  }, {
    key: "filterColumns",
    value: function filterColumns() {
      if (this.props.filterColumns) {
        return this.props.filterColumns.map(function (item) {
          var is_obj = _typeof(item) === 'object';
          return {
            field: is_obj ? item.field : item,
            width: is_obj ? item.width : null,
            text: is_obj ? item.text : item.field,
            format: is_obj ? item.format : null
          };
        });
      } else {
        var _row = this.state.data[0];
        return (0, _Common.map)(_row, function (item, key) {
          return {
            field: key,
            width: null,
            text: key,
            format: null
          };
        });
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-combo border ck-none shadow';

      if (this.props.triangular) {
        base = (0, _bind["default"])(base, 'ck-calendar-' + this.props.triangular);
      }

      if (this.props.sm) {
        base = (0, _bind["default"])(base, 'ck-combo-sm', 'ck-combo-up ck-combo-up-sm');
      } else {
        base = (0, _bind["default"])(base, 'ck-combo-up');
      } //mobile show


      if (this.isMobile) {
        base = (0, _bind["default"])(base, 'ck-combo-mobile');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      var base = {};

      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.width && !this.state.loading && this.state.data) {
        base.width = this.props.width;
      } else {
        base.width = 'auto';
      }

      return base;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this3.mainDom = c;
        },
        className: this.getClasses(),
        style: this.getStyles(),
        onMouseDown: function onMouseDown(e) {
          e.stopPropagation();
          e.preventDefault();
        }
      }, this.state.loading ? this.renderLoading() : this.state.data ? this.renderList() : this.renderNotResult());
    }
  }, {
    key: "renderLoading",
    value: function renderLoading() {
      return _react["default"].createElement("div", {
        className: "ck-combo-nofound"
      }, _react["default"].createElement(_Load["default"], null));
    }
  }, {
    key: "renderNotResult",
    value: function renderNotResult() {
      return _react["default"].createElement("div", {
        className: "ck-combo-nofound"
      }, this.state.emptyText);
    }
  }, {
    key: "renderList",
    value: function renderList() {
      var _this4 = this;

      var columns = this.filterColumns();
      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this4.conDom = c;
        },
        className: "ck-combo-content"
      }, _react["default"].createElement(_Table["default"], {
        ref: function ref(c) {
          return _this4.table = c;
        },
        height: "100px",
        select: this.props.multi,
        header: this.props.header,
        headerTheme: _common.Theme.light,
        truncate: true,
        striped: false,
        sm: this.props.sm,
        serialNumber: false,
        data: this.state.data,
        fixed: !!this.props.width,
        onCheck: this.props.multi ? this.multiSelectHandler : undefined,
        onClick: this.selectHandler
      }, (0, _Common.map)(columns, function (item, idx) {
        return _react["default"].createElement(_TableHeader["default"], {
          key: idx,
          field: item.field,
          width: item.width,
          text: item.text,
          onFormat: item.field === _this4.props.searchColumn ? _this4.filterFormat : item.format
        });
      })));
    }
  }]);

  return Combo;
}(_react["default"].Component);

exports.Combo = Combo;

_defineProperty(Combo, "defaultProps", {
  showRows: 8,
  data: [],
  search: "",
  multi: false,
  multiDef: null,
  header: false,
  searchType: 'start'
});

var _default = Combo;
exports["default"] = _default;
//# sourceMappingURL=Combo.js.map
