/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasScrolledParent = hasScrolledParent;
exports.Version = Version;
exports["default"] = exports.Runtime = exports.Clone = exports.explainUrl = exports.under2hump = exports.ucFirst = exports.strpad = exports.map = exports.GetDPI = exports.GetDomXY = exports.LoadScript = exports.RandNum = exports.RandomString = exports.extend = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var extend = function extend(org, exd) {
  if (_typeof(exd) === "object") {
    for (var key in exd) {
      org[key] = exd[key];
    }
  }

  return org;
};

exports.extend = extend;

var RandomString = function RandomString(str_length) {
  var tab = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
  var num,
      out_str = "";

  for (var i = 0; i < str_length; i++) {
    num = Math.round(Math.random() * tab.length);
    out_str += tab.substring(num, num + 1);
  }

  return out_str;
};

exports.RandomString = RandomString;

var RandNum = function RandNum(start, end) {
  var choice = end - start + 1;
  return Math.floor(Math.random() * choice + start);
};

exports.RandNum = RandNum;
var LoadScript = {
  _loaded: {},
  load: function load(srcStr, strID, func, version) {
    if (this._loaded[strID]) {
      if (func && typeof func === "function") func();
      return;
    }

    var element;
    var ext = srcStr.split('?')[0].substr(srcStr.lastIndexOf('.') + 1);

    if (ext === 'css') {
      element = document.createElement("LINK");

      if (typeof version === "string") {
        element.href = srcStr + "?" + version;
      } else if (typeof version === "boolean") {
        element.href = srcStr + "?" + RandomString(5);
      } else {
        element.href = srcStr;
      }

      element.rel = 'stylesheet';
      element.id = strID;
      element.type = 'text/css';
    } else if (ext === 'js') {
      element = document.createElement("SCRIPT");

      if (typeof version === "string") {
        element.src = srcStr + "?" + version;
      } else if (typeof version === "boolean") {
        element.src = srcStr + "?" + RandomString(5);
      } else {
        element.src = srcStr;
      }

      element.type = 'text/javascript';
      element.id = strID;
    } else {
      return;
    }

    this._loaded[strID] = false;
    var loaded = this._loaded;

    element.onload = function () {
      this.onload = null;
      loaded[strID] = true;
      if (func && typeof func === "function") func();
    };

    element.onerror = function () {
      alert("Load Library Error!");
    };

    document.getElementsByTagName("head")[0].appendChild(element);
  }
};
exports.LoadScript = LoadScript;

var GetDomXY = function GetDomXY(e) {
  var parent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var t = {
    top: e.offsetTop,
    left: e.offsetLeft,
    height: e.clientHeight,
    width: e.clientWidth
  };
  var scrollTop = 0;
  var scrollLeft = 0;
  var topScroll = 0;
  var leftScroll = 0;

  while ((e = e.offsetParent) && e !== parent) {
    t['top'] += e.offsetTop;
    t['left'] += e.offsetLeft;
    topScroll = e.scrollTop;
    scrollTop += topScroll;
    leftScroll = e.scrollLeft;
    scrollLeft += leftScroll;
  }

  t['top'] = t['top'] - (scrollTop - topScroll);
  t['left'] = t['left'] - (scrollLeft - leftScroll);
  return t;
};

exports.GetDomXY = GetDomXY;

var GetDPI = function GetDPI() {
  var _tmpNode$parentNode;

  var arrDPI = [];
  var tmpNode = document.createElement("DIV");
  tmpNode.style.cssText = "width:1in;height:1in;position:absolute;left:0px;top:0px;z-index:99;visibility:hidden";
  document.body.appendChild(tmpNode);
  arrDPI[0] = tmpNode.offsetWidth;
  arrDPI[1] = tmpNode.offsetHeight;
  (_tmpNode$parentNode = tmpNode.parentNode) === null || _tmpNode$parentNode === void 0 ? void 0 : _tmpNode$parentNode.removeChild(tmpNode);
  return arrDPI;
};
/**
 * Map object
 * @param obj
 * @param func
 * @returns {Array}
 */


exports.GetDPI = GetDPI;

var map = function map(obj, func) {
  if (_typeof(obj) !== 'object') {
    return [];
  }

  if (typeof func !== 'function') {
    return [];
  }

  var list = [];
  var idx = 0;

  for (var k in obj) {
    list.push(func(obj[k], k, idx));
    idx++;
  }

  return list;
};

exports.map = map;

var strpad = function strpad(text, length, padstring) {
  var type = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "left";
  text += '';
  padstring += '';
  var padtext = null;

  if (text.length < length) {
    padtext = padstring;

    while (padtext.length < length - text.length) {
      padtext += padstring;
    }

    if (type === "left") {
      text = padtext.substring(0, length - text.length) + text;
    } else if (type === "right") {
      text = text + padtext.substring(0, length - text.length);
    }
  }

  padtext = null;
  return text;
};

exports.strpad = strpad;

var ucFirst = function ucFirst(str) {
  if (str.length <= 0) return "";
  return str[0].toUpperCase() + str.substring(1);
};

exports.ucFirst = ucFirst;

var under2hump = function under2hump(str) {
  var arr = str.split('_');
  var hump = arr.map(function (item) {
    return ucFirst(item);
  });
  return hump.join('');
};

exports.under2hump = under2hump;

var explainUrl = function explainUrl(path) {
  var _arr$pop;

  var arr = path.split('/');
  arr.shift();
  var module = (_arr$pop = arr.pop()) !== null && _arr$pop !== void 0 ? _arr$pop : '';
  module = under2hump(module);
  var ext_path = arr.length > 0 ? '/' : '';
  return ext_path + arr.join('/') + "/" + module;
};

exports.explainUrl = explainUrl;

var Clone = function Clone(obj) {
  return JSON.parse(JSON.stringify(obj));
};

exports.Clone = Clone;

function hasScrolledParent(el) {
  var direction = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "vertical";

  while ((el = el.offsetParent) && el !== undefined) {
    if (direction === "vertical") {
      var style = window.getComputedStyle(el);
      var isScroll = style.overflowY === 'scroll' || style.overflowY === 'auto';
      if (el.scrollHeight > el.clientHeight && isScroll) return el;
    } else if (direction === "horizontal") {
      if (el.scrollWidth > el.clientWidth) return el;
    }
  }
}

var Runtime =
/*#__PURE__*/
function () {
  function Runtime() {
    _classCallCheck(this, Runtime);

    _defineProperty(this, "start", void 0);

    this.start = new Date();
  }

  _createClass(Runtime, [{
    key: "begin",
    value: function begin() {
      this.start = new Date();
    }
  }, {
    key: "end",
    value: function end() {
      var print = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var cur_date = new Date();
      var diff = cur_date.getTime() - this.start.getTime();
      var res = Math.floor(diff / 1000);

      if (print) {
        console.log(res);
      }

      return res;
    }
  }], [{
    key: "Start",
    value: function Start() {
      return new Runtime();
    }
  }]);

  return Runtime;
}();

exports.Runtime = Runtime;

function Version() {
  var u = navigator.userAgent;
  return {
    trident: u.indexOf('Trident') > -1,
    //IE内核
    presto: u.indexOf('Presto') > -1,
    //opera内核
    webKit: u.indexOf('AppleWebKit') > -1,
    //苹果、谷歌内核
    gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1,
    //火狐内核
    mobile: !!u.match(/AppleWebKit.*Mobile.*/),
    //是否为移动终端
    ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/),
    //ios终端
    android: u.indexOf('Android') > -1 || u.indexOf('Adr') > -1,
    //android终端
    iPhone: u.indexOf('iPhone') > -1,
    //是否为iPhone或者QQHD浏览器
    iPad: u.indexOf('iPad') > -1,
    //是否iPad
    webApp: u.indexOf('Safari') == -1,
    //是否web应该程序，没有头部与底部
    weixin: u.indexOf('MicroMessenger') > -1,
    //是否微信 （2015-01-22新增）
    qq: !!u.match(/\sQQ/i) //是否QQ

  };
}

var _default = {
  extend: extend,
  GetDomXY: GetDomXY,
  GetDPI: GetDPI,
  LoadScript: LoadScript,
  RandomString: RandomString,
  map: map,
  strpad: strpad,
  ucFirst: ucFirst,
  under2hump: under2hump,
  explainUrl: explainUrl,
  Clone: Clone,
  hasScrolledParent: hasScrolledParent,
  RandNum: RandNum,
  Runtime: Runtime,
  Version: Version
};
exports["default"] = _default;
//# sourceMappingURL=Common.js.map
