/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DropPanel = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/DropPanel.less");

require("./css/TriangleTarget.less");

var _Common = _interopRequireDefault(require("./Common"));

var _common = require("./components/common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DropPanel =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DropPanel, _React$Component);

  function DropPanel(props) {
    var _this;

    _classCallCheck(this, DropPanel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DropPanel).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "targetDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      var _assertThisInitialize, _assertThisInitialize2;

      _this.mainDom.classList.add('d-none');

      (_assertThisInitialize = _assertThisInitialized(_this)) === null || _assertThisInitialize === void 0 ? void 0 : (_assertThisInitialize2 = _assertThisInitialize.targetDom) === null || _assertThisInitialize2 === void 0 ? void 0 : _assertThisInitialize2.classList.remove('ck-intriangle');
      window.removeEventListener('mousedown', _this.hide);
    });

    return _this;
  }

  _createClass(DropPanel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _document$querySelect, _this$props$selector;

      this.targetDom = (_document$querySelect = document.querySelector((_this$props$selector = this.props.selector) !== null && _this$props$selector !== void 0 ? _this$props$selector : '')) !== null && _document$querySelect !== void 0 ? _document$querySelect : undefined;
      this.iniTarget();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.destroy();
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-drop-panel d-none';

      if (this.props.border) {
        base = (0, _bind["default"])(base, 'border');
      }

      if (this.props.theme) {
        var _this$props$theme;

        var themeStr = typeof this.props.theme === 'string' ? this.props.theme : _common.Theme[(_this$props$theme = this.props.theme) !== null && _this$props$theme !== void 0 ? _this$props$theme : 0];
        base = (0, _bind["default"])(base, 'border-' + themeStr);
      }

      if (this.props.round) {
        base = (0, _bind["default"])(base, 'rounded');
      }

      if (this.props.shadow) {
        base = (0, _bind["default"])(base, 'shadow');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {// const style:StrObject = {}
      // if (this.props.borderTheme) {
      // }
      // return style
    }
  }, {
    key: "iniTarget",
    value: function iniTarget() {
      var _this2 = this;

      if (!this.targetDom) {
        return;
      }

      this.targetDom.addEventListener('click', function () {
        _this2.show();
      }, false);
      this.mainDom.addEventListener('mousedown', function (e) {
        e.stopPropagation();
      });

      if (this.props.borderColor) {
        this.targetDom.style.setProperty("--ck-triangle-cus", this.props.borderColor);
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      window.removeEventListener('mousedown', this.hide);
    }
  }, {
    key: "show",
    value: function show(showDom) {
      var _this$targetDom;

      if (showDom) {
        this.targetDom = showDom;
      }

      window.addEventListener('mousedown', this.hide, false);
      this.mainDom.classList.remove('d-none');
      this === null || this === void 0 ? void 0 : (_this$targetDom = this.targetDom) === null || _this$targetDom === void 0 ? void 0 : _this$targetDom.classList.add('ck-intriangle');
      this.fixPosition();
    }
  }, {
    key: "fixPosition",
    value: function fixPosition() {
      var _common$hasScrolledPa;

      if (!this.targetDom) return;
      var scrollParent = (_common$hasScrolledPa = _Common["default"].hasScrolledParent(this.targetDom)) !== null && _common$hasScrolledPa !== void 0 ? _common$hasScrolledPa : document.documentElement;

      var position = _Common["default"].GetDomXY(this.targetDom, null);

      if (position.top + this.targetDom.offsetHeight + this.mainDom.offsetHeight > scrollParent.scrollTop + scrollParent.offsetHeight) {
        this.mainDom.style.top = -(this.targetDom.offsetHeight + this.mainDom.offsetHeight) + 'px';
        this.targetDom.classList.remove('ck-intriangle-bottom');
        this.targetDom.classList.add('ck-intriangle-top');
      } else {
        this.mainDom.style.top = this.targetDom.offsetHeight + 8 + 'px';
        this.targetDom.classList.remove('ck-intriangle-top');
        this.targetDom.classList.add('ck-intriangle-bottom');
      }

      if (position.left + this.mainDom.offsetWidth > scrollParent.scrollLeft + scrollParent.offsetWidth) {
        // this.mainDom.style.left = -((position.left + this.mainDom.offsetWidth) - (scrollParent.scrollLeft + scrollParent.offsetWidth)) + 'px';
        this.mainDom.style.left = this.targetDom.offsetWidth - this.mainDom.offsetWidth + 'px';
      } else {
        this.mainDom.style.left = '0';
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this3.mainDom = c;
        },
        className: this.getClasses()
      }, _react["default"].Children.map(this.props.children, function (item) {
        return _react["default"].cloneElement(item, _objectSpread({}, item.props, {
          parent: _this3
        }));
      }));
    }
  }]);

  return DropPanel;
}(_react["default"].Component);

exports.DropPanel = DropPanel;

_defineProperty(DropPanel, "defaultProps", {
  border: false,
  round: true,
  shadow: true
});

var _default = DropPanel;
exports["default"] = _default;
//# sourceMappingURL=DropPanel.js.map
