/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Dropdown = exports.DropdownValue = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Common = _interopRequireDefault(require("./Common"));

var _Button = _interopRequireDefault(require("./Button"));

var _common = require("./components/common");

var bootstrap = _interopRequireWildcard(require("bootstrap"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DropdownValue =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DropdownValue, _React$Component);

  function DropdownValue() {
    _classCallCheck(this, DropdownValue);

    return _possibleConstructorReturn(this, _getPrototypeOf(DropdownValue).apply(this, arguments));
  }

  return DropdownValue;
}(_react["default"].Component);

exports.DropdownValue = DropdownValue;

var Dropdown =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Dropdown, _React$PureComponent);

  function Dropdown(props) {
    var _this$props$text, _this$props$id;

    var _this;

    _classCallCheck(this, Dropdown);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Dropdown).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "dropdown", void 0);

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (e) {
      var val = {
        text: e.target.textContent,
        value: e.target.dataset.value
      };

      if (!_this.props.locked) {
        _this.setState(val);
      }

      if (_this.props.onChange && typeof _this.props.onChange === 'function') {
        _this.props.onChange(val.text, val.value);
      }
    });

    _this.state = {
      text: (_this$props$text = _this.props.text) !== null && _this$props$text !== void 0 ? _this$props$text : '',
      value: '',
      list: _this.props.data
    };
    _this.domId = (_this$props$id = _this.props.id) !== null && _this$props$id !== void 0 ? _this$props$id : 'drop-' + _Common["default"].RandomString(16);
    return _this;
  }

  _createClass(Dropdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.dropdown = new bootstrap.Dropdown(document.getElementById(this.domId));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.dropdown.dispose();
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProp) {
      var _nextProp$text;

      this.setState({
        text: (_nextProp$text = nextProp.text) !== null && _nextProp$text !== void 0 ? _nextProp$text : '',
        list: nextProp.data
      });
    }
  }, {
    key: "setValue",
    value: function setValue(val) {
      var text, value;

      switch (_typeof(val)) {
        case 'string':
          text = val;
          value = val;
          break;

        case 'object':
          text = val.text;
          value = val.value;
          break;

        default:
          return;
      }

      this.setState({
        text: text,
        value: value
      });
    }
  }, {
    key: "getValue",
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: "getJsonValue",
    value: function getJsonValue() {
      return {
        text: this.state.text,
        value: this.state.value
      };
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'dropdown';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      //default style
      var def_style = {
        "width": this.props.width + "px"
      };

      if (this.props.absolute) {
        def_style.position = 'absolute';
      }

      if (this.props.x) {
        def_style.left = this.props.x;
      }

      if (this.props.y) {
        def_style.top = this.props.y;
      }

      return _Common["default"].extend(def_style, this.props.style);
    }
  }, {
    key: "renderList",
    value: function renderList() {
      var _this2 = this;

      var list = this.state.list;

      if (!list || !(list instanceof Array)) {
        if (_react["default"].Children.count(this.props.children)) {
          list = [];

          _react["default"].Children.forEach(this.props.children, function (item) {
            if (item.type === DropdownValue) {
              list.push({
                text: item.props.text,
                value: item.props.value,
                active: item.props.active
              });
            }
          });
        } else {
          return null;
        }
      }

      return list.map(function (item, i) {
        var classList = 'dropdown-item';

        if (item.active) {
          classList += ' active';
        }

        if (typeof item === 'string') {
          return _react["default"].createElement("li", {
            key: i
          }, _react["default"].createElement(_Button["default"], {
            className: classList,
            size: _this2.props.size,
            onClick: _this2.selectHandler,
            "data-value": item
          }, item));
        }

        return _react["default"].createElement("li", {
          key: i
        }, _react["default"].createElement(_Button["default"], {
          className: classList,
          size: _this2.props.size,
          onClick: _this2.selectHandler,
          "data-value": item.value
        }, item.text));
      });
    }
  }, {
    key: "renderGrid",
    value: function renderGrid() {
      var _this3 = this;

      var list = this.state.list;

      if (!list || !(list instanceof Array)) {
        return null;
      }

      var domList = [];

      for (var row = 0; row < list.length; row++) {
        var rowList = list[row];

        if (!rowList || !(rowList instanceof Array)) {
          continue;
        }

        var rowDom = _react["default"].createElement("div", {
          key: row,
          className: "px-2 d-flex d-inline mt-1"
        }, rowList.map(function (item, i) {
          return _react["default"].createElement("button", {
            key: i,
            className: "flex-fill bd-highlight border",
            style: {
              backgroundColor: item,
              height: '24px'
            },
            "data-value": item,
            onClick: _this3.selectHandler
          });
        }));

        domList.push(rowDom);
      }

      return domList;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      return _react["default"].createElement("div", {
        className: this.getClasses(),
        style: this.getStyles()
      }, _react["default"].createElement(_Button["default"], {
        className: "dropdown-toggle",
        onClick: function onClick() {
          _this4.dropdown.show();
        },
        theme: this.props.theme,
        size: this.props.size,
        icon: this.props.icon,
        outline: this.props.outline,
        style: this.getStyles(),
        role: "button",
        id: this.domId,
        "data-bs-toggle": "dropdown"
      }, this.state.text), _react["default"].createElement("ul", {
        className: "dropdown-menu",
        "aria-labelledby": this.domId
      }, this.props.grid ? this.renderGrid() : this.renderList()));
    }
  }]);

  return Dropdown;
}(_react["default"].PureComponent);

exports.Dropdown = Dropdown;

_defineProperty(Dropdown, "Value", DropdownValue);

_defineProperty(Dropdown, "defaultProps", {
  data: [],
  text: '',
  theme: _common.Theme.secondary,
  outline: false
});

var _default = Dropdown;
exports["default"] = _default;
//# sourceMappingURL=Dropdown.js.map
