/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Form = void 0;

var _react = _interopRequireDefault(require("react"));

var _Input = _interopRequireDefault(require("./Input"));

var _CCheckbox = _interopRequireDefault(require("./CCheckbox"));

var _Select = _interopRequireDefault(require("./Select"));

var _TextArea = _interopRequireDefault(require("./TextArea"));

var _Common = require("./Common");

var _Dropdown = _interopRequireDefault(require("./Dropdown"));

var _Switch = _interopRequireDefault(require("./Switch"));

var _CDropdown = _interopRequireDefault(require("./CDropdown"));

var _ComboBox = _interopRequireDefault(require("./ComboBox"));

var _CalendarRange = _interopRequireDefault(require("./CalendarRange"));

var _RadioGroup = _interopRequireDefault(require("./RadioGroup"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Form =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Form, _React$PureComponent);

  function Form(props) {
    var _this;

    _classCallCheck(this, Form);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Form).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "vals", void 0);

    _defineProperty(_assertThisInitialized(_this), "components", void 0);

    _defineProperty(_assertThisInitialized(_this), "events", void 0);

    _defineProperty(_assertThisInitialized(_this), "newColumn", void 0);

    _defineProperty(_assertThisInitialized(_this), "lastValidItem", void 0);

    _this.vals = {};
    _this.components = {};
    _this.events = {};
    _this.newColumn = {};
    return _this;
  }

  _createClass(Form, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "getValues",
    value: function getValues() {
      return this.vals;
    }
  }, {
    key: "getNew",
    value: function getNew() {
      return Object.assign({}, this.newColumn);
    }
  }, {
    key: "setValue",
    value: function setValue(field, val) {
      this.vals[field] = val;

      if (this.components[field]) {// console.log(this.components.current);
        // this.components[field].setValue(val);
      }
    }
  }, {
    key: "check",
    value: function check() {
      var _this2 = this;

      var valid = true;
      (0, _Common.map)(this.components, function (item) {
        if (item && typeof item.check === 'function') {
          if (!item.check()) {
            valid = false;
            _this2.lastValidItem = item;
          }
        }
      });
      return valid;
    }
  }, {
    key: "getLastErrorCheck",
    value: function getLastErrorCheck() {
      return this.lastValidItem;
    }
  }, {
    key: "setValues",
    value: function setValues(vals) {
      var _this3 = this;

      this.vals = Object.assign(this.vals, vals);
      (0, _Common.map)(vals, function (item, key) {
        if (_this3.components[key]) {// console.log(this.components);
          // this.components[key].setValue(item);
        }
      });
    }
  }, {
    key: "inputChangeHandler",
    value: function inputChangeHandler(field) {
      var _this4 = this;

      return function (val) {
        _this4.vals[field] = val;

        if (typeof _this4.props.onChange === 'function') {
          _this4.props.onChange(field, val);
        }

        if (typeof _this4.events[field] === 'function') {
          _this4.events[field](val);
        }
      };
    }
  }, {
    key: "comboChangeHandler",
    value: function comboChangeHandler(field, searchField) {
      var _this5 = this;

      return function (val, row) {
        _this5.vals[field] = {
          text: val,
          value: row
        };

        if (typeof _this5.props.onChange === 'function') {
          _this5.props.onChange(field, val, row, 'combo', searchField);
        }

        if (typeof _this5.events[field] === 'function') {
          _this5.events[field](val, row);
        }
      };
    }
  }, {
    key: "selectChangeHandler",
    value: function selectChangeHandler(field) {
      var _this6 = this;

      return function (e) {
        _this6.vals[field] = e.target.value;

        if (typeof _this6.props.onChange === 'function') {
          _this6.props.onChange(field, e.target.value);
        }

        if (typeof _this6.events[field] === 'function') {
          _this6.events[field](e);
        }
      };
    }
  }, {
    key: "dropdownChangeHandler",
    value: function dropdownChangeHandler(field) {
      var _this7 = this;

      return function (text, val) {
        _this7.vals[field] = text;

        if (typeof _this7.props.onChange === 'function') {
          _this7.props.onChange(field, text, val);
        }

        if (typeof _this7.events[field] === 'function') {
          _this7.events[field](text, val);
        }
      };
    }
  }, {
    key: "cdropdownChangeHandler",
    value: function cdropdownChangeHandler(field) {
      var _this8 = this;

      return function (text, row) {
        _this8.vals[field] = row === null || row === void 0 ? void 0 : row.value;

        if (typeof _this8.props.onChange === 'function') {
          _this8.props.onChange(field, row === null || row === void 0 ? void 0 : row.text, row === null || row === void 0 ? void 0 : row.value);
        }

        if (typeof _this8.events[field] === 'function') {
          _this8.events[field](row === null || row === void 0 ? void 0 : row.text, row === null || row === void 0 ? void 0 : row.value);
        }
      };
    }
  }, {
    key: "checkChangeHandler",
    value: function checkChangeHandler(field) {
      var _this9 = this;

      return function (checked) {
        _this9.vals[field] = checked;

        if (typeof _this9.props.onChange === 'function') {
          _this9.props.onChange(field, checked);
        }

        if (typeof _this9.events[field] === 'function') {
          _this9.events[field](checked);
        }
      };
    }
  }, {
    key: "switchChangeHandler",
    value: function switchChangeHandler(field) {
      var _this10 = this;

      return function (checked) {
        _this10.vals[field] = checked;

        if (typeof _this10.props.onChange === 'function') {
          _this10.props.onChange(field, checked);
        }

        if (typeof _this10.events[field] === 'function') {
          _this10.events[field](checked);
        }
      };
    }
  }, {
    key: "calendarRangeChangeHandler",
    value: function calendarRangeChangeHandler(field) {
      var _this11 = this;

      return function (min, max) {
        _this11.vals[field] = {
          min: min,
          max: max
        };

        if (typeof _this11.props.onChange === 'function') {
          _this11.props.onChange(field, min, max);
        }

        if (typeof _this11.events[field] === 'function') {
          _this11.events[field](min, max);
        }
      };
    }
  }, {
    key: "radioChangeHandler",
    value: function radioChangeHandler(field) {
      var _this12 = this;

      return function (val) {
        _this12.vals[field] = val;

        if (typeof _this12.props.onChange === 'function') {
          _this12.props.onChange(field, val);
        }

        if (typeof _this12.events[field] === 'function') {
          _this12.events[field](val);
        }
      };
    }
  }, {
    key: "refComponent",
    value: function refComponent(field, orgRef) {
      var _this13 = this;

      return function (c) {
        _this13.components[field] = c;

        if (typeof orgRef === 'function') {
          orgRef(c);
        }
      };
    }
  }, {
    key: "bindingComponent",
    value: function bindingComponent(item) {
      var _this14 = this;

      if (_typeof(item) !== 'object' || item === null) {
        return item;
      }

      if (item.props && _typeof(item.props.children) === 'object' && item.type !== _CDropdown["default"] && item.type !== _ComboBox["default"] && item.type !== _RadioGroup["default"]) {
        var children = _react["default"].Children.map(item.props.children, function (child_item) {
          return _this14.bindingComponent(child_item);
        });

        return _react["default"].cloneElement(item, _objectSpread({}, item.props), children);
      } else {
        var props = {};

        var _field;

        if (typeof item.props.field === 'string') {
          _field = item.props.field;
        } else if (_typeof(item.props.field) === 'object') {
          _field = item.props.field.key;
        } else {
          return item;
        }

        this.newColumn[_field] = '';

        if (item.type === _Input["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          if (item.props.combo) {
            item.props.onChange = this.comboChangeHandler(_field, item.props.field);
            this.newColumn[_field] = {
              text: '',
              value: '',
              text_key: item.props.field.text_key
            };
          } else {
            props.onChange = this.inputChangeHandler(_field);
          } // this.components[field] = React.createRef();
          // item.props.ref = this.components[field];

        } else if (item.type === _Select["default"]) {
          if (typeof item.props.onSelect === 'function') {
            this.events[_field] = item.props.onSelect;
          }

          props.onSelect = this.selectChangeHandler(_field); // item.props.ref = this.refComponent(field);
        } else if (item.type === _CCheckbox["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.checkChangeHandler(_field); // item.props.ref = this.refComponent(field);
        } else if (item.type === _TextArea["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.inputChangeHandler(_field); // item.props.ref = this.refComponent(field);
        } else if (item.type === _Dropdown["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.dropdownChangeHandler(_field);
        } else if (item.type === _CDropdown["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.cdropdownChangeHandler(_field);
        } else if (item.type === _Switch["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.switchChangeHandler(_field);
        } else if (item.type === _ComboBox["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.comboChangeHandler(_field);
        } else if (item.type === _CalendarRange["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.calendarRangeChangeHandler(_field);
        } else if (item.type === _RadioGroup["default"]) {
          if (typeof item.props.onChange === 'function') {
            this.events[_field] = item.props.onChange;
          }

          props.onChange = this.radioChangeHandler(_field);
        } // return React.cloneElement(item,Object.assign({},item.props,props))


        props.ref = this.refComponent(_field, item.ref);
        return _react["default"].cloneElement(item, _objectSpread({}, item.props, props));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this15 = this;

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].Children.map(this.props.children, function (item) {
        return _this15.bindingComponent(item); // return item;
      }));
    }
  }]);

  return Form;
}(_react["default"].PureComponent);

exports.Form = Form;
var _default = Form;
exports["default"] = _default;
//# sourceMappingURL=Form.js.map
