/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Icon = (0, _react.forwardRef)(function (_ref, ref) {
  var _ref$iconType = _ref.iconType,
      iconType = _ref$iconType === void 0 ? 'solid' : _ref$iconType,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? '' : _ref$icon,
      spin = _ref.spin,
      bs = _ref.bs,
      className = _ref.className,
      onClick = _ref.onClick,
      restProps = _objectWithoutProperties(_ref, ["iconType", "icon", "spin", "bs", "className", "onClick"]);

  var _useState = (0, _react.useState)(icon),
      _useState2 = _slicedToArray(_useState, 2),
      currentIcon = _useState2[0],
      setCurrentIcon = _useState2[1];

  (0, _react.useEffect)(function () {
    setCurrentIcon(icon !== null && icon !== void 0 ? icon : '');
  }, [icon]);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      setIcon: function setIcon(icon) {
        setCurrentIcon(icon);
      }
    };
  }, []);
  var getBsClasses = (0, _react.useCallback)(function () {
    var base;

    if (currentIcon) {
      base = (0, _bind["default"])(base, currentIcon);
    }

    return (0, _bind["default"])(base, className);
  }, [currentIcon, className]);
  var getClasses = (0, _react.useCallback)(function () {
    if (bs) {
      return getBsClasses();
    }

    var base;

    switch (iconType) {
      case 'regular':
        base = 'far';
        break;

      case 'light':
        base = 'fal';
        break;

      case 'brands':
        base = 'fab';
        break;

      default:
        base = 'fas';
    }

    if (currentIcon) {
      base = (0, _bind["default"])(base, 'fa-' + currentIcon);
    }

    if (spin) {
      base = (0, _bind["default"])(base, 'fa-spin');
    }

    return (0, _bind["default"])(base, className);
  }, [bs, iconType, currentIcon, spin, className, getBsClasses]); // 不传递 iconType 给 <i>
  // const { iconType: icontype, ...btnProps } = restProps;

  return _react["default"].createElement("i", _extends({}, restProps, {
    className: getClasses(),
    onClick: onClick
  }));
});
Icon.displayName = 'Icon';
var _default = Icon;
exports["default"] = _default;
//# sourceMappingURL=Icon.js.map
