/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ImageView = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/ImageView.less");

var _Common = _interopRequireDefault(require("./Common"));

var _RImage = _interopRequireDefault(require("./RImage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ImageView =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ImageView, _React$Component);

  function ImageView(props) {
    var _this$props$src;

    var _this;

    _classCallCheck(this, ImageView);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImageView).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "closeHandler", function () {
      _this.mainDom.classList.add('d-none');
    });

    _defineProperty(_assertThisInitialized(_this), "next", function () {
      if (_this.state.src.length <= 0) return;
      var idx = 0;

      if (_this.state.currIdx + 1 < _this.state.src.length) {
        idx = _this.state.currIdx + 1;
      }

      _this.setState({
        currIdx: idx
      });
    });

    _defineProperty(_assertThisInitialized(_this), "previous", function () {
      if (_this.state.src.length <= 0) return;
      var idx = _this.state.src.length - 1;

      if (_this.state.currIdx > 0) {
        idx = _this.state.currIdx - 1;
      }

      _this.setState({
        currIdx: idx
      });
    });

    _this.state = {
      src: (_this$props$src = _this.props.src) !== null && _this$props$src !== void 0 ? _this$props$src : [],
      currIdx: 0
    };
    _this.domId = 'img-view-' + _Common["default"].RandomString(16);

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    return _this;
  }

  _createClass(ImageView, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.src !== this.state.src) {
        var _nextProps$src;

        this.setState({
          src: (_nextProps$src = nextProps.src) !== null && _nextProps$src !== void 0 ? _nextProps$src : [],
          currIdx: 0
        });
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'img-view d-none';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "show",
    value: function show(srcList) {
      var _this2 = this;

      var src = this.state.src;

      if (srcList) {
        if (typeof srcList === "string") {
          src = [srcList];
        } else {
          src = srcList;
        }
      }

      this.setState({
        src: src,
        currIdx: 0
      }, function () {
        _this2.mainDom.classList.remove('d-none');
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var data = this.state.src[this.state.currIdx];
      var is_obj = _typeof(data) === "object";

      var con = _react["default"].createElement("div", {
        id: this.domId,
        ref: function ref(c) {
          return _this3.mainDom = c;
        },
        className: this.getClasses()
      }, _react["default"].createElement("div", {
        id: "image-main",
        className: "image-main"
      }, _react["default"].createElement("div", {
        className: "top"
      }, _react["default"].createElement("span", null, is_obj ? data.title : ''), _react["default"].createElement("button", {
        className: "btn-close",
        onClick: this.closeHandler
      }, _react["default"].createElement("span", null, _react["default"].createElement("svg", {
        fill: "white",
        version: "1.1",
        xmlns: "http://www.w3.org/2000/svg",
        x: "0px",
        y: "0px",
        width: "100%",
        height: "100%",
        viewBox: "0 0 512 512"
      }, _react["default"].createElement("path", {
        d: "M443.6,387.1L312.4,255.4l131.5-130c5.4-5.4,5.4-14.2,0-19.6l-37.4-37.6c-2.6-2.6-6.1-4-9.8-4c-3.7,0-7.2,1.5-9.8,4 L256,197.8L124.9,68.3c-2.6-2.6-6.1-4-9.8-4c-3.7,0-7.2,1.5-9.8,4L68,105.9c-5.4,5.4-5.4,14.2,0,19.6l131.5,130L68.4,387.1 c-2.6,2.6-4.1,6.1-4.1,9.8c0,3.7,1.4,7.2,4.1,9.8l37.4,37.6c2.7,2.7,6.2,4.1,9.8,4.1c3.5,0,7.1-1.3,9.8-4.1L256,313.1l130.7,131.1 c2.7,2.7,6.2,4.1,9.8,4.1c3.5,0,7.1-1.3,9.8-4.1l37.4-37.6c2.6-2.6,4.1-6.1,4.1-9.8C447.7,393.2,446.2,389.7,443.6,387.1z"
      }))))), _react["default"].createElement("figure", null, _react["default"].createElement(_RImage["default"], {
        display: "full",
        className: "img",
        width: "100vw",
        height: "100vw",
        src: is_obj ? data.src : data
      })), _react["default"].createElement("div", {
        className: "foot"
      }, _react["default"].createElement("figcaption", {
        className: "title"
      }), _react["default"].createElement("div", null, this.state.currIdx + 1, " / ", this.state.src.length))), this.renderSwitchButton());

      return _reactDom["default"].createPortal(con, document.body);
    }
  }, {
    key: "renderSwitchButton",
    value: function renderSwitchButton() {
      if (this.state.src.length <= 1) {
        return null;
      }

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("button", {
        type: "button",
        className: "btn",
        style: {
          left: '10px'
        },
        onClick: this.previous
      }, _react["default"].createElement("span", null, _react["default"].createElement("svg", {
        fill: "#fff",
        version: "1.1",
        xmlns: "http://www.w3.org/2000/svg",
        x: "0px",
        y: "0px",
        width: "100%",
        height: "100%",
        viewBox: "0 0 512 512"
      }, _react["default"].createElement("path", {
        d: "M213.7,256L213.7,256L213.7,256L380.9,81.9c4.2-4.3,4.1-11.4-0.2-15.8l-29.9-30.6c-4.3-4.4-11.3-4.5-15.5-0.2L131.1,247.9 c-2.2,2.2-3.2,5.2-3,8.1c-0.1,3,0.9,5.9,3,8.1l204.2,212.7c4.2,4.3,11.2,4.2,15.5-0.2l29.9-30.6c4.3-4.4,4.4-11.5,0.2-15.8 L213.7,256z"
      })))), _react["default"].createElement("button", {
        type: "button",
        className: "btn",
        style: {
          right: '10px'
        },
        onClick: this.next
      }, _react["default"].createElement("span", null, _react["default"].createElement("svg", {
        fill: "#fff",
        version: "1.1",
        xmlns: "http://www.w3.org/2000/svg",
        x: "0px",
        y: "0px",
        width: "100%",
        height: "100%",
        viewBox: "0 0 512 512"
      }, _react["default"].createElement("path", {
        d: "M298.3,256L298.3,256L298.3,256L131.1,81.9c-4.2-4.3-4.1-11.4,0.2-15.8l29.9-30.6c4.3-4.4,11.3-4.5,15.5-0.2l204.2,212.7 c2.2,2.2,3.2,5.2,3,8.1c0.1,3-0.9,5.9-3,8.1L176.7,476.8c-4.2,4.3-11.2,4.2-15.5-0.2L131.3,446c-4.3-4.4-4.4-11.5-0.2-15.8 L298.3,256z"
      })))));
    }
  }]);

  return ImageView;
}(_react["default"].Component);

exports.ImageView = ImageView;

_defineProperty(ImageView, "defaultProps", {
  src: []
});

var _default = ImageView;
exports["default"] = _default;
//# sourceMappingURL=ImageView.js.map
