/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Input = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Common = _interopRequireDefault(require("./Common"));

var _Calendar = _interopRequireWildcard(require("./Calendar"));

var _Combo = _interopRequireDefault(require("./Combo"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _i18n = _interopRequireDefault(require("./components/i18n"));

require("./css/Input.less");

var _bootstrap = require("bootstrap");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var stopEvent = function stopEvent(e) {
  e.stopPropagation();
};

var Input =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input(props) {
    var _this$props$disabled, _this$props$id;

    var _this;

    _classCallCheck(this, Input);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Input).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "isFocus", void 0);

    _defineProperty(_assertThisInitialized(_this), "input", void 0);

    _defineProperty(_assertThisInitialized(_this), "calendar", void 0);

    _defineProperty(_assertThisInitialized(_this), "combo", void 0);

    _defineProperty(_assertThisInitialized(_this), "clearIcon", void 0);

    _defineProperty(_assertThisInitialized(_this), "tip", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "changeHandler", function (e) {
      var state = {
        value: e.target ? e.target.value : e
      };

      _this.setState(state, function () {
        if (typeof _this.props.onChange === 'function') {
          _this.props.onChange(state.value, null, _assertThisInitialized(_this));
        }

        if (_this.combo) {
          _this.combo.filter(state.value);
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "blurHandler", function (e) {
      _this.setState({
        validate: _this.validate(e.target.value)
      });
    });

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (text, row) {
      _this.setState({
        value: text
      }, function () {
        if (typeof _this.props.onChange === 'function') {
          _this.props.onChange(text, row, _assertThisInitialized(_this));
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "keyUpHandler", function (e) {
      if (e.key === 'Enter') {
        if (typeof _this.props.onEnter === 'function') {
          _this.props.onEnter(e.target.value);
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "focusClearHandler", function () {
      _this.isFocus = true;

      if (_this.clearIcon) {
        _this.setState({
          icon: 'times-circle'
        }); // this.clearIcon.setIcon('times-circle');

      }
    });

    _defineProperty(_assertThisInitialized(_this), "showMulti", function () {
      var _ref, _this$props, _this$props$multi;

      // let width = this.input.offsetWidth;
      // let xy = common.GetDomXY(this.input,this.input.parentNode);
      // this.input.style.width = width+'px';
      // this.multi.classList.remove('d-none');
      // this.multi.style.left = xy.left+'px';
      // this.multi.style.top = xy.top+'px';
      // this.multi.style.width = width+'px';
      // this.multi.style.height = this.props.multi.height ?? '100px';
      // this.input.style.height = this.props.multi.height ?? '100px';
      _this.input.style.width = window.getComputedStyle(_this.input).width;

      _this.input.classList.add('ck-input-multi-show', 'shadow');

      _this.input.style.height = (_ref = (_this$props = _this.props) === null || _this$props === void 0 ? void 0 : (_this$props$multi = _this$props.multi) === null || _this$props$multi === void 0 ? void 0 : _this$props$multi.height) !== null && _ref !== void 0 ? _ref : '100px';
    });

    _defineProperty(_assertThisInitialized(_this), "hideMulti", function () {
      _this.input.style.height = 'calc(1.5em + .75rem + 2px)';
      setTimeout(function () {
        _this.input.classList.remove('ck-input-multi-show', 'shadow');

        _this.input.style.width = '100%';
      }, 210);
    });

    _defineProperty(_assertThisInitialized(_this), "blurClearHandler", function () {
      _this.isFocus = false;

      if (_this.clearIcon) {
        if (_this.props.combo) {
          // this.clearIcon.setIcon('angle-down');
          _this.setState({
            icon: 'angle-down'
          });
        } else if (_this.props.calendar) {
          _this.setState({
            icon: 'calendar-alt'
          }); // this.clearIcon.setIcon('calendar-alt');

        } else {
          _this.setState({
            icon: ''
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "dblHandler", function () {
      if (_this.calendar && !_this.state.value) {
        _this.calendar.setCurrentDate(new Date());

        _this.setState({
          value: _this.calendar.format()
        }, function () {
          if (typeof _this.props.onChange === 'function') {
            _this.props.onChange(_this.state.value, null, _assertThisInitialized(_this));
          }

          _this.calendar.hide();
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "mainDblHandler", function () {
      if (typeof _this.props.onDblClick === 'function') {
        _this.props.onDblClick();
      }
    });

    _this.state = {
      value: _this.props.data,
      validate: true,
      disabled: (_this$props$disabled = _this.props.disabled) !== null && _this$props$disabled !== void 0 ? _this$props$disabled : false,
      comboData: _this.props.comboData,
      icon: _this.props.combo ? 'angle-down' : _this.props.calendar ? 'calendar-alt' : ''
    };
    _this.domId = (_this$props$id = _this.props.id) !== null && _this$props$id !== void 0 ? _this$props$id : 'input-' + _Common["default"].RandomString(16);
    _this.isFocus = false;
    return _this;
  }

  _createClass(Input, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this,
          _this$props$validate;

      if (this.props.calendar) {
        this.input.addEventListener('focus', function (e) {
          _this2.calendar.show(e.currentTarget);
        }, false); // $(ReactDOM.findDOMNode(this.input)).on('focus', (e) => {
        //     this.calendar.show(e.currentTarget);
        // });
        // $(ReactDOM.findDOMNode(this.input)).on('mousedown', (e) => {
        //     e.stopPropagation();
        // });
      }

      if (this.props.combo) {
        this.input.addEventListener('focus', function (e) {
          _this2.combo.show(_this2.state.value, e.currentTarget);
        }, false);
      }

      this.input.addEventListener('focus', this.focusClearHandler, false);
      this.input.addEventListener('blur', this.blurClearHandler, false);
      this.input.addEventListener('blur', this.blurHandler, false);
      this.input.addEventListener('mousedown', stopEvent, false);

      if (this.props.validate && ((_this$props$validate = this.props.validate) === null || _this$props$validate === void 0 ? void 0 : _this$props$validate.tip)) {
        this.tip = new _bootstrap.Tooltip(document.getElementById(this.domId), {
          trigger: 'manual',
          template: '<div class="tooltip ck-input-tip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner bg-danger"></div></div>'
        });
      }

      if (this.props.multi) {
        this.input.addEventListener('focus', this.showMulti, false);
        this.input.addEventListener('blur', this.hideMulti, false);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props$validate2;

      if (this.props.validate && ((_this$props$validate2 = this.props.validate) === null || _this$props$validate2 === void 0 ? void 0 : _this$props$validate2.tip)) {
        this.tip.hide();
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      this.setState({
        value: nextProps.data,
        comboData: nextProps.comboData
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextProps.comboData !== this.props.comboData) {
        return true;
      }

      if (nextProps.disabled !== this.props.disabled) {
        return true;
      }

      if (nextProps.label !== this.props.label) {
        return true;
      }

      if (nextState.validate !== this.state.validate) {
        return true;
      }

      if (nextState.icon !== this.state.icon) {
        return true;
      }

      return nextState.value !== this.state.value;
    }
  }, {
    key: "getValue",
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: "setValue",
    value: function setValue(val) {
      this.setState({
        value: val
      });
    }
  }, {
    key: "getMainClasses",
    value: function getMainClasses() {
      var base = this.props.label ? 'mb-3' : '';

      if (this.props.hidden) {
        base = (0, _bind["default"])(base, 'd-none');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getMainStyles",
    value: function getMainStyles() {
      //default style
      var base = {
        position: 'relative'
      };

      if (this.props.width) {
        base.width = this.props.width;
      }

      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.absolute) {
        base.position = 'absolute';
      }

      if (this.props.x) {
        base.left = this.props.x;
      }

      if (this.props.y) {
        base.top = this.props.y;
      }

      if (!this.props.label) {
        base.marginBottom = '0';

        if (this.props.multi) {
          base.height = 'calc(1.5em + .75rem + 2px)';
        }
      }

      return _Common["default"].extend(base, this.props.style);
    }
  }, {
    key: "getInputClasses",
    value: function getInputClasses(append) {
      var base = 'form-control ck-input'; //readonly

      if (this.props.plaintext) {
        base = 'form-control-plaintext'; // this.props.readOnly = true;
      } //size


      var size;

      switch (this.props.size) {
        case 'lg':
          size = 'form-control-lg';
          break;

        case 'sm':
          size = 'form-control-sm';
          break;

        case 'xs':
          size = 'form-control-xs';
          break;

        default:
          size = '';
      }

      base = (0, _bind["default"])(base, size);

      if (!this.state.validate) {
        base = (0, _bind["default"])(base, 'ck-input-valid');
      }

      if ((this.props.calendar || this.props.combo) && !this.state.disabled && !this.props.readOnly) {
        base = (0, _bind["default"])(base, 'ck-input-icon');
      }

      if (this.props.readOnly && (this.props.calendar || this.props.combo)) {
        base = (0, _bind["default"])(base, 'ck-input-select');
      }

      if (this.props.align) {
        if (this.props.align === 'left') {
          base = (0, _bind["default"])(base, "text-start");
        } else if (this.props.align === 'right') {
          base = (0, _bind["default"])(base, "text-end");
        } else {
          base = (0, _bind["default"])(base, "text-".concat(this.props.align));
        }
      }

      if (this.props.multi) {
        base = (0, _bind["default"])(base, "ck-input-multi");
      }

      if (this.props.underline) {
        base = (0, _bind["default"])(base, 'ck-input-underline');
      }

      return (0, _bind["default"])(base, this.props.textClass, append);
    }
  }, {
    key: "getInputStyle",
    value: function getInputStyle() {
      var base = {};

      if (this.props.width) {
        base.width = this.props.width;
      }

      if (this.props.height) {
        base.height = this.props.height;
      } else if (this.props.multi) {
        base.height = 'calc(1.5em + .75rem + 2px)';
      }

      return _Common["default"].extend(base, this.props.textStyle);
    }
  }, {
    key: "check",
    value: function check(flag) {
      var validate = flag !== null && flag !== void 0 ? flag : this.validate(this.state.value);
      this.setState({
        validate: validate
      });
      return validate;
    }
  }, {
    key: "validate",
    value: function validate(val) {
      if (this.props.validate) {
        var vali = this.props.validate;
        var valid;

        if (typeof vali.rule === 'function') {
          valid = vali.rule(val);
        } else {
          valid = vali.rule.test(val);
        }

        if (vali.tip) {
          if (valid) {
            this.tip.hide();
          } else {
            this.tip.show();
          } // $('#' + this.domId).tooltip(valid ? 'hide' : 'show');

        }

        return valid;
      }

      return true;
    }
    /*********************
     * Event
     *********************/

  }, {
    key: "setSelectRows",
    value: function setSelectRows(key, val) {
      if (this.props.combo) {
        this.combo.setSelectRows(key, val);
      }
    }
  }, {
    key: "renderLabel",

    /*********************
     * render method
     *********************/
    value: function renderLabel() {
      if (this.props.label === '') {
        return null;
      }

      return _react["default"].createElement("label", {
        htmlFor: this.domId,
        className: 'form-label ' + this.props.labelClass
      }, this.props.label);
    }
  }, {
    key: "renderSummary",
    value: function renderSummary() {
      var _this$props2, _this$props2$validate;

      if (!this.state.validate && !((_this$props2 = this.props) === null || _this$props2 === void 0 ? void 0 : (_this$props2$validate = _this$props2.validate) === null || _this$props2$validate === void 0 ? void 0 : _this$props2$validate.tip)) {
        var _this$props3, _this$props3$validate;

        return _react["default"].createElement("div", {
          className: "invalid-feedback",
          style: {
            display: 'block'
          }
        }, (_this$props3 = this.props) === null || _this$props3 === void 0 ? void 0 : (_this$props3$validate = _this$props3.validate) === null || _this$props3$validate === void 0 ? void 0 : _this$props3$validate.text);
      }

      if (!this.props.summary) {
        return null;
      }

      return _react["default"].createElement("small", {
        className: "form-text text-muted text-truncate"
      }, this.props.summary);
    }
  }, {
    key: "renderCalendar",
    value: function renderCalendar() {
      var _ref2,
          _this$props$calendar,
          _ref3,
          _this$props$calendar2,
          _this$props$calendar3,
          _this3 = this;

      if (!this.props.calendar) {
        return null;
      }

      var input_icon = 'ck-input-calendar-icon';

      if (this.props.size) {
        input_icon = (0, _bind["default"])(input_icon, 'ck-input-calendar-icon-' + this.props.size);
      }

      var lang = _i18n["default"].getLang();

      var props = {
        format: (_ref2 = (_this$props$calendar = this.props.calendar) === null || _this$props$calendar === void 0 ? void 0 : _this$props$calendar.format) !== null && _ref2 !== void 0 ? _ref2 : this.props.calendarFormat,
        timeBar: (_ref3 = (_this$props$calendar2 = this.props.calendar) === null || _this$props$calendar2 === void 0 ? void 0 : _this$props$calendar2.time) !== null && _ref3 !== void 0 ? _ref3 : this.props.calendarTime,
        limit: (_this$props$calendar3 = this.props.calendar) === null || _this$props$calendar3 === void 0 ? void 0 : _this$props$calendar3.limit
      };
      return _react["default"].createElement("div", {
        className: "ck-input-calendar"
      }, _react["default"].createElement(_Calendar["default"], {
        ref: function ref(c) {
          return _this3.calendar = c;
        },
        onSelect: function onSelect(val) {
          _this3.setState({
            value: val
          });

          if (_this3.props.onChange && typeof _this3.props.onChange === 'function') {
            _this3.props.onChange(val, _this3);
          }
        },
        value: this.state.value,
        format: props.format,
        timeBar: props.timeBar,
        limit: props.limit,
        lang: lang["short"],
        none: true,
        shadow: true,
        absolute: true,
        sm: this.props.size === 'xs',
        triangular: "up"
      }), !this.props.disabled && !this.props.readOnly ? _react["default"].createElement("div", {
        className: input_icon,
        onMouseDown: function onMouseDown(e) {
          e.stopPropagation();
          e.preventDefault();

          if (_this3.isFocus) {
            _this3.changeHandler('');
          } else {
            _this3.input.focus();
          }
        }
      }, _react["default"].createElement(_Icon["default"], {
        ref: function ref(c) {
          return _this3.clearIcon = c;
        },
        icon: this.state.icon
      })) : null);
    }
  }, {
    key: "renderCombo",
    value: function renderCombo() {
      var _this4 = this;

      if (!this.props.combo) {
        return null;
      }

      var input_icon = 'ck-input-calendar-icon';

      if (this.props.size) {
        input_icon = (0, _bind["default"])(input_icon, 'ck-input-calendar-icon-' + this.props.size);
      }

      return _react["default"].createElement("div", {
        className: "ck-input-calendar"
      }, _react["default"].createElement(_Combo["default"], _extends({
        ref: function ref(c) {
          return _this4.combo = c;
        }
      }, this.props.combo, {
        sm: this.props.size === 'sm' || this.props.size === 'xs',
        data: this.state.comboData,
        noSearch: this.props.readOnly,
        onShow: function onShow() {},
        onSelect: this.selectHandler
      })), _react["default"].createElement("div", {
        className: input_icon,
        onMouseDown: function onMouseDown(e) {
          e.stopPropagation();
          e.preventDefault();

          if (_this4.isFocus) {
            var _this4$props, _this4$props$combo;

            _this4.changeHandler('');

            if ((_this4$props = _this4.props) === null || _this4$props === void 0 ? void 0 : (_this4$props$combo = _this4$props.combo) === null || _this4$props$combo === void 0 ? void 0 : _this4$props$combo.multi) {
              _this4.combo.clearMulti();
            }
          } else {
            _this4.input.focus();
          }
        }
      }, _react["default"].createElement(_Icon["default"], {
        ref: function ref(c) {
          return _this4.clearIcon = c;
        },
        icon: this.state.icon
      })));
    }
  }, {
    key: "renderClear",
    value: function renderClear() {
      var _this5 = this;

      if (this.props.disabled || this.props.combo || this.props.calendar || this.props.plaintext || this.props.disableClear || this.props.readOnly) {
        return null;
      }

      var input_icon = 'ck-input-calendar-icon';

      if (this.props.size) {
        input_icon = (0, _bind["default"])(input_icon, 'ck-input-calendar-icon-' + this.props.size);
      }

      return _react["default"].createElement("div", {
        className: "ck-input-calendar"
      }, _react["default"].createElement("div", {
        className: input_icon,
        onMouseDown: function onMouseDown(e) {
          e.stopPropagation();
          e.preventDefault();

          if (_this5.isFocus) {
            _this5.changeHandler('');
          } else {
            _this5.input.focus();
          }
        }
      }, _react["default"].createElement(_Icon["default"], {
        ref: function ref(c) {
          return _this5.clearIcon = c;
        },
        icon: this.state.icon
      })));
    } //build tooltip

  }, {
    key: "renderValidateTip",
    value: function renderValidateTip() {
      if (this.props.validate) {
        return {
          'data-toggle': 'tooltip',
          'data-placement': 'right',
          title: this.props.validate.text
        };
      }

      return {};
    }
  }, {
    key: "renderDisableMask",
    value: function renderDisableMask() {
      if (!this.props.disabled || !this.props.onDblClick) return null;
      return _react["default"].createElement("div", {
        className: "position-absolute w-100 h-100",
        style: {
          top: 0,
          left: 0
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state$value,
          _this6 = this;

      if (this.props.multi) {
        return this.renderMulti();
      }

      var inputProps = _objectSpread({}, this.props);

      delete inputProps.absolute;
      delete inputProps.disableClear;
      delete inputProps.calendar;
      delete inputProps.plaintext;
      delete inputProps.onDblClick;
      delete inputProps.calendarTime;
      delete inputProps.calendarFormat;
      delete inputProps.comboData;
      var val = (_this$state$value = this.state.value) !== null && _this$state$value !== void 0 ? _this$state$value : '';

      if (this.props.calendar && val !== "") {
        var _ref4, _ref5, _this$props$calendar4;

        val = (0, _Calendar.format)((_ref4 = (_ref5 = (_this$props$calendar4 = this.props.calendar) === null || _this$props$calendar4 === void 0 ? void 0 : _this$props$calendar4.format) !== null && _ref5 !== void 0 ? _ref5 : this.props.calendarFormat) !== null && _ref4 !== void 0 ? _ref4 : '', new Date(val));
      }

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          _this6.mainDom = c;
        },
        id: this.domId + '-main',
        className: this.getMainClasses(),
        style: this.getMainStyles(),
        onDoubleClick: this.mainDblHandler
      }, this.renderLabel(), this.renderDisableMask(), _react["default"].createElement("input", _extends({
        type: "text",
        autoComplete: "off"
      }, inputProps, {
        size: undefined,
        ref: function ref(c) {
          return _this6.input = c;
        },
        onChange: this.changeHandler,
        onKeyUp: this.keyUpHandler,
        onDoubleClick: this.dblHandler,
        value: val,
        className: this.getInputClasses(''),
        style: this.getInputStyle(),
        id: this.domId
      }, this.renderValidateTip())), this.renderCalendar(), this.renderCombo(), this.renderClear(), this.renderSummary());
    }
  }, {
    key: "renderMulti",
    value: function renderMulti() {
      var _this7 = this,
          _this$state$value2;

      return _react["default"].createElement("div", {
        id: this.domId + '-main',
        ref: function ref(c) {
          _this7.mainDom = c;
        },
        className: this.getMainClasses(),
        style: this.getMainStyles()
      }, this.renderLabel(), _react["default"].createElement("textarea", _extends({}, this.props, {
        ref: function ref(c) {
          return _this7.input = c;
        },
        onChange: this.changeHandler,
        onKeyUp: this.keyUpHandler,
        onDoubleClick: this.dblHandler,
        value: (_this$state$value2 = this.state.value) !== null && _this$state$value2 !== void 0 ? _this$state$value2 : '',
        className: this.getInputClasses(''),
        style: this.getInputStyle(),
        id: this.domId
      }, this.renderValidateTip())), this.renderSummary());
    }
  }]);

  return Input;
}(_react["default"].Component);

exports.Input = Input;

_defineProperty(Input, "defaultProps", {
  size: 'df',
  label: '',
  data: null,
  summary: '',
  readOnly: false,
  disabled: false,
  disableClear: false
});

var _default = Input;
exports["default"] = _default;
//# sourceMappingURL=Input.js.map
