/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.InputGroup = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var InputGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(InputGroup, _React$Component);

  function InputGroup(props) {
    var _this$props$label, _this$props$disabled;

    var _this;

    _classCallCheck(this, InputGroup);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(InputGroup).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "changeHandler", function (e) {
      _this.setState({
        value: e.target.value
      });

      if (_this.props.onChange && typeof _this.props.onChange === 'function') {
        _this.props.onChange(e.target.value, _assertThisInitialized(_this));
      }
    });

    _this.state = {
      label: (_this$props$label = _this.props.label) !== null && _this$props$label !== void 0 ? _this$props$label : '',
      value: _this.props.data,
      disabled: (_this$props$disabled = _this.props.disabled) !== null && _this$props$disabled !== void 0 ? _this$props$disabled : false
    };
    return _this;
  }

  _createClass(InputGroup, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProp) {
      this.setState({
        value: nextProp.data
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextProps.disabled !== this.props.disabled) {
        return true;
      }

      return nextState.value !== this.state.value;
    }
  }, {
    key: "getValue",
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: "setValue",
    value: function setValue(val) {
      this.setState({
        value: val
      });
    }
    /*********************
     * Event
     *********************/

  }, {
    key: "renderSummary",

    /*********************
     * render method
     *********************/
    value: function renderSummary() {
      if (this.props.summary === '') {
        return null;
      }

      return _react["default"].createElement("small", {
        className: "form-text text-muted text-truncate"
      }, this.props.summary);
    }
  }, {
    key: "render",
    value: function render() {
      //default style
      var def_style = {
        "width": this.props.width + "px"
      }; //input size

      var size = null;

      switch (this.props.size) {
        case "sm":
          size = {
            main: "input-group-sm",
            label: "inputGroup-sizing-sm",
            input: "inputGroup-sizing-sm"
          };
          break;

        case "lg":
          size = {
            main: "input-group-lg",
            label: "inputGroup-sizing-lg",
            input: "inputGroup-sizing-lg"
          };
          break;

        default:
          size = {
            main: "",
            label: "inputGroup-sizing-default",
            input: "inputGroup-sizing-default"
          };
      } //merge class name


      var cls_name = "input-group";
      cls_name = (0, _bind["default"])(cls_name, size.main, this.props.className);

      var inProps = _objectSpread({}, this.props);

      delete inProps.absolute;
      delete inProps.inline;
      delete inProps.half;
      return _react["default"].createElement("div", {
        className: cls_name,
        style: def_style
      }, _react["default"].createElement("div", {
        className: "input-group-text"
      }, this.state.label), _react["default"].createElement("input", _extends({
        type: "text"
      }, inProps, {
        size: undefined,
        onChange: this.changeHandler,
        value: this.state.value,
        className: "form-control"
      })), this.renderSummary());
    }
  }]);

  return InputGroup;
}(_react["default"].Component);

exports.InputGroup = InputGroup;

_defineProperty(InputGroup, "defaultProps", {
  label: "",
  data: undefined,
  size: "",
  summary: '',
  disabled: false
});

var _default = InputGroup;
exports["default"] = _default;
//# sourceMappingURL=InputGroup.js.map
