/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Label = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/Label.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Label =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Label, _React$PureComponent);

  function Label(props) {
    var _this$props$text;

    var _this;

    _classCallCheck(this, Label);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Label).call(this, props));
    _this.state = {
      text: (_this$props$text = _this.props.text) !== null && _this$props$text !== void 0 ? _this$props$text : ''
    };
    return _this;
  }

  _createClass(Label, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-label';

      if (this.props.absolute) {
        base = (0, _bind["default"])(base, 'position-absolute');
      }

      if (this.props.sm) {
        base = (0, _bind["default"])(base, 'ck-label-sm');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      var base = {};

      if (this.props.width) {
        base.width = this.props.width;
        base.paddingLeft = '0';
        base.paddingRight = '0';
      }

      if (this.props.height) {
        base.height = this.props.height;
        base.paddingTop = '0';
        base.paddingBottom = '0';
      }

      if (this.props.absolute) {
        base.top = this.props.y;
        base.left = this.props.x;
      }

      if (this.props.color) {
        base.color = this.props.color;
      }

      if (this.props.backColor) {
        base.backgroundColor = this.props.backColor;
      }

      if (this.props.align) {
        base.textAlign = this.props.align;
      }

      if (_typeof(this.props.style) === 'object') {
        base = _objectSpread({}, base, this.props.style);
      }

      return base;
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: this.getClasses(),
        style: this.getStyles()
      }, this.state.text);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (prevState.text !== nextProps.text) {
        var _nextProps$text;

        return {
          text: (_nextProps$text = nextProps.text) !== null && _nextProps$text !== void 0 ? _nextProps$text : ''
        };
      }

      return null;
    }
  }]);

  return Label;
}(_react["default"].PureComponent);

exports.Label = Label;
var _default = Label;
exports["default"] = _default;
//# sourceMappingURL=Label.js.map
