/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Menu = exports.MenuItem = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Common = _interopRequireWildcard(require("./Common"));

var _Icon = _interopRequireDefault(require("./Icon"));

require("./css/Menu.less");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MenuItem =
/*#__PURE__*/
function (_React$Component) {
  _inherits(MenuItem, _React$Component);

  function MenuItem(props) {
    var _this$props$parent;

    var _this;

    _classCallCheck(this, MenuItem);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MenuItem).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "parent", void 0);

    _defineProperty(_assertThisInitialized(_this), "childMenu", void 0);

    _defineProperty(_assertThisInitialized(_this), "clickHandler", function (e) {
      if (typeof _this.props.onClick === "function") {
        _this.props.onClick(e, _this.props.field, _this.parent.data);

        _this.parent.hide(e);
      }

      _this.parent.clickHandler(e, _this.props.field);
    });

    _defineProperty(_assertThisInitialized(_this), "showChildHandler", function (e) {
      _this.parent.closeChild(e);

      _this.childMenu.show({
        evt: e,
        type: 'dom',
        data: _this.parent.data
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeChildHandler", function (e) {
      _this.parent.closeChild(e);
    });

    _this.parent = (_this$props$parent = _this.props.parent) !== null && _this$props$parent !== void 0 ? _this$props$parent : new Menu(props);
    return _this;
  }

  _createClass(MenuItem, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-menu-item d-flex align-items-center';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "render",
    value: function render() {
      if (this.props.step) {
        return _react["default"].createElement("hr", null);
      }

      if (this.props.child) {
        return this.renderChildMenu();
      }

      return _react["default"].createElement("div", {
        className: this.getClasses(),
        onMouseDown: this.clickHandler,
        onMouseOver: this.closeChildHandler
      }, this.props.icon && this.renderIcon(), this.props.children);
    }
  }, {
    key: "renderIcon",
    value: function renderIcon() {
      return _react["default"].createElement("span", {
        className: "text-center",
        style: {
          width: '20px'
        }
      }, _react["default"].createElement(_Icon["default"], {
        icon: this.props.icon
      }));
    }
  }, {
    key: "renderChildMenu",
    value: function renderChildMenu() {
      var _this$parent$props$zI,
          _this2 = this;

      var zIndex = (_this$parent$props$zI = this.parent.props.zIndex) !== null && _this$parent$props$zI !== void 0 ? _this$parent$props$zI : 0;
      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("div", {
        className: this.getClasses(),
        onMouseDown: this.showChildHandler,
        onMouseOver: this.showChildHandler
      }, _react["default"].createElement("span", null, this.props.text), _react["default"].createElement("span", {
        className: "ms-auto"
      }, "\xA0\xA0", _react["default"].createElement(_Icon["default"], {
        icon: "caret-right"
      }))), _react["default"].createElement(Menu, {
        ref: function ref(c) {
          _this2.childMenu = c;

          _this2.parent.childMenus.push(c);
        },
        zIndex: zIndex + 1,
        onClick: function onClick(key) {
          _this2.parent.clickHandler(key);
        }
      }, this.props.children));
    }
  }]);

  return MenuItem;
}(_react["default"].Component);

exports.MenuItem = MenuItem;

var Menu =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(Menu, _React$Component2);

  function Menu(props) {
    var _this3;

    _classCallCheck(this, Menu);

    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(Menu).call(this, props));

    _defineProperty(_assertThisInitialized(_this3), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this3), "data", void 0);

    _defineProperty(_assertThisInitialized(_this3), "childMenus", void 0);

    _defineProperty(_assertThisInitialized(_this3), "evt_close", void 0);

    _defineProperty(_assertThisInitialized(_this3), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this3), "height", void 0);

    _defineProperty(_assertThisInitialized(_this3), "width", void 0);

    _defineProperty(_assertThisInitialized(_this3), "clickHandler", function (e, key) {
      if (typeof _this3.props.onClick === 'function') {
        _this3.props.onClick(key, _this3.data);
      }

      _this3.hide(e);
    });

    _defineProperty(_assertThisInitialized(_this3), "hide", function (e) {
      _this3.mainDom.classList.add('d-none');

      window.removeEventListener("mousedown", _this3.hide);

      if (typeof _this3.evt_close === 'function') {
        _this3.evt_close(e);
      }
    });

    _this3.childMenus = [];
    _this3.domId = 'menu-' + _Common["default"].RandomString(16);
    _this3.evt_close = _this3.props.onClose;
    _this3.state = {
      menu_list: _this3.initMenuData()
    };
    return _this3;
  }

  _createClass(Menu, [{
    key: "initMenuData",
    value: function initMenuData() {
      var _this4 = this;

      var data = [];

      _react["default"].Children.map(this.props.children, function (item) {
        if (item && item.type === MenuItem) {
          // const props = Object.assign(item.props, { parent: this })
          data.push(_objectSpread({}, item.props, {
            parent: _this4
          }));
        }
      });

      return data;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("mousedown", this.hide);
    }
  }, {
    key: "show",
    value: function show(option) {
      var _this5 = this;

      if (option === null || option === void 0 ? void 0 : option.menu_list) {
        option.evt = Object.assign({}, option.evt);
        this.setState({
          menu_list: option.menu_list
        }, function () {
          _this5.showHandler(option);
        });
      } else {
        this.showHandler(option);
      }
    }
  }, {
    key: "showHandler",
    value: function showHandler(option) {
      var _option$data, _option$close;

      this.data = (_option$data = option.data) !== null && _option$data !== void 0 ? _option$data : '';
      this.evt_close = (_option$close = option.close) !== null && _option$close !== void 0 ? _option$close : null;
      this.mainDom.classList.remove('d-none');
      this.position(option);
      window.addEventListener("mousedown", this.hide, false);
    }
  }, {
    key: "position",
    value: function position(option) {
      this.height = this.mainDom.clientHeight;
      this.width = this.mainDom.clientWidth;

      if (option.type === 'mouse') {
        var fixPosition = this.fixPositionScreen(option.evt.pageX, option.evt.pageY);
        this.mainDom.style.top = fixPosition.y + 'px';
        this.mainDom.style.left = fixPosition.x + 'px';
      } else {
        var pos = (0, _Common.GetDomXY)(option.evt.currentTarget);
        var fixPos;

        switch (option.type) {
          case 'dom-top':
            fixPos = {
              x: pos.left,
              y: pos.top - this.height
            };
            break;

          case 'dom-bottom':
            fixPos = {
              x: pos.left,
              y: pos.top + option.evt.currentTarget.clientHeight
            };
            break;

          case 'dom-left':
            fixPos = {
              x: pos.left - this.width,
              y: pos.top
            };
            break;

          case 'dom-right':
          default:
            fixPos = this.fixPositionScreen(pos.left + option.evt.currentTarget.clientWidth, pos.top, -option.evt.currentTarget.clientWidth, option.evt.currentTarget.clientHeight);
        }

        this.mainDom.style.top = fixPos.y + 'px';
        this.mainDom.style.left = fixPos.x + 'px';
      }
    }
  }, {
    key: "fixPositionScreen",
    value: function fixPositionScreen(x, y) {
      var offx = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var offy = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var fx = x,
          fy = y;

      if (y + this.mainDom.clientHeight > document.documentElement.scrollTop + document.documentElement.clientHeight) {
        fy = fy - this.mainDom.clientHeight + offy;
        if (fy < 0) fy = 0;
      }

      if (x + this.mainDom.clientWidth > document.documentElement.scrollLeft + document.documentElement.clientWidth) {
        fx = fx - this.mainDom.clientWidth + offx;
        if (fx < 0) fx = 0;
      }

      return {
        x: fx,
        y: fy
      };
    }
  }, {
    key: "closeChild",
    value: function closeChild(e) {
      this.childMenus.forEach(function (item) {
        if (item && typeof item.hide === 'function') {
          item.hide(e);
          item.closeChild(e);
        }
      });
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-menu border shadow d-none';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      var _ref, _this$props$zIndex;

      var base = {
        zIndex: (_ref = (_this$props$zIndex = this.props.zIndex) === null || _this$props$zIndex === void 0 ? void 0 : _this$props$zIndex.toString()) !== null && _ref !== void 0 ? _ref : ''
      };

      if (this.props.width) {
        base.width = this.props.width;
      }

      return base;
    }
  }, {
    key: "render",
    value: function render() {
      var _this6 = this;

      var content = _react["default"].createElement("div", {
        onContextMenu: function onContextMenu(e) {
          e.stopPropagation();
        },
        id: this.domId,
        ref: function ref(c) {
          return _this6.mainDom = c;
        },
        onMouseDown: function onMouseDown(e) {
          e.preventDefault();
          e.stopPropagation();
        },
        className: this.getClasses(),
        style: this.getStyles()
      }, this.state.menu_list.map(function (item, idx) {
        return _react["default"].createElement(MenuItem, _extends({
          key: idx,
          parent: _this6
        }, item));
      }));

      return _reactDom["default"].createPortal(content, document.body);
    }
  }]);

  return Menu;
}(_react["default"].Component);

exports.Menu = Menu;

_defineProperty(Menu, "Item", MenuItem);

_defineProperty(Menu, "defaultProps", {
  zIndex: 1200
});

var _default = Menu;
exports["default"] = _default;
//# sourceMappingURL=Menu.js.map
