/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RImage = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/Image.less");

var _Icon = _interopRequireDefault(require("./Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RImage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(RImage, _React$Component);

  function RImage(props) {
    var _this;

    _classCallCheck(this, RImage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RImage).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "clickHandler", function (e) {
      if (typeof _this.props.onClick === 'function') {
        _this.props.onClick(e);
      }
    });

    var is_load,
        src = null;

    if (typeof _this.props.src === 'string' || !_this.props.src) {
      is_load = false;
    } else {
      is_load = true;
      src = _this.props.src;
    }

    _this.state = {
      isLoad: is_load,
      src: src,
      display: ''
    };
    return _this;
  }

  _createClass(RImage, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.state.isLoad) {
        this.loadImage(this.props.src);
      }
    }
  }, {
    key: "loadImage",
    value: function loadImage(src) {
      var _this2 = this;

      var img = new Image();

      img.onload = function () {
        img.onload = null;
        var dis = '';

        if (img.width > img.height) {
          dis = 'horizontal';
        } else if (img.height > img.width) {
          dis = 'vertical';
        }

        _this2.setState({
          isLoad: true,
          src: img.src,
          display: dis
        });
      };

      img.src = src;
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _this3 = this;

      if (nextProps.src !== this.props.src) {
        var is_load = true;

        if (typeof nextProps.src === 'string' || !nextProps.src) {
          is_load = false;
        }

        this.setState({
          isLoad: is_load
        }, function () {
          _this3.loadImage(nextProps.src);
        });
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-image d-flex';

      if (this.props.border || !this.state.isLoad) {
        base = (0, _bind["default"])(base, 'border');
      }

      if (this.props.circle) {
        base = (0, _bind["default"])(base, 'ck-image-circle');
      }

      if (this.props.onClick) {
        base = (0, _bind["default"])(base, 'ck-image-click');
      }

      if (this.props.display === 'center') {
        if (this.state.display === 'vertical') {
          base = (0, _bind["default"])(base, 'align-items-center');
        } else if (this.state.display === 'horizontal') {
          base = (0, _bind["default"])(base, 'justify-content-center');
        } else {
          base = (0, _bind["default"])(base, 'justify-content-center', 'align-items-center');
        }
      } else {
        base = (0, _bind["default"])(base, 'justify-content-center', 'align-items-center');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      var base = {
        height: '100px',
        width: '100px'
      };

      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.width) {
        base.width = this.props.width;
      }

      return base;
    }
  }, {
    key: "render",
    value: function render() {
      var imgStyle = {};

      if (this.props.display === 'center') {
        if (this.state.display === 'vertical') {
          imgStyle.maxWidth = '100%';
        } else {
          imgStyle.maxHeight = '100%';
        }
      } else {
        imgStyle.maxWidth = '100%';
        imgStyle.maxHeight = '100%';
      }

      return _react["default"].createElement("div", {
        className: this.getClasses(),
        onClick: this.clickHandler,
        style: this.getStyles()
      }, this.state.isLoad ? _react["default"].createElement("img", {
        src: this.state.src,
        style: imgStyle
      }) : _react["default"].createElement(_Icon["default"], {
        icon: "image"
      }));
    }
  }]);

  return RImage;
}(_react["default"].Component);

exports.RImage = RImage;

_defineProperty(RImage, "defaultProps", {
  display: 'center'
});

var _default = RImage;
exports["default"] = _default;
//# sourceMappingURL=RImage.js.map
