/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Scroll = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Common = require("./Common");

require("./css/Scroll.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Scroll =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Scroll, _React$PureComponent);

  function Scroll(props) {
    var _this$props$speed;

    var _this;

    _classCallCheck(this, Scroll);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Scroll).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "wheelSpeed", void 0);

    _defineProperty(_assertThisInitialized(_this), "scrollProportion", void 0);

    _defineProperty(_assertThisInitialized(_this), "offsetTop", void 0);

    _defineProperty(_assertThisInitialized(_this), "isShow", void 0);

    _defineProperty(_assertThisInitialized(_this), "x", void 0);

    _defineProperty(_assertThisInitialized(_this), "y", void 0);

    _defineProperty(_assertThisInitialized(_this), "scrollX", void 0);

    _defineProperty(_assertThisInitialized(_this), "scrollY", void 0);

    _defineProperty(_assertThisInitialized(_this), "domLeft", void 0);

    _defineProperty(_assertThisInitialized(_this), "domXY", void 0);

    _defineProperty(_assertThisInitialized(_this), "parent", void 0);

    _defineProperty(_assertThisInitialized(_this), "parentDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "showDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "dom", void 0);

    _defineProperty(_assertThisInitialized(_this), "scrollDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "showHandler", function () {
      _this.scrollProportion = _this.parentDom.offsetHeight / _this.parentDom.scrollHeight;

      if (_this.scrollProportion === 1) {
        _this.isShow = false;

        _this.dom.classList.add('d-none');

        return;
      }

      _this.dom.classList.remove('d-none');

      _this.scrollDom.style.height = _this.parentDom.offsetHeight * _this.scrollProportion + 'px';
      _this.dom.style.top = _this.parentDom.offsetTop + 'px';
      _this.dom.style.height = _this.parentDom.offsetHeight + 'px';
      _this.scrollDom.style.top = _this.parentDom.scrollTop * _this.scrollProportion + 'px';

      _this.dom.classList.add('ck-scroll-show');

      _this.isShow = true;
      _this.domXY = (0, _Common.GetDomXY)(_this.dom);
    });

    _defineProperty(_assertThisInitialized(_this), "hideHandler", function () {
      _this.isShow = false;

      _this.dom.classList.remove('ck-scroll-show');
    });

    _defineProperty(_assertThisInitialized(_this), "scrollHandler", function (e) {
      if (e.deltaY !== 0) {
        e.preventDefault();
      }

      if (!_this.isShow) {
        _this.showHandler();
      }

      var scrollTop = _this.parentDom.scrollTop + e.deltaY * _this.wheelSpeed;

      _this.setScrollTop(scrollTop);

      if (typeof _this.props.onScroll === 'function') {
        _this.props.onScroll(scrollTop);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "scrollClickHandler", function (e) {
      _this.setBarTop(e.pageY - _this.domXY.top - _this.scrollDom.clientHeight / 2); // this.scrollX = parseInt(this.scrollDom.style.left);
      // this.scrollY = parseInt(this.scrollDom.style.top);
      // this.x = parseInt(e.pageX);
      // this.y = parseInt(e.pageY);


      _this.beginDragHandler(e);
    });

    _defineProperty(_assertThisInitialized(_this), "beginDragHandler", function (e) {
      e.stopPropagation();
      e.preventDefault();
      _this.scrollY = parseInt(_this.scrollDom.style.top);
      _this.y = e.pageY;

      _this.dom.classList.add('ck-scroll-scrolling-v');

      window.addEventListener('mousemove', _this.moveDragHandler, false);
      window.addEventListener('mouseup', _this.endDragHandler, false);
    });

    _defineProperty(_assertThisInitialized(_this), "moveDragHandler", function (e) {
      _this.setBarTop(e.pageY - _this.y + _this.scrollY);
    });

    _defineProperty(_assertThisInitialized(_this), "endDragHandler", function () {
      _this.dom.classList.remove('ck-scroll-scrolling-v');

      window.removeEventListener('mousemove', _this.moveDragHandler);
      window.removeEventListener('mouseup', _this.endDragHandler);
    });

    _this.parent = _this.props.parent || undefined; //scroll speed

    _this.wheelSpeed = ((_this$props$speed = _this.props.speed) !== null && _this$props$speed !== void 0 ? _this$props$speed : 1) / 10; //scroll height to component height Proportion

    _this.scrollProportion = 0; //scroll offset top

    _this.offsetTop = 0; //display status

    _this.isShow = false; //move xy

    _this.x = 0;
    _this.y = 0;
    _this.scrollX = 0;
    _this.scrollY = 0; //scroll top xy

    _this.domXY = {}; //

    _this.state = {
      show: false
    };
    return _this;
  }

  _createClass(Scroll, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initParentEvent();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.parentDom) {
        this.parentDom.classList.remove('ck-scroll-over');
        this.parentDom.removeEventListener('wheel', this.scrollHandler);
        this.parentDom.removeEventListener('mouseover', this.showHandler);
        this.parentDom.removeEventListener('mouseout', this.hideHandler);
      } // this.dom.addEventListener("mousedown",this.beginDragHandler,false);


      this.dom.removeEventListener("wheel", this.scrollHandler);
    }
  }, {
    key: "initParentEvent",
    value: function initParentEvent() {
      if (this.parent) {
        this.parentDom = this.parent;
      } else if (this.props.selector) {
        var dom = document.querySelector(this.props.selector);

        if (dom === null) {
          throw "can not found selector \"".concat(this.props.selector, "\"");
        }

        this.parentDom = dom;
      } else {
        this.parentDom = this.dom.parentNode;
      }

      if (this.parentDom) {
        this.parentDom.classList.add('ck-scroll-over');
        this.parentDom.addEventListener('wheel', this.scrollHandler, {
          passive: false
        });
        this.parentDom.addEventListener('mouseover', this.showHandler, false);
        this.parentDom.addEventListener('mouseout', this.hideHandler, false);
      } // this.dom.addEventListener("mousedown",this.beginDragHandler,false);


      this.dom.addEventListener("wheel", this.scrollHandler, {
        passive: false
      });
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-scroll ck-scroll-v';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "setScrollTop",
    value: function setScrollTop(top) {
      this.parentDom.scrollTop = top;
      this.scrollDom.style.top = this.parentDom.scrollTop * this.scrollProportion + 'px';
    }
  }, {
    key: "setBarTop",
    value: function setBarTop(top) {
      if (top < 0) {
        top = 0;
      } else if (top > this.dom.clientHeight - this.scrollDom.clientHeight) {
        top = this.dom.clientHeight - this.scrollDom.clientHeight;
      }

      this.scrollDom.style.top = top + 'px';
      this.parentDom.scrollTop = top / this.scrollProportion;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this2.dom = c;
        },
        className: this.getClasses(),
        onMouseDown: this.scrollClickHandler
      }, _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this2.scrollDom = c;
        },
        className: "ck-scroll-bar ck-scroll-bar-v",
        onMouseDown: this.beginDragHandler
      }));
    }
  }]);

  return Scroll;
}(_react["default"].PureComponent);

exports.Scroll = Scroll;

_defineProperty(Scroll, "defaultProps", {
  speed: 5,
  align: 'right'
});

var _default = Scroll;
exports["default"] = _default;
//# sourceMappingURL=Scroll.js.map
