/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Table = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TableHeader = _interopRequireDefault(require("./TableHeader"));

var _TableHeaderRow = _interopRequireDefault(require("./TableHeaderRow"));

var _CCheckbox = _interopRequireDefault(require("./CCheckbox"));

var _Button = _interopRequireDefault(require("./Button"));

var _Common = _interopRequireWildcard(require("./Common"));

var _Icon = _interopRequireDefault(require("./Icon"));

require("./css/Table.less");

var _Scroll = _interopRequireDefault(require("./Scroll"));

var _HScroll = _interopRequireDefault(require("./HScroll"));

var _Menu = _interopRequireDefault(require("./Menu"));

var _common = require("./components/common");

var _Load = _interopRequireDefault(require("./Load"));

var _Drag = _interopRequireDefault(require("./components/Drag"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Table =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Table, _React$Component);

  // drag split
  function Table(props) {
    var _this$props$data, _this$props$select;

    var _this;

    _classCallCheck(this, Table);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Table).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "treeOpens", void 0);

    _defineProperty(_assertThisInitialized(_this), "select_all", void 0);

    _defineProperty(_assertThisInitialized(_this), "selectRows", void 0);

    _defineProperty(_assertThisInitialized(_this), "treeHeader", void 0);

    _defineProperty(_assertThisInitialized(_this), "sortList", void 0);

    _defineProperty(_assertThisInitialized(_this), "afterFields", void 0);

    _defineProperty(_assertThisInitialized(_this), "beforeFields", void 0);

    _defineProperty(_assertThisInitialized(_this), "tableHeaderRows", void 0);

    _defineProperty(_assertThisInitialized(_this), "headers", void 0);

    _defineProperty(_assertThisInitialized(_this), "width", void 0);

    _defineProperty(_assertThisInitialized(_this), "beforeHoldWidth", void 0);

    _defineProperty(_assertThisInitialized(_this), "afterHoldWidth", void 0);

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "rootDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "stickyDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "tableHeader", void 0);

    _defineProperty(_assertThisInitialized(_this), "afterHeader", void 0);

    _defineProperty(_assertThisInitialized(_this), "beforeHeader", void 0);

    _defineProperty(_assertThisInitialized(_this), "beforeBody", void 0);

    _defineProperty(_assertThisInitialized(_this), "afterBody", void 0);

    _defineProperty(_assertThisInitialized(_this), "tableBody", void 0);

    _defineProperty(_assertThisInitialized(_this), "hScroll", void 0);

    _defineProperty(_assertThisInitialized(_this), "menu", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainMenu", void 0);

    _defineProperty(_assertThisInitialized(_this), "allchk", void 0);

    _defineProperty(_assertThisInitialized(_this), "renderCheckes", void 0);

    _defineProperty(_assertThisInitialized(_this), "drag", void 0);

    _defineProperty(_assertThisInitialized(_this), "headerSplits", void 0);

    _defineProperty(_assertThisInitialized(_this), "dragColumnLeft", void 0);

    _defineProperty(_assertThisInitialized(_this), "dragWidth", void 0);

    _defineProperty(_assertThisInitialized(_this), "split", void 0);

    _defineProperty(_assertThisInitialized(_this), "stickyHeader", function () {
      var hxy;

      if (_this.stickyDom === document.documentElement) {
        hxy = (0, _Common.GetDomXY)(_this.mainDom);
      } else {
        hxy = (0, _Common.GetDomXY)(_this.mainDom, _this.stickyDom);
      }

      if (hxy.top < _this.stickyDom.scrollTop) {
        var y = _this.stickyDom.scrollTop - hxy.top - 2;
        if (_this.tableHeader) _this.tableHeader.style.transform = "translate3d(0,".concat(y, "px,10px)");

        if (_this.afterHeader) {
          _this.afterHeader.style.transform = "translate3d(0,".concat(y, "px,10px)");
        }

        if (_this.beforeHeader) {
          _this.beforeHeader.style.transform = "translate3d(0,".concat(y, "px,10px)");
        }
      } else {
        if (_this.tableHeader) _this.tableHeader.style.transform = "translate3d(0,0,10px)";

        if (_this.afterHeader) {
          _this.afterHeader.style.transform = "translate3d(0,0,10px)";
        }

        if (_this.beforeHeader) {
          _this.beforeHeader.style.transform = "translate3d(0,0,10px)";
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "holdShow", function () {
      if (_this.mainDom.clientWidth >= _this.tableBody.clientWidth) {
        if (_this.afterBody && _this.afterBody.parentNode) {
          _this.afterBody.parentNode.style.right = _this.mainDom.clientWidth - _this.tableBody.clientWidth + 'px';
        }
      } else {
        if (_this.afterBody && _this.afterBody.parentNode) {
          _this.afterBody.parentNode.style.right = '0';
        }
      }

      _this.holdShadow();
    });

    _defineProperty(_assertThisInitialized(_this), "selectAll", function (checked) {
      _this.select_all = checked;
      var selectRows = {};

      _this.renderCheckes.forEach(function (item) {
        item.ref.setChecked(_this.select_all);

        _this.setRowCheck(_this.select_all, item.idx);

        selectRows[item.idx] = checked;
      });

      var _this$checkAllCheckHa = _this.checkAllCheckHalf(),
          _this$checkAllCheckHa2 = _slicedToArray(_this$checkAllCheckHa, 2),
          half = _this$checkAllCheckHa2[1];

      _this.setState({
        selectRows: selectRows,
        selectAll: checked,
        selectHalf: half
      }, function () {
        if (typeof _this.props.onCheckAll === "function") {
          _this.props.onCheckAll(checked, _this.getSelectRows());
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "scrollHandler", function (e) {
      if (_this.beforeBody) {
        var dom = document.querySelector('.ck-table-hold-before');
        dom.scrollTop = e.currentTarget.scrollTop; // let head = this.beforeBody.querySelector('thead')
        // if (head) head.style.transform = `translate3d(0,${e.currentTarget.scrollTop}px,10px)`;
      }

      if (_this.afterBody) {
        var _dom = document.querySelector('.ck-table-hold-after');

        _dom.scrollTop = e.currentTarget.scrollTop; // let head = this.afterBody.querySelector('thead')
        // if (head) head.style.transform = `translate3d(0,${e.currentTarget.scrollTop}px,10px)`;
      }

      _this.holdShadow();
    });

    _defineProperty(_assertThisInitialized(_this), "touchStartX", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchStartY", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchScrollX", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchScrollY", void 0);

    _defineProperty(_assertThisInitialized(_this), "touchStartHandler", function (e) {
      if (e.touches.length === 1) {
        var touch = e.touches[0];
        _this.touchStartX = touch.pageX;
        _this.touchStartY = touch.pageY;
        _this.touchScrollX = _this.mainDom.scrollLeft;
        _this.touchScrollY = _this.mainDom.scrollTop;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "touchMoveHandler", function (e) {
      if (e.touches.length === 1) {
        e.preventDefault();
        var touch = e.touches[0];
        var diffX = _this.touchStartX - touch.pageX;
        var diffY = _this.touchStartY - touch.pageY;

        _this.mainDom.scrollTo({
          left: _this.touchScrollX + diffX,
          top: _this.touchScrollY + diffY,
          behavior: 'auto'
        }); // this.mainDom.scrollLeft = this.touchScrollX + diffX;
        // this.mainDom.scrollTop = this.touchScrollY + diffY;

      }
    });

    _defineProperty(_assertThisInitialized(_this), "hoverAuthorRow", function (e) {
      var _row$parentNode;

      var row = e.currentTarget;
      var id = (row === null || row === void 0 ? void 0 : (_row$parentNode = row.parentNode) === null || _row$parentNode === void 0 ? void 0 : _row$parentNode.parentNode).id;

      if (id.includes('after') || id.includes('before')) {
        // this.tableBody.tBodies[0].rows[row.sectionRowIndex].style.backgroundColor = (e.type === "mouseover" ? 'var(--bs-table-hover-bg)' : '')
        _this.tableBody.tBodies[0].rows[row.sectionRowIndex].classList.toggle('ck-table-hover');

        if (id.includes('after') && _this.beforeBody) {
          _this.beforeBody.tBodies[0].rows[row.sectionRowIndex].classList.toggle('ck-table-hover'); // this.beforeBody.tBodies[0].rows[row.sectionRowIndex].style.backgroundColor = (e.type === "mouseover" ? 'var(--bs-table-hover-bg)' : '')

        } else if (id.includes('before') && _this.afterBody) {
          _this.afterBody.tBodies[0].rows[row.sectionRowIndex].classList.toggle('ck-table-hover'); // this.afterBody.tBodies[0].rows[row.sectionRowIndex].style.backgroundColor = (e.type === "mouseover" ? 'var(--bs-table-hover-bg)' : '')

        }
      } else {
        if (_this.beforeBody) {
          // this.beforeBody.tBodies[0].rows[row.sectionRowIndex].style.backgroundColor = (e.type === "mouseover" ? 'var(--bs-table-hover-bg)' : '')
          _this.beforeBody.tBodies[0].rows[row.sectionRowIndex].classList.toggle('ck-table-hover');
        }

        if (_this.afterBody) {
          // this.afterBody.tBodies[0].rows[row.sectionRowIndex].style.backgroundColor = (e.type === "mouseover" ? 'var(--bs-table-hover-bg)' : '')
          _this.afterBody.tBodies[0].rows[row.sectionRowIndex].classList.toggle('ck-table-hover');
        }
      }
    });

    _this.state = {
      data: (_this$props$data = _this.props.data) !== null && _this$props$data !== void 0 ? _this$props$data : [],
      select: (_this$props$select = _this.props.select) !== null && _this$props$select !== void 0 ? _this$props$select : false,
      tree: {},
      refresh: typeof _this.props.onRefresh === 'function',
      selectRows: {},
      selectAll: false,
      selectHalf: false
    };
    _this.headerSplits = [];
    _this.treeOpens = {};
    _this.select_all = false;
    _this.selectRows = [];
    _this.treeHeader = {};
    _this.sortList = {};
    _this.afterFields = [];
    _this.beforeFields = [];
    _this.tableHeaderRows = [];
    _this.headers = [];
    _this.width = 0;
    _this.beforeHoldWidth = 0;
    _this.afterHoldWidth = 0;

    _this.initTableWidth(_this.props.children);

    _this.domId = 'table-' + _Common["default"].RandomString(16);

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    return _this;
  }

  _createClass(Table, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mainDom.addEventListener('scroll', this.scrollHandler, false);
      window.addEventListener('resize', this.holdShow, false);
      this.syncRowsHeight();
      this.holdShow();
      this.sticky();
      this.touchScrollHandler();
      this.bindSplit();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.holdShow, false);
      this.unSticky();
      this.unTouchScrollHandler();
    } //表头随页面滚动自动浮动到顶部

  }, {
    key: "sticky",
    value: function sticky() {
      if (!this.props.sticky) return;
      var parentScroll = (0, _Common.hasScrolledParent)(this.mainDom);

      if (parentScroll === undefined) {
        document.addEventListener('scroll', this.stickyHeader, false);
        this.stickyDom = document.documentElement;
      } else {
        parentScroll.addEventListener('scroll', this.stickyHeader, false);
        this.stickyDom = parentScroll;
      }
    }
  }, {
    key: "unSticky",
    value: function unSticky() {
      if (this.props.sticky && this.stickyDom) {
        if (this.stickyDom === document.documentElement) {
          document.removeEventListener('scroll', this.stickyHeader);
        } else {
          this.stickyDom.removeEventListener('scroll', this.stickyHeader);
        }
      }
    }
  }, {
    key: "syncRowsHeight",
    value: function syncRowsHeight() {
      // 同步多表头高度
      if (this.beforeBody) {
        var _this$beforeBody, _this$beforeBody$tHea, _this$tableBody, _this$tableBody$tHead;

        this.setRowsHeight((_this$beforeBody = this.beforeBody) === null || _this$beforeBody === void 0 ? void 0 : (_this$beforeBody$tHea = _this$beforeBody.tHead) === null || _this$beforeBody$tHea === void 0 ? void 0 : _this$beforeBody$tHea.rows, (_this$tableBody = this.tableBody) === null || _this$tableBody === void 0 ? void 0 : (_this$tableBody$tHead = _this$tableBody.tHead) === null || _this$tableBody$tHead === void 0 ? void 0 : _this$tableBody$tHead.rows); // this.beforeBody.tHead.rows[0].style.height = this.tableBody.tHead.rows[0].clientHeight + 'px';
      } // 同步多表头高度


      if (this.afterBody) {
        var _this$afterBody, _this$afterBody$tHead, _this$tableBody2, _this$tableBody2$tHea;

        this.setRowsHeight((_this$afterBody = this.afterBody) === null || _this$afterBody === void 0 ? void 0 : (_this$afterBody$tHead = _this$afterBody.tHead) === null || _this$afterBody$tHead === void 0 ? void 0 : _this$afterBody$tHead.rows, (_this$tableBody2 = this.tableBody) === null || _this$tableBody2 === void 0 ? void 0 : (_this$tableBody2$tHea = _this$tableBody2.tHead) === null || _this$tableBody2$tHea === void 0 ? void 0 : _this$tableBody2$tHea.rows);
      } //同步内容高度


      if (this.afterBody || this.beforeBody) {
        for (var _i2 = 0; _i2 < this.tableBody.tBodies[0].rows.length; _i2++) {
          var _ref, _this$beforeBody2, _ref2, _this$afterBody2;

          // console.log(beforeTable.tBodies[0].rows[i]);
          var bodyHeight = this.tableBody.tBodies[0].rows[_i2].getBoundingClientRect().height;

          var beforeHeight = (_ref = (_this$beforeBody2 = this.beforeBody) === null || _this$beforeBody2 === void 0 ? void 0 : _this$beforeBody2.tBodies[0].rows[_i2].getBoundingClientRect().height) !== null && _ref !== void 0 ? _ref : 0;
          var afterHeight = (_ref2 = (_this$afterBody2 = this.afterBody) === null || _this$afterBody2 === void 0 ? void 0 : _this$afterBody2.tBodies[0].rows[_i2].getBoundingClientRect().height) !== null && _ref2 !== void 0 ? _ref2 : 0;
          var height = Math.max(bodyHeight, beforeHeight, afterHeight); // if (this.beforeBody) {
          //     height = this.beforeBody.tBodies[0].rows[i].getBoundingClientRect().height > height ? this.beforeBody.tBodies[0].rows[i].getBoundingClientRect().height : height
          // }
          // if (this.afterBody) {
          //     height = this.afterBody.tBodies[0].rows[i].getBoundingClientRect().height > height ? this.afterBody.tBodies[0].rows[i].getBoundingClientRect().height : height
          // }

          if (this.beforeBody) {
            this.beforeBody.tBodies[0].rows[_i2].style.height = height + 'px';
          }

          if (this.afterBody) {
            this.afterBody.tBodies[0].rows[_i2].style.height = height + 'px';
          }

          this.tableBody.tBodies[0].rows[_i2].style.height = height + 'px'; // if (this.tableBody.tBodies[0].rows[i].getBoundingClientRect().height < height) {
          //     this.tableBody.tBodies[0].rows[i].style.height = height + 'px';
          // }
        }
      }

      if (this.tableHeader) {// this.tableHeader.style.transform = `translateY(${e.currentTarget.scrollTop}px)`;
        // this.tableHeader.style.transform = `translate3d(0,0,10px)`;
      }
    }
  }, {
    key: "setRowsHeight",
    value: function setRowsHeight(rows, heightRows) {
      for (var _i3 = 0; _i3 < rows.length; _i3++) {
        rows[_i3].style.height = heightRows[_i3].getBoundingClientRect().height + 'px';
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.syncRowsHeight();
      this.holdShow();
      this.unSticky();
      this.sticky();
      this.bindSplit();
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (this.props.data !== nextProps.data) {
        var _nextProps$data, _nextProps$data2;

        // this.select_all = false;
        // this.selectRows = [];
        // if (this.allchk) {
        //     this.allchk.setChecked(false);
        //     this.allchk.setHalf(false);
        var treeData = {};
        this.treeOpens = {};
        this.initTreeData((_nextProps$data = nextProps.data) !== null && _nextProps$data !== void 0 ? _nextProps$data : [], treeData);
        this.setState({
          data: (_nextProps$data2 = nextProps.data) !== null && _nextProps$data2 !== void 0 ? _nextProps$data2 : [],
          selectAll: false,
          selectHalf: false,
          selectRows: {},
          tree: treeData
        }, function () {
          if (_this2.hScroll) {
            _this2.hScroll.initAlignParent();
          }
        });
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextProps.children !== this.props.children) {
        this.headers = [];
        this.initTableWidth(nextProps.children);
      }

      if (nextState.selectRows !== this.state.selectRows) {
        return true;
      }

      if (nextState.data !== this.state.data) {
        return true;
      }

      if (nextProps.loading !== this.props.loading) {
        return true;
      }

      return nextState.tree !== this.state.tree;
    }
  }, {
    key: "initTreeData",
    value: function initTreeData(data, treeData) {
      var _this3 = this;

      data.forEach(function (item, i) {
        if (item.children) {
          treeData[i.toString()] = item.children;

          _this3.initTreeData(item.children, treeData);
        }
      });
      return treeData;
    }
  }, {
    key: "initTableWidth",
    value: function initTableWidth(children) {
      var _this4 = this;

      // if (this.props.width) {
      this.width = 0;
      this.beforeHoldWidth = 0;
      this.afterHoldWidth = 0;
      var reg = /(\d+)(px|rem|cm|mm|pt)$/;
      var unit = 0;

      _react["default"].Children.map(children, function (item) {
        if (!item) {
          return;
        }

        if (item.type === _TableHeader["default"]) {
          if (item.props.hide) {
            return;
          }

          var matchs;

          if (item.props.width && item.props.width.match) {
            var _parseInt;

            matchs = item.props.width.match(reg);
            _this4.width += parseInt(matchs[1]);
            unit = (_parseInt = parseInt(matchs[2])) !== null && _parseInt !== void 0 ? _parseInt : 0;
          } else {
            unit = 100;
          }

          _this4.headers.push(item);

          if (item.props.beforeHold) {
            if (matchs) {
              _this4.beforeHoldWidth += parseInt(matchs[1]);
            }

            _this4.beforeFields.push(item.props.field);
          } else if (item.props.afterHold) {
            if (matchs) {
              _this4.afterHoldWidth += parseInt(matchs[1]);
            }

            _this4.afterFields.push(item.props.field);
          }
        } else if (item.type === _TableHeaderRow["default"]) {
          _this4.initTableHeaderRow(item);
        } else if (item.type === _Menu["default"]) {
          _this4.menu = _react["default"].cloneElement(item, {
            ref: function ref(c) {
              _this4.mainMenu = c;
            }
          }); // this.menu.props.ref=(c)=>{this.mainMenu=c};
        }
      });

      if (this.props.select) {
        this.width += 30;
        this.beforeHoldWidth += 30;
      }

      if (this.props.serialNumber) {
        this.width += 30;
        this.beforeHoldWidth += 30;
      }

      this.width += unit;
      this.beforeHoldWidth += unit;
      this.afterHoldWidth += unit;
    }
  }, {
    key: "initTableHeaderRow",
    value: function initTableHeaderRow(row) {
      var headerRow = [];

      _react["default"].Children.map(row.props.children, function (item) {
        if (!item) {
          return;
        }

        if (item.type === _TableHeader["default"]) {
          headerRow.push(item);
        }
      });

      this.tableHeaderRows.push(headerRow);
    }
    /**
    * binding column split
    */

  }, {
    key: "bindSplit",
    value: function bindSplit() {
      var _this5 = this;

      if (this.props.move && this.props.width) {
        var list = this.rootDom.querySelectorAll('.column-split');
        list.forEach(function (split) {
          if (!_this5.drag) {
            _this5.dragColumnLeft = 0;
            _this5.dragWidth = 0;
            _this5.drag = new _Drag["default"](_this5.split, split, {
              start: function start(dragDom, eventDom) {
                var _ref3, _document$querySelect;

                _this5.rootDom.classList.add('user-select-none');

                var column_key = eventDom.dataset.key;
                _this5.dragWidth = parseInt((_ref3 = (_document$querySelect = document.querySelector("#".concat(column_key))) === null || _document$querySelect === void 0 ? void 0 : _document$querySelect.width) !== null && _ref3 !== void 0 ? _ref3 : "0");

                var xy = _Common["default"].GetDomXY(eventDom, _this5.rootDom); // this.dragWidth      = parseInt((eventDom?.parentNode as HTMLElement).style.width);


                _this5.dragColumnLeft = xy.left - _this5.mainDom.scrollLeft;
                dragDom.style.left = _this5.dragColumnLeft + 'px';
                dragDom.classList.remove('d-none'); // console.log(this.dragWidth,this.dragColumnLeft,dragDom)

                return true;
              },
              move: function move(_move) {
                if (_this5.dragWidth + (_move.x - _this5.dragColumnLeft) < 50) {
                  _move.x = _this5.dragColumnLeft - _this5.dragWidth + 50;
                }
              },
              end: function end(dragDom, eventDom) {
                dragDom.classList.add('d-none');
                var column_key = eventDom.dataset.key;

                var diff = parseInt(dragDom.style.left) - _this5.dragColumnLeft;

                _this5.width = _this5.width + diff; // this.tableHeader.style.width = `${this.width}px`;
                // this.tableBody.style.width = `${this.width}px`;

                document.querySelectorAll("#".concat(column_key)).forEach(function (item) {
                  // console.log(`${this.dragWidth + diff}px`,`#${column_key}`);
                  item.width = "".concat(_this5.dragWidth + diff, "px");
                });

                _this5.syncRowsHeight();

                _this5.rootDom.classList.remove('user-select-none');

                return true;
              }
            });
          } else {
            _this5.drag.setEventDom(split);
          }
        });
      }
    } //checkbox handler

  }, {
    key: "changeHandler",
    value: function changeHandler(row, i) {
      var _this6 = this;

      return function (checked) {
        _this6.setRowCheck(checked, i);

        var _this6$checkAllCheckH = _this6.checkAllCheckHalf(),
            _this6$checkAllCheckH2 = _slicedToArray(_this6$checkAllCheckH, 2),
            allChecked = _this6$checkAllCheckH2[0],
            half = _this6$checkAllCheckH2[1];

        var selectRows = Object.assign({}, _this6.state.selectRows);
        selectRows[i] = checked;

        _this6.setState({
          selectRows: selectRows,
          selectAll: allChecked,
          selectHalf: half
        });

        if (typeof _this6.props.onCheck === "function") {
          _this6.props.onCheck(checked, row);
        }
      };
    }
  }, {
    key: "checkAllCheckHalf",
    value: function checkAllCheckHalf() {
      if (!this.allchk) {
        return [false, false];
      }

      if (this.selectRows.length > 0 && this.selectRows.length !== this.renderCheckes.length) {
        // this.allchk.setHalf(true);
        return [false, true];
      }

      if (this.selectRows.length === 0) {
        return [false, false]; // this.allchk.setHalf(false);
        // this.allchk.setChecked(false);
      } else if (this.selectRows.length === this.renderCheckes.length) {
        return [true, false]; // this.allchk.setHalf(false);
        // this.allchk.setChecked(true);
      }

      return [false, false];
    }
  }, {
    key: "setRowCheck",
    value: function setRowCheck(checked, rowIdx) {
      // let selectedIdx;
      // let chkRow = this.renderCheckes.find((item,idx)=>{
      //     return item.idx === rowIdx
      // })
      if (checked) {
        if (!this.selectRows.includes(rowIdx)) {
          this.selectRows.push(rowIdx);
        } // this.selectRows[rowIdx] = this.state.data[rowIdx];

      } else {
        if (this.selectRows.includes(rowIdx)) {
          this.selectRows.splice(this.selectRows.indexOf(rowIdx), 1);
        }
      } // if (checked) {
      //     ReactDOM.findDOMNode(chkRow.ref).parentNode.parentNode.classList.add('ck-table-selected');
      // } else {
      //     ReactDOM.findDOMNode(chkRow.ref).parentNode.parentNode.classList.remove('ck-table-selected');
      // }
      // console.log(this.selectRows)

    }
  }, {
    key: "refCheck",
    value: function refCheck(row, rowIdx) {
      var _this7 = this;

      return function (c) {
        if (!c) return;

        _this7.renderCheckes.push({
          ref: c,
          idx: rowIdx,
          data: row
        }); // this.renderRows.push(row)

      };
    } //table row check handler

  }, {
    key: "clickHandler",
    value: function clickHandler(row, i) {
      var _this8 = this;

      return function () {
        if (typeof _this8.props.onClick === 'function') {
          _this8.props.onClick(row, i);
        }
      };
    } //table head sort

  }, {
    key: "sortHandler",
    value: function sortHandler(field, callback) {
      var _this9 = this;

      return function (e) {
        var dom = e.currentTarget;
        var sort_type;

        if (dom.dataset.sort) {
          sort_type = dom.dataset.sort === 'asc' ? 'desc' : 'asc';
        } else {
          sort_type = 'asc';
        }

        callback(field, sort_type);
        dom.dataset.sort = sort_type;
        _this9.sortList[field] = sort_type;
        var child = dom.querySelector('i');
        child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
        child.classList.add('fa-sort-alpha-' + (sort_type === 'asc' ? 'down' : 'up'));
      };
    }
  }, {
    key: "getSelectRows",

    /**
     * 得到所有选中的行
     */
    value: function getSelectRows() {
      var _this10 = this;

      return this.selectRows.map(function (item) {
        var chkItem = _this10.renderCheckes.find(function (chk) {
          return chk.idx === item;
        });

        return chkItem.data;
      });
    }
    /**
     * 设置选中的行
     */

  }, {
    key: "setSelectRows",
    value: function setSelectRows(key, list) {
      var _this11 = this;

      var selectRows = {};
      this.renderCheckes.forEach(function (chk) {
        var checked = list.includes(chk.data[key]);
        chk.ref.setChecked(checked);

        _this11.setRowCheck(checked, chk.idx);

        selectRows[chk.idx] = checked;
      });

      var _this$checkAllCheckHa3 = this.checkAllCheckHalf(),
          _this$checkAllCheckHa4 = _slicedToArray(_this$checkAllCheckHa3, 2),
          allChecked = _this$checkAllCheckHa4[0],
          half = _this$checkAllCheckHa4[1];

      this.setState({
        selectRows: selectRows,
        selectAll: allChecked,
        selectHalf: half
      });
    }
  }, {
    key: "getClasses",
    value: function getClasses(css) {
      var base = 'table ck-table'; //striped

      if (this.props.striped) {
        base = (0, _classnames["default"])(base, 'table-striped');
      } //theme


      if (this.props.theme !== undefined) {
        base = (0, _classnames["default"])(base, 'table-' + _common.Theme[this.props.theme]);
      } //bordered


      if (this.props.bordered) {
        base = (0, _classnames["default"])(base, 'table-bordered');
      } //hover


      if (this.props.hover) {
        base = (0, _classnames["default"])(base, 'table-hover');
      } //sm


      if (this.props.sm) {
        base = (0, _classnames["default"])(base, 'table-sm');
      }

      if (this.props.fontSm) {
        base = (0, _classnames["default"])(base, 'table-font-sm');
      } //responsive


      if (this.props.responsive) {
        base = (0, _classnames["default"])(base, 'table-responsive');
      } //fixed


      if (this.props.fixed || this.props.scroll || this.props.width) {
        base = (0, _classnames["default"])(base, 'fixed');
      }

      if (this.props.height) {
        base = (0, _classnames["default"])(base, 'sticky-thead');
      }

      return (0, _classnames["default"])(base, css);
    }
  }, {
    key: "getMainClass",
    value: function getMainClass() {
      var base = 'ck-table-main';

      if (this.props.scroll) {
        base = (0, _classnames["default"])(base, 'ck-table-scroll');
      }

      if (this.props.height) {
        base = (0, _classnames["default"])(base, 'ck-table-scroll-height');
      }

      if (this.props.width) {
        base = (0, _classnames["default"])(base, 'ck-table-scroll-width');
      }

      return base;
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      //default style
      var base = {}; //width

      if (this.props.width) {
        base.width = this.props.width;
      } //height


      if (this.props.height) {
        base.height = this.props.height;
      }

      return base;
    }
  }, {
    key: "getMainStyle",
    value: function getMainStyle() {
      //default style
      var base = {};

      if (this.props.absolute) {
        var _this$props$y, _this$props$x;

        base.position = 'absolute';
        base.top = (_this$props$y = this.props.y) !== null && _this$props$y !== void 0 ? _this$props$y : '';
        base.left = (_this$props$x = this.props.x) !== null && _this$props$x !== void 0 ? _this$props$x : '';
      }

      if (this.props.height) {
        base.overflow = 'hidden';
        base.height = this.props.height;
      }

      return _Common["default"].extend(base, this.props.style);
    }
  }, {
    key: "getTableStyles",
    value: function getTableStyles(width) {
      var base = {};

      if (this.props.width) {
        base.width = this.width.toString() + 'px';
      }

      if (width) {
        base.width = width.toString() + 'px';
      }

      if (this.props.height || this.props.sticky) {
        base.transformStyle = 'preserve-3d';
      }

      return base;
    }
  }, {
    key: "getHeaderClasses",
    value: function getHeaderClasses() {
      var base = '';

      if (this.props.headerTheme !== undefined) {
        base = 'table-' + _common.Theme[this.props.headerTheme];
      }

      if (this.props.sticky) {
        base = (0, _classnames["default"])(base, 'sticky-thead-row');
      }

      return (0, _classnames["default"])(base, this.props.headClass);
    }
  }, {
    key: "touchScrollHandler",
    //touch scroll event
    value: function touchScrollHandler() {
      if ('ontouchstart' in document.documentElement) {
        this.mainDom.addEventListener('touchstart', this.touchStartHandler);
        this.mainDom.addEventListener('touchmove', this.touchMoveHandler);
      }
    }
  }, {
    key: "unTouchScrollHandler",
    value: function unTouchScrollHandler() {
      if ('ontouchstart' in document.documentElement) {
        this.mainDom.removeEventListener('touchstart', this.touchStartHandler);
        this.mainDom.removeEventListener('touchmove', this.touchMoveHandler);
      }
    }
  }, {
    key: "holdShadow",
    value: function holdShadow() {
      if (this.beforeBody) {
        var parent = this.beforeBody.parentNode;

        if (this.mainDom.scrollLeft === 0) {
          parent.classList.remove('shadow');
        } else {
          parent.classList.add('shadow');
        }
      }

      if (this.afterBody) {
        var _parent = this.afterBody.parentNode;
        var diff = this.mainDom.scrollWidth - this.mainDom.clientWidth;

        if (diff === this.mainDom.scrollLeft || diff - 1 === this.mainDom.scrollLeft) {
          _parent.classList.remove('shadow');
        } else {
          _parent.classList.add('shadow');
        }
      }
    }
  }, {
    key: "setHeight",
    value: function setHeight(height) {
      this.mainDom.style.height = height;
      this.rootDom.style.height = height;
    }
  }, {
    key: "render",
    value: function render() {
      var _this12 = this;

      var divClass = 'position-relative';

      if (this.props.height) {
        divClass += ' ck-table-fixed-h';
      }

      divClass = (0, _classnames["default"])(divClass, this.props.className);
      this.renderCheckes = [];
      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this12.rootDom = c;
        },
        className: divClass,
        id: this.domId + '_main',
        style: this.getMainStyle()
      }, _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this12.mainDom = c;
        },
        id: this.domId,
        className: this.getMainClass(),
        style: this.getStyles()
      }, this.state.refresh ? _react["default"].createElement(_Button["default"], {
        className: "ck-table-refresh-btn",
        icon: "sync-alt",
        onClick: this.props.onRefresh,
        size: "sm",
        theme: _common.Theme.dark
      }, this.props.refreshText) : null, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this12.tableBody = c;
        },
        id: this.domId + '_body',
        className: this.getClasses(),
        style: this.getTableStyles()
      }, this.props.width ? this.renderCol() : null, this.props.header ? this.renderHeader() : null, _react["default"].createElement("tbody", {
        key: "main"
      }, this.renderBody(this.beforeFields.concat(this.afterFields), 'main')))), this.renderHoldBefore(), this.renderHoldAfter(), this.props.height ? _react["default"].createElement(_Scroll["default"], {
        selector: "#".concat(this.domId)
      }) : null, this.props.width ? _react["default"].createElement(_HScroll["default"], {
        ref: function ref(c) {
          return _this12.hScroll = c;
        },
        showSelector: "#".concat(this.domId, "_main"),
        selector: "#".concat(this.domId),
        alignParent: true
      }) : null, this.menu, _react["default"].createElement("div", {
        className: 'ck-table-loading ' + (this.props.loading ? '' : 'd-none')
      }, _react["default"].createElement("div", {
        className: "text-center mt-5"
      }, _react["default"].createElement(_Load["default"], null))), _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this12.split = c;
        },
        className: "ck-table-split d-none"
      }));
    }
  }, {
    key: "renderCol",
    value: function renderCol(filter, filter_type) {
      var _this13 = this;

      return _react["default"].createElement("colgroup", null, this.props.serialNumber && filter_type !== 'after' ? _react["default"].createElement("col", {
        width: "30px"
      }) : null, this.state.select && filter_type !== 'after' ? _react["default"].createElement("col", {
        width: '30px'
      }) : null, this.headers.map(function (item, idx) {
        //hold column
        if (filter && filter.indexOf(item.props.field) === -1) {
          return null;
        }

        if (item.props.hide) {
          return null;
        }

        return _react["default"].createElement("col", {
          key: idx,
          id: _this13.domId + '-' + idx,
          width: item.props.width
        });
      }));
    }
  }, {
    key: "renderHeaderRow",
    value: function renderHeaderRow(filter, filter_type) {
      var _this14 = this;

      if (this.tableHeaderRows.length <= 0) return null;
      var headers = [];
      this.tableHeaderRows.forEach(function (list) {
        var offset = 0; // if (index === 0) {

        if (_this14.props.serialNumber) offset++;
        if (_this14.props.select) offset++; // }

        var totalCols = 0;
        headers.push(_react["default"].createElement("tr", null, offset > 0 && filter_type !== 'after' ? _react["default"].createElement("th", {
          colSpan: offset
        }) : null, list.map(function (item, idx) {
          var colsCount = item.props.cols;
          if (filter && totalCols >= filter.length) return null;

          if (filter && colsCount > filter.length) {
            colsCount = filter.length;
          }

          totalCols += item.props.cols;
          return _react["default"].createElement("th", {
            key: idx,
            colSpan: colsCount,
            className: "colspan",
            style: {
              textAlign: item.props.align
            }
          }, item.props.text);
        })));
      });
      return headers;
    }
  }, {
    key: "renderHeader",
    value: function renderHeader(filter, filter_type) {
      var _this15 = this;

      return _react["default"].createElement("thead", {
        ref: function ref(c) {
          if (!filter) {
            _this15.tableHeader = c;
          } else {
            switch (filter_type) {
              case 'after':
                _this15.afterHeader = c;
                break;

              case 'before':
                _this15.beforeHeader = c;
                break;
            }
          }
        },
        className: this.getHeaderClasses()
      }, this.renderHeaderRow(filter, filter_type), _react["default"].createElement("tr", null, this.props.serialNumber && filter_type !== 'after' ? _react["default"].createElement("th", {
        style: {
          width: '30px',
          textAlign: 'center'
        }
      }) : null, this.state.select && filter_type !== 'after' ? _react["default"].createElement("th", {
        className: "chk",
        style: {
          textAlign: 'center',
          width: '30px'
        }
      }, _react["default"].createElement(_CCheckbox["default"], {
        ref: function ref(c) {
          _this15.allchk = c;
        },
        onChange: this.selectAll,
        checked: this.state.selectAll,
        half: this.state.selectHalf
      })) : null, this.headers.map(function (item, key) {
        var _item$props$sort;

        if (!item || item.props.hide) {
          return null;
        } //hold column


        if (filter && filter.indexOf(item.props.field) === -1) {
          return null;
        }

        var align = _this15.props.headerAlign || item.props.align || _this15.props.align;
        var style = {
          'textAlign': align !== null && align !== void 0 ? align : ''
        };

        if (item.props.width) {
          style.width = item.props.width;
        }

        if (item.props.textOver) {
          style.textOverflow = 'ellipsis';
        }

        var sort_icon = 'sort';

        if (item.props.sort) {
          _this15.sortList[item.props.field] = item.props.sort;
        }

        if (_this15.sortList[item.props.field]) {
          sort_icon = 'sort-alpha-' + (_this15.sortList[item.props.field] === 'asc' ? 'down' : 'up');
        }

        return _react["default"].createElement("th", {
          key: key,
          "data-key": 'head_' + key,
          style: style
        }, item.props.onSort ? _react["default"].createElement("a", {
          className: "sort",
          "data-sort": (_item$props$sort = item.props.sort) !== null && _item$props$sort !== void 0 ? _item$props$sort : undefined,
          onClick: _this15.sortHandler(item.props.field, item.props.onSort)
        }, item.props.text, " ", _react["default"].createElement(_Icon["default"], {
          icon: sort_icon
        })) : item.props.text, _this15.props.move ? _react["default"].createElement("span", {
          "data-key": _this15.domId + '-' + key,
          className: "column-split"
        }) : null);
      })));
    }
  }, {
    key: "renderBody",
    value: function renderBody(filter, filter_type) {
      var _this16 = this;

      if (!this.state.data || this.state.data.length <= 0) {
        var columnCount = _react["default"].Children.count(this.props.children);

        if (this.props.select) columnCount += 1;
        if (this.props.serialNumber) columnCount += 1;
        return _react["default"].createElement("tr", {
          key: 0
        }, _react["default"].createElement("td", {
          key: 0,
          align: "center",
          colSpan: columnCount
        }, this.props.emptyText));
      }

      return this.state.data.map(function (row, i) {
        return _this16.renderRow(row, i.toString(), null, 0, filter, filter_type);
      });
    }
  }, {
    key: "formatSn",
    value: function formatSn(i) {
      if (typeof i === 'string') {
        var arr = i.split('-');

        for (var _i4 = 0; _i4 < arr.length; _i4++) {
          arr[_i4] = (parseInt(arr[_i4]) + 1).toString();
        }

        return arr.join('-');
      } else {
        return i + 1;
      }
    }
  }, {
    key: "renderRow",
    value: function renderRow(row, i, parentRow, indent, filter, filter_type) {
      var _this17 = this;

      var tree_status = 'close';

      if (row.children) {
        if (!this.treeOpens[i] || this.treeOpens[i] === 'open') {
          // this.state.tree[i] = row.children;
          tree_status = 'open';
        } else {
          // delete this.state.tree[i];
          tree_status = 'close';
        }
      }

      var dynamic_tree = typeof this.props.onClickTree === 'function';
      var classString = this.props.onClick ? 'click-row' : '';

      if (this.props.sticky) {// classString += ' sticky-thead-row'    
      }

      classString += this.state.selectRows[i] ? ' ck-table-selected' : '';
      return _react["default"].createElement(_react["default"].Fragment, {
        key: i
      }, _react["default"].createElement("tr", {
        key: i,
        onContextMenu: function onContextMenu(e) {
          if (!_this17.mainMenu) return;
          e.preventDefault();

          _this17.mainMenu.show({
            evt: e,
            type: 'mouse',
            data: row
          });
        },
        onMouseOver: this.hoverAuthorRow,
        onMouseOut: this.hoverAuthorRow,
        className: classString,
        onClick: this.clickHandler(row, i)
      }, this.props.serialNumber && filter_type !== 'after' ? _react["default"].createElement("th", {
        className: 'sn text-nowrap' + (this.props.headerTheme ? ' table-' + _common.Theme[this.props.headerTheme] : ''),
        style: {
          textAlign: 'center',
          width: '30px'
        }
      }, this.formatSn(i)) : null, this.state.select && filter_type !== 'after' ? _react["default"].createElement("td", {
        className: "chk",
        style: {
          textAlign: 'center',
          width: '30px'
        }
      }, filter_type === 'main' && this.beforeFields.length > 0 ? null : _react["default"].createElement(_CCheckbox["default"], {
        ref: this.refCheck(row, i),
        onChange: this.changeHandler(row, i),
        checked: !!this.state.selectRows[i]
      })) : null, this.headers.map(function (item, key) {
        var _ref4;

        if (!item || item.props.hide) {
          return null;
        } //set style


        var style = _objectSpread({}, _this17.props.columnStyle);

        style.textAlign = (_ref4 = item.props.align || _this17.props.align) !== null && _ref4 !== void 0 ? _ref4 : '';

        if (item.props.width) {
          style.width = item.props.width;
        } //hold column


        if (filter) {
          if (filter_type === 'main') {
            if (filter.includes(item.props.field)) {
              return _react["default"].createElement("td", {
                className: _this17.props.truncate ? 'text-truncate' : '',
                style: style,
                key: 'col_' + key
              });
            }
          } else {
            if (!filter.includes(item.props.field)) {
              return null;
            }
          }
        } //set tree


        var tree, parent;

        if (item.props.tree) {
          var is_tree = typeof item.props.tree === "function" ? item.props.tree(row) : item.props.tree;

          if (parentRow) {
            parent = [];

            for (var _i5 = 0; _i5 < indent; _i5++) {
              parent.push(_react["default"].createElement("span", {
                key: _i5,
                className: "me-4"
              }));
            }
          }

          if (!is_tree) {
            tree = _react["default"].createElement("i", {
              className: "me-1 far fa-plus-square opacity-0"
            });
          } else {
            tree = _react["default"].createElement(_Icon["default"], {
              "data-open": tree_status,
              onClick: function onClick(e) {
                var target = e.currentTarget;

                if (target.dataset.open === 'close') {
                  if (typeof _this17.props.onClickTree === 'function') {
                    _this17.props.onClickTree(row, function (data) {
                      if (!data) {
                        return;
                      }

                      var tree = Object.assign({}, _this17.state.tree);
                      tree[i] = data; // this.state.tree = null;

                      _this17.setState({
                        tree: tree
                      });
                    });
                  } else {
                    _this17.treeOpens[i] = 'open';

                    var _tree = Object.assign({}, _this17.state.tree);

                    _tree[i] = row.children; // this.state.tree = null;

                    _this17.setState({
                      tree: _tree
                    });
                  }

                  target.dataset.open = 'open';
                  target.classList.remove('fa-plus-square');
                  target.classList.add('fa-minus-square');
                } else {
                  _this17.treeOpens[i] = 'close';
                  target.dataset.open = 'close';
                  target.classList.remove('fa-minus-square');
                  target.classList.add('fa-plus-square');

                  var _tree2 = Object.assign({}, _this17.state.tree);

                  delete _tree2[i]; // this.state.tree = null;

                  _this17.setState({
                    tree: _tree2
                  });
                }
              },
              className: "me-1 text-primary",
              icon: tree_status === 'open' ? 'minus-square' : 'plus-square',
              iconType: "regular"
            });
          }
        }

        if (item.props.children) {
          return _react["default"].createElement("td", {
            className: item.props.className,
            style: style,
            key: 'col_' + key
          }, parent, tree, _react["default"].cloneElement(item.props.children, {
            text: item.props.text,
            row: row,
            value: row[item.props.field]
          }));
        } else {
          return _react["default"].createElement("td", {
            className: _this17.props.truncate ? 'text-truncate' : '',
            style: style,
            onDoubleClick: function onDoubleClick() {
              if (typeof item.props.onDbClick === 'function') {
                item.props.onDbClick(item.props.field, row);
              }
            },
            key: 'col_' + key
          }, parent, dynamic_tree || row.children ? tree : null, item.props.onFormat ? item.props.onFormat(row[item.props.field], row, i, key, item.props.field) : row[item.props.field]);
        }
      })), this.props.tree ? this.renderTreeRow(row, i, indent + 1, filter, filter_type) : null);
    }
  }, {
    key: "renderTreeRow",
    value: function renderTreeRow(row, i, indent, filter, filter_type) {
      var _this18 = this;

      var data = this.state.tree[i];

      if (!data) {
        return null;
      }

      return data.map(function (item, idx) {
        return _this18.renderRow(item, "".concat(i, "-").concat(idx), row, indent, filter, filter_type);
      });
    }
  }, {
    key: "renderHoldBefore",
    value: function renderHoldBefore() {
      var _this19 = this;

      if (!this.state.data) return null;

      if (this.beforeFields.length <= 0) {
        return null;
      }

      var style = {};

      if (this.props.height) {
        style.overflow = 'hidden';
      }

      return _react["default"].createElement("div", {
        className: "ck-table-hold-before",
        style: style
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this19.beforeBody = c;
        },
        id: this.domId + '_before_body',
        className: this.getClasses(),
        style: this.getTableStyles(this.beforeHoldWidth)
      }, this.renderCol(this.beforeFields), this.props.header ? this.renderHeader(this.beforeFields, 'before') : null, _react["default"].createElement("tbody", null, this.renderBody(this.beforeFields))));
    }
  }, {
    key: "renderHoldAfter",
    value: function renderHoldAfter() {
      var _this20 = this;

      if (!this.state.data) return null;

      if (this.afterFields.length <= 0) {
        return null;
      }

      var style = {};

      if (this.props.height) {
        style.overflow = 'hidden';
      }

      return _react["default"].createElement("div", {
        className: "ck-table-hold-after shadow",
        style: style
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this20.afterBody = c;
        },
        id: this.domId + '_after_body',
        className: this.getClasses(''),
        style: this.getTableStyles(this.afterHoldWidth)
      }, this.renderCol(this.afterFields, 'after'), this.props.header ? this.renderHeader(this.afterFields, 'after') : null, _react["default"].createElement("tbody", null, this.renderBody(this.afterFields, 'after'))));
    }
  }]);

  return Table;
}(_react["default"].Component);

exports.Table = Table;

_defineProperty(Table, "Header", _TableHeader["default"]);

_defineProperty(Table, "HeaderRow", _TableHeaderRow["default"]);

_defineProperty(Table, "defaultProps", {
  data: [],
  dataCount: 1,
  select: false,
  header: true,
  currentPage: 1,
  hover: true,
  striped: true,
  fixed: false,
  align: 'left',
  emptyText: 'Not data',
  serialNumber: true,
  truncate: false,
  headerTheme: _common.Theme.primary,
  sticky: true
});

var _default = Table;
exports["default"] = _default;
//# sourceMappingURL=Table.js.map
