/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Tabs = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Common = _interopRequireDefault(require("./Common"));

require("./css/Tabs.less");

var _Icon = _interopRequireDefault(require("./Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Tabs =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Tabs, _React$PureComponent);

  function Tabs(props) {
    var _this$props$showTab, _this$props$disabled;

    var _this;

    _classCallCheck(this, Tabs);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Tabs).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (e) {
      var _dataset$tabid;

      _this.setState({
        currentShow: (_dataset$tabid = e.currentTarget.dataset.tabid) !== null && _dataset$tabid !== void 0 ? _dataset$tabid : ''
      }, function () {
        if (typeof _this.props.onSelect === 'function') {
          _this.props.onSelect(_this.state.currentShow);
        }
      });
    });

    _this.state = {
      currentShow: (_this$props$showTab = _this.props.showTab) !== null && _this$props$showTab !== void 0 ? _this$props$showTab : '',
      disabled: (_this$props$disabled = _this.props.disabled) !== null && _this$props$disabled !== void 0 ? _this$props$disabled : false
    };
    _this.domId = 'tabs-' + _Common["default"].RandomString(16);

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    return _this;
  }

  _createClass(Tabs, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var stateData = {};

      if (nextProps.showTab) {
        stateData.currentShow = nextProps.showTab;
      }

      if (nextProps.disabled !== undefined) {
        stateData.disabled = nextProps.disabled;
      }

      this.setState(stateData);
    } // shouldComponentUpdate(nextProps, nextState) {
    //     if (this.state.currentShow !== nextState.currentShow) {
    //         return true;
    //     }
    //     return this.state.disabled !== nextState.disabled
    // }

  }, {
    key: "setSelect",
    value: function setSelect(tab_id) {
      this.setState({
        currentShow: tab_id
      });
    }
  }, {
    key: "getMainClasses",
    value: function getMainClasses() {
      var base = 'ck-tabs';

      if (this.props.sm) {
        base = (0, _bind["default"])(base, 'ck-tabs-sm');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'nav ck-tabs-header';

      if (this.props.pills) {
        base = (0, _bind["default"])(base, 'nav-pills');
      } else {
        base = (0, _bind["default"])(base, 'nav-tabs');
      }

      return (0, _bind["default"])(base);
    }
  }, {
    key: "getStyle",
    value: function getStyle() {
      //default style
      var base = {}; //width

      if (this.props.width) {
        base.width = this.props.width;
      } //height


      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.absolute) {
        var _this$props$y, _this$props$x;

        base.position = 'absolute';
        base.top = (_this$props$y = this.props.y) !== null && _this$props$y !== void 0 ? _this$props$y : '';
        base.left = (_this$props$x = this.props.x) !== null && _this$props$x !== void 0 ? _this$props$x : '';

        if (_typeof(this.props.position) === 'object') {
          base.top = this.props.position.top || this.props.y;
          base.left = this.props.position.left || this.props.x;
          base.right = this.props.position.right || 'unset';
          base.bottom = this.props.position.bottom || 'unset';

          if (this.props.position.left && this.props.position.right) {
            base.width = 'unset';
          }

          if (this.props.position.top && this.props.position.bottom) {
            base.height = 'unset';
          }
        }
      }

      return _Common["default"].extend(base, this.props.style);
    }
  }, {
    key: "renderTabs",
    value: function renderTabs() {
      var _this2 = this;

      return _react["default"].createElement("ul", {
        className: this.getClasses(),
        id: "".concat(this.domId)
      }, _react["default"].Children.map(this.props.children, function (item, index) {
        var class_name = 'nav-link';

        if (!_this2.state.currentShow && index === 0) {
          // this.state.currentShow = item.props.id as string;
          class_name = (0, _bind["default"])(class_name, 'active');
        } else if (_this2.state.currentShow === item.props.id) {
          class_name = (0, _bind["default"])(class_name, 'active');
        }

        if (item.props.disabled || _this2.props.disabled) {
          class_name = (0, _bind["default"])(class_name, 'disabled');
        }

        var clickEvt = undefined;

        if (!item.props.disabled) {
          if (typeof item.props.onClick === 'function') {
            clickEvt = function clickEvt(e) {
              item.props.onClick(e.currentTarget.dataset.tabid);
            };
          } else {
            clickEvt = _this2.selectHandler;
          }
        }

        var is_close = typeof _this2.props.onClose === 'function';
        return _react["default"].createElement("li", {
          className: "nav-item"
        }, _react["default"].createElement("a", {
          className: class_name,
          "data-tabid": item.props.id,
          onClick: clickEvt
        }, is_close ? _react["default"].createElement(_Icon["default"], {
          className: "me-2",
          icon: "times-circle",
          onClick: function onClick(e) {
            e.stopPropagation();

            if (_this2.state.currentShow === item.props.id) {
              _this2.setState({
                currentShow: ''
              });
            }

            if (typeof _this2.props.onClose === 'function') _this2.props.onClose(item.props.id, index);
          }
        }) : null, item.props.text));
      }));
    }
  }, {
    key: "renderContents",
    value: function renderContents() {
      var _this3 = this;

      if (!this.props.content) {
        return null;
      }

      var base = 'tab-content ck-tabs-content';

      if (this.props.border) {
        base = (0, _bind["default"])(base, 'ck-tabs-border');
      }

      var style = {}; // if (this.props.absolute && this.props.height) {
      //     style.marginTop = this.props.sm ? '-28px' : '-42px';
      // }

      return _react["default"].createElement("div", {
        className: base,
        id: "".concat(this.domId, "-content"),
        style: style
      }, _react["default"].Children.map(this.props.children, function (item, index) {
        var class_name = 'tab-pane';

        if (item.props.fade) {
          class_name = (0, _bind["default"])(class_name, 'fade');
        }

        if (!_this3.state.currentShow && index === 0) {
          class_name = (0, _bind["default"])(class_name, 'show', 'active');
        } else if (_this3.state.currentShow === item.props.id) {
          class_name = (0, _bind["default"])(class_name, 'show', 'active');
        }

        return _react["default"].createElement("div", {
          className: class_name,
          id: item.props.id
        }, item.props.children);
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: this.getMainClasses(),
        style: this.getStyle()
      }, this.renderTabs(), this.renderContents());
    }
  }]);

  return Tabs;
}(_react["default"].PureComponent);

exports.Tabs = Tabs;

_defineProperty(Tabs, "defaultProps", {
  border: true,
  content: true,
  showTab: '',
  disabled: false
});

var _default = Tabs;
exports["default"] = _default;
//# sourceMappingURL=Tabs.js.map
