/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.TextArea = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _Common = _interopRequireDefault(require("./Common"));

require("./css/TextArea.less");

var _ButtonGroup = _interopRequireDefault(require("./ButtonGroup"));

var _Button = _interopRequireDefault(require("./Button"));

var _Dropdown = _interopRequireDefault(require("./Dropdown"));

var _Drag = _interopRequireDefault(require("./components/Drag"));

var _common = require("./components/common");

var _Icon = _interopRequireDefault(require("./Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TextArea =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TextArea, _React$Component);

  function TextArea(props) {
    var _this;

    _classCallCheck(this, TextArea);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TextArea).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "input", void 0);

    _defineProperty(_assertThisInitialized(_this), "resizeImg", void 0);

    _defineProperty(_assertThisInitialized(_this), "resizeRB", void 0);

    _defineProperty(_assertThisInitialized(_this), "resize", void 0);

    _defineProperty(_assertThisInitialized(_this), "currentResize", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "isFull", void 0);

    _defineProperty(_assertThisInitialized(_this), "fullBtn", void 0);

    _defineProperty(_assertThisInitialized(_this), "changeHandler", function (e) {
      _this.setState({
        value: e.target.value
      });

      if (_this.props.onChange && typeof _this.props.onChange === 'function') {
        _this.props.onChange(e.target.value, _assertThisInitialized(_this), e);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "inputHandler", function () {
      _this.setState({
        html: _this.input.innerHTML // value: this.input.innerHTML

      }, function () {
        if (_this.props.onChange && typeof _this.props.onChange === 'function') {
          _this.props.onChange(_this.state.html, _assertThisInitialized(_this));
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "pasteHandler", function (e) {
      e.stopPropagation();
      e.preventDefault();

      if (e.clipboardData.types.indexOf('Files') !== -1) {
        var file = e.clipboardData.files[0];

        _this.insertImage(file);
      } else {
        var paste = e.clipboardData.getData('text');
        paste = paste.replace(/\r\n/g, "\n");

        if (!/\n/.test(paste)) {
          _this.insertHtmlNode(document.createTextNode(paste));

          return;
        } // paste = paste.replace(/\s/g,"&nbsp;");


        var pasteContents = paste.split(/\n/);
        pasteContents.forEach(function (val) {
          if (val === '') {
            return;
          }

          var div = document.createElement("div");
          div.innerHTML = val.replace(/\s/g, "&nbsp;");

          _this.insertHtmlNode(div);
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "dropHandler", function (e) {
      e.stopPropagation();
      e.preventDefault();

      if (e.dataTransfer.files.length > 0) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = e.dataTransfer.files[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var file = _step.value;

            _this.insertImage(file);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "fullHandler", function () {
      if (_this.isFull) {
        var _this$mainDom$querySe;

        _this.isFull = false;
        document.body.classList.remove('full-none-scroll');

        _this.mainDom.classList.remove('ck-text-area-full');

        (_this$mainDom$querySe = _this.mainDom.querySelector('label')) === null || _this$mainDom$querySe === void 0 ? void 0 : _this$mainDom$querySe.classList.remove('d-none');

        _this.input.classList.remove('full-input');
      } else {
        var _this$mainDom$querySe2;

        _this.isFull = true;
        document.body.classList.add('full-none-scroll');

        _this.mainDom.classList.add('ck-text-area-full');

        (_this$mainDom$querySe2 = _this.mainDom.querySelector('label')) === null || _this$mainDom$querySe2 === void 0 ? void 0 : _this$mainDom$querySe2.classList.add('d-none');

        _this.input.classList.add('full-input');
      }

      _this.setState({
        isFull: !_this.state.isFull
      });
    });

    _defineProperty(_assertThisInitialized(_this), "bindingResize", function (e) {
      var elm = e.currentTarget;
      _this.currentResize = elm;
      elm.classList.add("img-selected");
      _this.resizeImg.style.width = elm.clientWidth + 2 + 'px';
      _this.resizeImg.style.height = elm.clientHeight + 2 + 'px';
      _this.resizeImg.style.left = elm.offsetLeft + 'px';
      _this.resizeImg.style.top = elm.offsetTop + 'px';
      _this.resizeRB.style.top = elm.clientHeight - 5 + 'px';
      _this.resizeRB.style.left = elm.clientWidth - 5 + 'px';

      _this.resizeImg.classList.remove('d-none');
    });

    _defineProperty(_assertThisInitialized(_this), "unBindingResize", function (e) {
      var elm = e.currentTarget;
      _this.currentResize = null;
      elm.classList.remove("img-selected");

      _this.resizeImg.classList.add('d-none');
    });

    _this.state = {
      html: _this.props.data,
      value: _this.props.data,
      isFull: false
    };
    _this.domId = 'text-area-' + _Common["default"].RandomString(16);

    if (_this.props.id) {
      _this.domId = _this.props.id;
    }

    return _this;
  }

  _createClass(TextArea, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.execCommand('insertBrOnReturn', false, "true");
      document.execCommand("styleWithCSS", false, "true");
      this.initImageResize();
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProp) {
      this.setState({
        value: nextProp.data,
        html: nextProp.data
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (this.state.isFull !== nextState.isFull) {
        return true;
      }

      if (this.props.disabled !== nextProps.disabled) {
        return true;
      }

      if (this.props.htmlMode) {
        // return true;
        return nextState.value !== this.state.html;
      }

      return nextState.value !== this.state.value;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this2 = this;

      if (this.props.htmlMode) {
        this.initImageResize();
        this.resizeContent();
        this.input.querySelectorAll("img").forEach(function (elm) {
          elm.addEventListener('focus', _this2.bindingResize, false);
          elm.addEventListener('blur', _this2.unBindingResize, false);
        });
      }
    } //resize content top

  }, {
    key: "resizeContent",
    value: function resizeContent() {// if (this.props.htmlMode && this.props.htmlBar) {
      //     this.input.style.top = -(this.mainDom.querySelector('.header-bar')?.clientHeight??0)+'px'
      // }
    }
  }, {
    key: "getValue",
    value: function getValue() {
      if (this.props.htmlMode) return this.state.html;
      return this.state.value;
    }
  }, {
    key: "setValue",
    value: function setValue(val) {
      if (this.props.htmlMode) {
        this.setState({
          value: val,
          html: val
        });
        return;
      }

      this.setState({
        value: val
      });
    }
  }, {
    key: "getMainClasses",
    value: function getMainClasses() {
      var base = 'form-group ck-text-area';

      if (this.props.absolute) {
        base = (0, _bind["default"])(base, 'position-absolute');
      } //html mode


      if (this.props.htmlMode) {
        base = (0, _bind["default"])(base, 'ck-text-html');
      } //full


      if (this.state.isFull) {
        base = (0, _bind["default"])(base, 'ck-text-area-full');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getMainStyles",
    value: function getMainStyles() {
      //default style
      var base = {}; //width

      if (this.props.width) {
        base.width = this.props.width;
      } //height
      // if (this.props.height) {
      //     base.height = this.props.height;
      // }


      if (this.props.absolute) {
        var _this$props$y, _this$props$x;

        base.top = (_this$props$y = this.props.y) !== null && _this$props$y !== void 0 ? _this$props$y : '';
        base.left = (_this$props$x = this.props.x) !== null && _this$props$x !== void 0 ? _this$props$x : '';
      }

      if (!this.props.label) {
        base.marginBottom = '0';
      }

      return _Common["default"].extend(base, this.props.style);
    }
  }, {
    key: "getInputClasses",
    value: function getInputClasses() {
      var base = 'form-control'; //readonly

      if (this.props.plaintext) {
        base = 'form-control-plaintext';
      } //size


      var size;

      switch (this.props.size) {
        case 'lg':
          size = 'form-control-lg';
          break;

        case 'sm':
          size = 'form-control-sm';
          break;

        case 'xs':
          size = 'ck-text-area-xs';
          break;

        default:
          size = '';
      }

      base = (0, _bind["default"])(base, size); //height
      // if (this.props.height) {
      //     base = classNames(base,'h-100')
      // }

      if (this.props.htmlMode) {
        base = (0, _bind["default"])(base, 'overflow-auto position-relative', this.props.htmlBar ? 'has-header-bar' : '');
      }

      return (0, _bind["default"])(base, size);
    }
    /*********************
     * Event
     *********************/

  }, {
    key: "insertImage",

    /*********************
     * edit html process method
     *********************/
    value: function insertImage(file) {
      var _this3 = this;

      var reg = /^image\/(png|jpg|jpeg|gif)/ig;

      if (!reg.test(file.type)) {
        // console.log('can not insert non-picture file');
        return;
      }

      var read = new FileReader();

      read.onload = function () {
        var img = document.createElement('img');
        img.src = read.result;
        img.tabIndex = 1;

        _this3.insertHtmlNode(img);

        img.addEventListener('focus', _this3.bindingResize, false);
        img.addEventListener('blur', _this3.unBindingResize, false);
      };

      read.readAsDataURL(file);
    }
  }, {
    key: "insertHtmlNode",
    value: function insertHtmlNode(node) {
      var selection = window.getSelection();
      if (!selection || !selection.rangeCount) return false;
      selection.deleteFromDocument();
      selection.getRangeAt(0).insertNode(node);
      selection.collapseToEnd();
      this.inputHandler();
    }
  }, {
    key: "execCommand",
    value: function execCommand(cmd, args) {
      document.execCommand(cmd, false, args);
    }
  }, {
    key: "initImageResize",
    value: function initImageResize() {
      var _this4 = this;

      this.resize = {};
      var resize, rightBottom;

      if (this.input.querySelector('.img-edit')) {
        resize = this.input.querySelector('.img-edit');
        rightBottom = resize.querySelector('.img-edit-point');
      } else {
        resize = document.createElement('div');
        rightBottom = document.createElement('div');
      }

      resize.className = "img-edit d-none";
      rightBottom.className = "img-edit-point";
      rightBottom.addEventListener("mousedown", function (e) {
        e.stopPropagation();
        e.preventDefault();
      }, false);
      new _Drag["default"](rightBottom, rightBottom, {
        start: function start() {
          _this4.resize.width = resize.clientWidth;
          _this4.resize.height = resize.clientHeight;
          return true;
        },
        move: function move(_move) {
          resize.style.width = _move.x + 7 + 'px';
          resize.style.height = _move.y + 7 + 'px';
        },
        end: function end() {
          if (_this4.currentResize) {
            _this4.currentResize.style.width = resize.style.width;
            _this4.currentResize.style.height = resize.style.height;
          }

          return true;
        }
      });
      resize.appendChild(rightBottom);
      this.input.appendChild(resize);
      this.resizeImg = resize;
      this.resizeRB = rightBottom;
    }
  }, {
    key: "renderLabel",

    /*********************
     * render method
     *********************/
    value: function renderLabel() {
      if (this.props.label === '') {
        return null;
      }

      return _react["default"].createElement("label", {
        htmlFor: this.domId
      }, this.props.label);
    }
  }, {
    key: "renderSummary",
    value: function renderSummary() {
      if (this.props.summary === '') {
        return null;
      }

      return _react["default"].createElement("small", {
        className: "form-text text-muted text-truncate"
      }, this.props.summary);
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this5.mainDom = c;
        },
        className: this.getMainClasses(),
        style: this.getMainStyles()
      }, this.renderLabel(), this.props.htmlMode ? this.renderHtmlEditIcon() : null, this.props.htmlMode ? this.renderHtmlEdit() : this.renderTextArea(), this.renderFullButton(), this.renderSummary());
    }
  }, {
    key: "renderTextArea",
    value: function renderTextArea() {
      var _this6 = this,
          _this$state$value;

      var style = {};

      if (this.props.height) {
        style.height = this.props.height;
      }

      var inputProps = _objectSpread({}, this.props);

      delete inputProps.absolute;
      delete inputProps.htmlBar;
      delete inputProps.plaintext;
      delete inputProps.htmlMode;
      return _react["default"].createElement("textarea", _extends({
        ref: function ref(c) {
          return _this6.input = c;
        }
      }, inputProps, {
        style: style,
        onChange: this.changeHandler,
        value: (_this$state$value = this.state.value) !== null && _this$state$value !== void 0 ? _this$state$value : '',
        className: this.getInputClasses(),
        id: this.domId
      }));
    }
  }, {
    key: "renderHtmlEdit",
    value: function renderHtmlEdit() {
      var _this7 = this;

      var style = {};

      if (this.props.height) {
        style.height = this.props.height;
      }

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this7.input = c;
        },
        contentEditable: !this.props.readOnly,
        id: this.domId,
        className: this.getInputClasses(),
        style: style,
        onInput: this.inputHandler,
        onPaste: this.pasteHandler // onDragOver={e=>{e.preventDefault();}}
        // onDragEnd={this.dragEndHandler}
        ,
        onDrop: this.dropHandler,
        dangerouslySetInnerHTML: {
          __html: this.getContent()
        }
      });
    }
  }, {
    key: "getContent",
    value: function getContent() {
      var _this$state$value2;

      if (!this.state.value && this.input) {
        this.input.innerHTML = '';
      }

      return (_this$state$value2 = this.state.value) !== null && _this$state$value2 !== void 0 ? _this$state$value2 : this.state.html;
    }
  }, {
    key: "renderHtmlEditIcon",
    value: function renderHtmlEditIcon() {
      var _this$props$size,
          _this8 = this;

      if (!this.props.htmlBar) {
        return null;
      }

      var size = (_this$props$size = this.props.size) !== null && _this$props$size !== void 0 ? _this$props$size : 'sm';
      var iconClass = 'icon-' + size;
      return _react["default"].createElement("div", {
        className: "header-bar"
      }, _react["default"].createElement(_ButtonGroup["default"], {
        className: "bg-white"
      }, _react["default"].createElement(_Button["default"], {
        className: iconClass,
        size: size,
        icon: "bold",
        outline: true,
        theme: _common.Theme.secondary,
        tip: "Bold",
        onClick: function onClick() {
          _this8.execCommand('bold');
        }
      }), _react["default"].createElement(_Button["default"], {
        className: iconClass,
        size: size,
        icon: "italic",
        outline: true,
        theme: _common.Theme.secondary,
        tip: "Italic",
        onClick: function onClick() {
          _this8.execCommand('italic');
        }
      }), _react["default"].createElement(_Button["default"], {
        className: iconClass,
        size: size,
        icon: "underline",
        outline: true,
        theme: _common.Theme.secondary,
        tip: "Underline",
        onClick: function onClick() {
          _this8.execCommand('underline');
        }
      }), _react["default"].createElement(_Button["default"], {
        className: iconClass,
        size: size,
        icon: "undo",
        outline: true,
        theme: _common.Theme.secondary,
        tip: "Undo",
        onClick: function onClick() {
          _this8.execCommand('undo');
        }
      }), _react["default"].createElement(_Button["default"], {
        className: iconClass,
        size: size,
        icon: "redo",
        outline: true,
        theme: _common.Theme.secondary,
        tip: "Redo",
        onClick: function onClick() {
          _this8.execCommand('redo', '');
        }
      }), _react["default"].createElement(_Dropdown["default"], {
        className: "btn-group",
        size: size,
        outline: true,
        icon: "text-height",
        data: [{
          text: 'x-Small',
          value: '1'
        }, {
          text: 'Small',
          value: '2'
        }, {
          text: 'Medium',
          value: '3'
        }, {
          text: 'Large',
          value: '4'
        }, {
          text: 'x-Large',
          value: '5'
        }, {
          text: 'xx-Large',
          value: '6'
        }, {
          text: 'xxx-Large',
          value: '7'
        }],
        onChange: function onChange(txt, val) {
          _this8.execCommand('fontSize', val);
        }
      }), _react["default"].createElement(_Dropdown["default"], {
        className: "btn-group",
        size: size,
        outline: true,
        icon: "highlighter",
        data: [['red', 'orange', 'yellow', 'green', 'blue', 'purple'], ['white', 'gray', 'black', 'brown', 'silver', 'purple']],
        grid: true,
        onChange: function onChange(txt, val) {
          _this8.execCommand('foreColor', val);
        }
      }), _react["default"].createElement(_Button["default"], {
        className: iconClass,
        size: size,
        icon: "eraser",
        outline: true,
        theme: _common.Theme.secondary,
        tip: "Clean",
        onClick: function onClick() {
          _this8.execCommand('removeFormat');
        }
      })));
    }
  }, {
    key: "renderFullButton",
    value: function renderFullButton() {
      var _this$props$size2,
          _this9 = this;

      var size = (_this$props$size2 = this.props.size) !== null && _this$props$size2 !== void 0 ? _this$props$size2 : 'sm';
      var iconClass = 'icon-' + size;
      return this.props.htmlMode ? _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this9.fullBtn = c;
        },
        className: 'full-btn' + (this.state.isFull ? ' full-status' : '')
      }, _react["default"].createElement(_Button["default"], {
        className: iconClass,
        id: this.domId + '-btn-full',
        size: size,
        icon: this.state.isFull ? 'compress-arrows-alt' : 'expand-arrows-alt',
        outline: true,
        theme: _common.Theme.secondary,
        tip: "Full Screen",
        onClick: this.fullHandler
      })) : _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this9.fullBtn = c;
        },
        className: 'full-btn-normal' + (this.state.isFull ? ' full-normal-status' : ''),
        onClick: this.fullHandler
      }, _react["default"].createElement(_Icon["default"], {
        icon: this.state.isFull ? 'times-circle' : "search"
      }));
    }
  }]);

  return TextArea;
}(_react["default"].Component);

exports.TextArea = TextArea;

_defineProperty(TextArea, "defaultProps", {
  label: '',
  data: null,
  summary: '',
  readOnly: false,
  htmlMode: false,
  htmlBar: true
});

var _default = TextArea;
exports["default"] = _default;
//# sourceMappingURL=TextArea.js.map
