/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Tree = void 0;

var _react = _interopRequireDefault(require("react"));

var _dedupe = _interopRequireDefault(require("classnames/dedupe"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _CCheckbox = _interopRequireDefault(require("./CCheckbox"));

require("./css/Tree.less");

var _Common = _interopRequireDefault(require("./Common"));

var _Svg = require("./components/Svg");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Tree =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Tree, _React$PureComponent);

  function Tree(props) {
    var _this$props$data, _this$props$id;

    var _this;

    _classCallCheck(this, Tree);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Tree).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "domId", void 0);

    _defineProperty(_assertThisInitialized(_this), "parents", void 0);

    _defineProperty(_assertThisInitialized(_this), "currentSelected", void 0);

    _defineProperty(_assertThisInitialized(_this), "checkObjList", void 0);

    _defineProperty(_assertThisInitialized(_this), "checkSelectList", void 0);

    _defineProperty(_assertThisInitialized(_this), "checkItems", void 0);

    _defineProperty(_assertThisInitialized(_this), "svgList", void 0);

    _defineProperty(_assertThisInitialized(_this), "checkedList", void 0);

    _defineProperty(_assertThisInitialized(_this), "mainDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (item, id) {
      return function (e) {
        if (typeof _this.props.onClick === 'function') {
          _this.props.onClick(e, item, id);
        }

        if (_this.props.showSelected && !_this.parents[id]) {
          var _this$mainDom, _e$currentTarget;

          var active = (_this$mainDom = _this.mainDom) === null || _this$mainDom === void 0 ? void 0 : _this$mainDom.querySelector('.active');

          if (active) {
            active.classList.remove('active');
          }

          if ((_e$currentTarget = e.currentTarget) === null || _e$currentTarget === void 0 ? void 0 : _e$currentTarget.parentNode) {
            var _e$currentTarget2;

            ((_e$currentTarget2 = e.currentTarget) === null || _e$currentTarget2 === void 0 ? void 0 : _e$currentTarget2.parentNode).classList.add('active');
          }
        }
      };
    });

    _defineProperty(_assertThisInitialized(_this), "dbClickHandler", function (item, id) {
      return function () {
        if (typeof _this.props.onDbClick === 'function') {
          var isShowChild = _this.props.onDbClick(item, id);

          if (isShowChild !== false) {
            _this.showChild(id);
          }
        } else {
          _this.showChild(id);
        }
      };
    });

    _defineProperty(_assertThisInitialized(_this), "iconHandler", function (item, id) {
      return function () {
        _this.showChild(id);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "menuHandler", function (item, id) {
      return function (e) {
        if (typeof _this.props.onMenu === 'function') {
          _this.props.onMenu(e, item, id);
        }
      };
    });

    _this.state = {
      data: (_this$props$data = _this.props.data) !== null && _this$props$data !== void 0 ? _this$props$data : ''
    };
    _this.parents = {};
    _this.domId = (_this$props$id = _this.props.id) !== null && _this$props$id !== void 0 ? _this$props$id : 'tree-' + _Common["default"].RandomString(8); //ccheck components

    _this.checkObjList = {}; //checked list

    _this.checkSelectList = {}; //check parent list

    _this.checkItems = {}; //this svg list

    _this.svgList = []; //checkedList

    _this.checkedList = [];
    return _this;
  }

  _createClass(Tree, [{
    key: "componentDidMount",
    value: function componentDidMount() {// let item = {
      //     icon:'',
      //     key:'',
      //     text:'',
      //     children:[]
      // };
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.data !== this.state.data) {
        this.setState({
          data: nextProps.data
        });
      }
    }
    /**
     * 选择事件
     */

  }, {
    key: "changeHandler",
    value: function changeHandler(item, id, parent) {
      var _this2 = this;

      return function (check) {
        _this2.setCheckObj(check, item, id, parent);
      };
    }
  }, {
    key: "setCheckObj",
    value: function setCheckObj(check, item, id, parent) {
      var _this3 = this;

      item.id = id;

      if (typeof this.props.onSelect === 'function') {
        this.props.onSelect(check, item);
      }

      if (check) {
        this.checkSelectList[parent].push(item);
        var idx = this.checkedList.findIndex(function (val) {
          return val.id === id;
        });

        if (idx === -1) {
          this.checkedList.push(item);
        }
      } else {
        var _idx = this.checkSelectList[parent].indexOf(item);

        this.checkSelectList[parent].splice(_idx, 1);
        var chk_idx = this.checkedList.findIndex(function (val) {
          return val.id === id;
        });

        if (chk_idx !== -1) {
          this.checkedList.splice(chk_idx, 1);
        }
      }

      if (this.checkItems[id] && this.checkItems[id].length > 0) {
        this.checkItems[id].forEach(function (data) {
          _this3.setCheckObj(check, data.data, data.id, id);

          _this3.checkObjList[data.id].setChecked(check);
        });
      } //set parent check status


      if (this.props.check && this.checkObjList[parent]) {
        if (this.checkSelectList[parent].length === this.checkItems[parent].length) {
          this.checkObjList[parent].setChecked(true);
        } else if (this.checkSelectList[parent].length > 0) {
          this.checkObjList[parent].setHalf(true);
        } else {
          this.checkObjList[parent].setChecked(false);
        }
      }
    }
  }, {
    key: "showChild",
    value: function showChild(id) {
      var parent = this.parents[id];

      if (parent) {
        if (parent.dataset.show === '0') {
          parent.dataset.show = '1';
          parent.classList.remove('d-none');
          parent.previousElementSibling.querySelector('i').classList.add('ck-tree-icon-down'); // this.drawLines(parent.querySelector('.ck-tree-svg'))
        } else {
          parent.dataset.show = '0';
          parent.classList.add('d-none');
          parent.previousElementSibling.querySelector('i').classList.remove('ck-tree-icon-down');
        }
      }
    }
  }, {
    key: "getSelected",
    value: function getSelected() {
      return this.checkedList;
    }
    /**
     * get main div class name
     * @returns {*}
     */

  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-tree';
      return (0, _dedupe["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      var base = {};

      if (this.props.width) {
        base.width = this.props.width;
      }

      return base;
    }
  }, {
    key: "drawLines",
    value: function drawLines(item) {
      var _item$dataset;

      if (((_item$dataset = item.dataset) === null || _item$dataset === void 0 ? void 0 : _item$dataset.done) === 'true') return;
      var path = "M 4 0 "; // x=3,
      // y=0;

      var numChild = parseInt(item.dataset.length);
      console.log(item.clientHeight, item.clientWidth);
      var itemHeight = item.clientHeight / numChild;
      var itemHalf = itemHeight / 2;

      for (var i = 0; i < numChild; i++) {
        // y += (itemHeight*i)
        if (i + 1 === numChild) {
          path += "v ".concat(itemHalf.toFixed(2), " h 17");
        } else {
          path += "v ".concat(itemHalf.toFixed(2), " h 17 m -17 0 v ").concat(itemHalf.toFixed(2), " ");
        }
      } // path += 'Z'


      var svg = (0, _Svg.SvgElm)(item);
      svg.add('path').attr('class', 'path-line').attr('d', path);
      item.dataset.done = 'true';
    }
  }, {
    key: "renderItem",
    value: function renderItem(list, parent, level, parent_key) {
      var _this4 = this;

      if (!(list instanceof Array)) {
        return null;
      }

      if (!level) {
        level = 0;
      }

      if (!parent_key) {
        parent_key = 0;
      }

      var pad = parent ? '20' : 0;
      this.checkSelectList[parent_key] = [];
      this.checkItems[parent_key] = [];
      return list.map(function (val, idx) {
        var style = {
          'marginLeft': pad + 'px'
        };
        var id = "".concat(parent_key, "-").concat(idx);

        _this4.checkItems[parent_key].push({
          id: id,
          data: val
        });

        if (val === null || val === void 0 ? void 0 : val.checked) {
          _this4.checkSelectList[parent_key].push(val);

          val.id = id;

          _this4.checkedList.push(val);
        }

        return _react["default"].createElement("div", {
          key: idx,
          className: "ck-tree-item",
          style: style
        }, _react["default"].createElement("div", {
          className: "ck-tree-content d-flex",
          onContextMenu: _this4.menuHandler(val, id)
        }, val.children ? _react["default"].createElement("span", {
          className: "ck-tree-icon",
          onClick: _this4.iconHandler(val, id)
        }, _react["default"].createElement(_Icon["default"], {
          className: val.show ? 'ck-tree-icon-down' : '',
          icon: val.children ? 'angle-right' : val.icon
        })) : _react["default"].createElement("span", {
          className: "ck-tree-icon"
        }), _this4.props.check ? _react["default"].createElement(_CCheckbox["default"], {
          ref: function ref(c) {
            return _this4.checkObjList[id] = c;
          },
          checked: val === null || val === void 0 ? void 0 : val.checked,
          className: "chk me-1",
          inline: true,
          onChange: _this4.changeHandler(val, id, parent_key)
        }) : null, _react["default"].createElement("span", {
          className: "ck-tree-item-text",
          onDoubleClick: _this4.dbClickHandler(val, id),
          onClick: _this4.selectHandler(val, id)
        }, val.icon ? _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_Icon["default"], {
          icon: val.icon
        }), " ") : null, val.text)), val.children ? _react["default"].createElement("div", {
          id: _this4.domId + '-' + id,
          className: 'ck-tree-children' + (val.show ? '' : ' d-none'),
          "data-show": val.show ? '1' : '0',
          ref: function ref(c) {
            return _this4.parents[id] = c;
          }
        }, _this4.renderSvg(val.children), _this4.renderItem(val.children, val, level + 1, id)) : null);
      });
    }
  }, {
    key: "renderSvg",
    value: function renderSvg(children) {
      return _react["default"].createElement("svg", {
        className: "ck-tree-svg",
        "data-length": children.length
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this5.mainDom = c;
        },
        className: this.getClasses(),
        style: this.getStyles()
      }, this.renderItem(this.state.data, null, 0, 0));
    }
  }]);

  return Tree;
}(_react["default"].PureComponent);

exports.Tree = Tree;
var _default = Tree;
exports["default"] = _default;
//# sourceMappingURL=Tree.js.map
