/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Drag = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 拖动控制类
 * @author clake
 * @version 0.1
 */
var move = {
  x: 0,
  y: 0
};

var Drag =
/*#__PURE__*/
function () {
  /**
   * 初始化方法
   * @param dragDom  DOMElement|string   拖动对像,可以传入DOM对像或selector字符串
   * @param eventDom DOMElement|string   拖动事件对像,可以传入DOM对像或selector字符串
   * @param events   object              事件对像,可选多个事件
   */
  function Drag(dragDom, eventDom, events) {
    var _this = this;

    _classCallCheck(this, Drag);

    _defineProperty(this, "dragX", 0);

    _defineProperty(this, "dragY", 0);

    _defineProperty(this, "domX", 0);

    _defineProperty(this, "domY", 0);

    _defineProperty(this, "x", 0);

    _defineProperty(this, "y", 0);

    _defineProperty(this, "dragDom", void 0);

    _defineProperty(this, "eventDom", void 0);

    _defineProperty(this, "_evtStart", void 0);

    _defineProperty(this, "_evtMove", void 0);

    _defineProperty(this, "_evtEnd", void 0);

    _defineProperty(this, "beginDrag", function (e) {
      if (e.button !== 0) {
        return false;
      }

      _this.eventDom = e === null || e === void 0 ? void 0 : e.currentTarget; // e.preventDefault();

      window.addEventListener('mousemove', _this.startMove, false);
    });

    _defineProperty(this, "startMove", function (e) {
      var _ref, _this$dragDom, _ref2, _this$dragDom2;

      if (e.buttons !== 1) {
        window.removeEventListener('mousemove', _this.startMove, false);
        return false;
      }

      window.removeEventListener('mousemove', _this.startMove, false);

      if (!_this._evtStart(_this.dragDom, _this.eventDom, e)) {
        return false;
      }

      _this.domX = parseInt((_ref = (_this$dragDom = _this.dragDom) === null || _this$dragDom === void 0 ? void 0 : _this$dragDom.style.left) !== null && _ref !== void 0 ? _ref : '0');
      _this.domY = parseInt((_ref2 = (_this$dragDom2 = _this.dragDom) === null || _this$dragDom2 === void 0 ? void 0 : _this$dragDom2.style.top) !== null && _ref2 !== void 0 ? _ref2 : '0');
      _this.dragX = e.pageX;
      _this.dragY = e.pageY;
      window.addEventListener('mousemove', _this.moveDrag, false);
      window.addEventListener('mouseup', _this.overDrag, false);
    });

    _defineProperty(this, "moveDrag", function (e) {
      move.x = _this.domX + (e.pageX - _this.dragX);
      move.y = _this.domY + (e.pageY - _this.dragY);

      if (typeof _this._evtMove === "function") {
        _this._evtMove(move, _this.dragDom, _this.eventDom, e);
      }

      _this.dragDom.style.top = move.y + 'px';
      _this.dragDom.style.left = move.x + 'px';
    });

    _defineProperty(this, "overDrag", function (e) {
      window.removeEventListener('mousemove', _this.moveDrag);
      window.removeEventListener('mouseup', _this.overDrag);

      _this._evtEnd(_this.dragDom, _this.eventDom, e);
    });

    this.setDragDom(dragDom);
    this.setEventDom(eventDom);
    this.initEvents(events);
  }

  _createClass(Drag, [{
    key: "setDragDom",
    value: function setDragDom(dragDom) {
      if (dragDom instanceof HTMLElement) {
        this.dragDom = dragDom;
      } else if (typeof dragDom === "string") {
        var dom = document.querySelector(dragDom);

        if (!dom) {
          throw "dragDom must be selector string or HTMLElement object";
        }

        this.dragDom = dom;
      } else {
        throw "dragDom must be selector string or HTMLElement object";
      }
    }
  }, {
    key: "setEventDom",
    value: function setEventDom(eventDom) {
      if (eventDom instanceof HTMLElement) {
        this.eventDom = eventDom;
      } else if (typeof eventDom === 'string') {
        var dom = document.querySelector(eventDom);

        if (!dom) {
          this.eventDom = this.dragDom;
        }

        this.eventDom = dom;
      } else {
        this.eventDom = this.dragDom;
      }

      this.bindEvents();
    }
  }, {
    key: "initEvents",
    value: function initEvents(events) {
      var _events$start, _events$move, _events$end;

      this._evtStart = (_events$start = events.start) !== null && _events$start !== void 0 ? _events$start : defaultEvent;
      this._evtMove = (_events$move = events.move) !== null && _events$move !== void 0 ? _events$move : undefined;
      this._evtEnd = (_events$end = events.end) !== null && _events$end !== void 0 ? _events$end : defaultEvent;
    }
  }, {
    key: "bindEvents",
    value: function bindEvents() {
      var _this$eventDom;

      (_this$eventDom = this.eventDom) === null || _this$eventDom === void 0 ? void 0 : _this$eventDom.addEventListener("mousedown", this.beginDrag, false);
    }
  }, {
    key: "unbind",
    value: function unbind() {
      var _this$eventDom2;

      (_this$eventDom2 = this.eventDom) === null || _this$eventDom2 === void 0 ? void 0 : _this$eventDom2.removeEventListener('mousedown', this.beginDrag);
    }
  }]);

  return Drag;
}();

exports.Drag = Drag;

function defaultEvent() {
  return true;
}

var _default = Drag;
exports["default"] = _default;
//# sourceMappingURL=Drag.js.map
