/* @clake/react-bootstrap4 v2.4.9 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-23T17:38:08+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Upload = void 0;

var _Common = _interopRequireDefault(require("../Common"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fileDom;

var Upload =
/*#__PURE__*/
function () {
  _createClass(Upload, null, [{
    key: "NewUpload",
    //change event handler
    //progress event handler
    //success event handler
    //error event handler
    //upload server address
    //is init dom
    //current choose file
    //post file field name
    //drag file selector
    value: function NewUpload(opts) {
      return new Upload(opts);
    }
  }]);

  function Upload(opts) {
    var _this = this,
        _ref,
        _ref2,
        _ref3,
        _ref4,
        _ref5,
        _ref6,
        _ref7;

    _classCallCheck(this, Upload);

    _defineProperty(this, "changeEvent", void 0);

    _defineProperty(this, "progressEvent", void 0);

    _defineProperty(this, "successEvent", void 0);

    _defineProperty(this, "errorEvent", void 0);

    _defineProperty(this, "uploadHost", void 0);

    _defineProperty(this, "isInit", false);

    _defineProperty(this, "currentFile", void 0);

    _defineProperty(this, "fieldName", void 0);

    _defineProperty(this, "dragSelector", void 0);

    _defineProperty(this, "dropHandler", function (e) {
      e.stopPropagation();
      e.preventDefault();

      if (e.dataTransfer && e.dataTransfer.files.length > 0) {
        _this.currentFile = e.dataTransfer.files[0];

        if (typeof _this.changeEvent === 'function') {
          _this.changeEvent(_this.currentFile, _this.currentFile.name);
        }
      }
    });

    _defineProperty(this, "changeHandler", function () {
      var _fileDom$files;

      _this.currentFile = (_fileDom$files = fileDom.files) === null || _fileDom$files === void 0 ? void 0 : _fileDom$files[0];

      if (typeof _this.changeEvent === 'function' && _this.currentFile) {
        _this.changeEvent(_this.currentFile, _this.currentFile.name);
      }
    });

    this.changeEvent = (_ref = opts === null || opts === void 0 ? void 0 : opts.change) !== null && _ref !== void 0 ? _ref : null;
    this.progressEvent = (_ref2 = opts === null || opts === void 0 ? void 0 : opts.progress) !== null && _ref2 !== void 0 ? _ref2 : null;
    this.successEvent = (_ref3 = opts === null || opts === void 0 ? void 0 : opts.success) !== null && _ref3 !== void 0 ? _ref3 : null;
    this.errorEvent = (_ref4 = opts === null || opts === void 0 ? void 0 : opts.error) !== null && _ref4 !== void 0 ? _ref4 : null;
    this.uploadHost = (_ref5 = opts === null || opts === void 0 ? void 0 : opts.host) !== null && _ref5 !== void 0 ? _ref5 : '';
    this.fieldName = (_ref6 = opts === null || opts === void 0 ? void 0 : opts.field) !== null && _ref6 !== void 0 ? _ref6 : 'upfile';
    this.dragSelector = (_ref7 = opts === null || opts === void 0 ? void 0 : opts.drag_target) !== null && _ref7 !== void 0 ? _ref7 : null;
    this.initFileDom();
  }

  _createClass(Upload, [{
    key: "initFileDom",
    value: function initFileDom() {
      if (!fileDom) {
        fileDom = document.createElement("input");
        fileDom.type = 'file';
        fileDom.className = 'd-none';
        fileDom.addEventListener("change", this.changeHandler); // document.body.appendChild(fileDom);
      }

      var dragDom = undefined;

      if (typeof this.dragSelector === 'string') {
        var dom = document.querySelector("#" + this.dragSelector);

        if (!dom) {
          throw "can not found drag selector";
        }

        dragDom = dom;
      }

      if (dragDom) {
        dragDom.addEventListener("drop", this.dropHandler, false);
      }

      this.isInit = true;
    }
  }, {
    key: "choose",
    //tiger choose upload file
    value: function choose() {
      fileDom.value = '';
      fileDom.click();
    } //upload to host

  }, {
    key: "up",
    value: function up(post_data) {
      var _this2 = this;

      if (!this.currentFile) {
        return;
      } // let ot,oloaded;


      var data = new FormData();
      data.append(this.fieldName, this.currentFile);

      if (post_data) {
        _Common["default"].map(post_data, function (item, key) {
          data.append(key, item);
        });
      }

      var xhr = new XMLHttpRequest();
      xhr.open("post", this.uploadHost, true); // 请求成功回调函数

      xhr.addEventListener('load', function (e) {
        var status = xhr.status;

        if (status >= 200 && status < 300 || status === 304) {
          var _result;

          if (xhr.responseType === 'text') {
            _result = xhr.responseText;
          } else if (xhr.responseType === 'document') {
            _result = xhr.responseXML;
          } else {
            _result = xhr.response;
          } // 注意:状态码200表示请求发送/接受成功,不表示业务处理成功


          if (typeof _this2.successEvent === 'function') _this2.successEvent(_result, status, xhr);
        } else {
          if (typeof _this2.errorEvent === 'function') _this2.errorEvent(status, e);
        }
      }); // 请求出错

      xhr.addEventListener('error', function (e) {
        if (typeof _this2.errorEvent === 'function') _this2.errorEvent(xhr.status, e);
      }); // 请求超时

      xhr.addEventListener('timeout', function (e) {
        if (typeof _this2.errorEvent === 'function') _this2.errorEvent(408, e);
      }); // xhr.upload.addEventListener('progress');
      //upload progress

      xhr.upload.addEventListener("progress", function (e) {
        var loaded, total, percent;

        if (e.lengthComputable) {
          loaded = e.loaded;
          total = e.total;
          percent = (loaded / total * 100).toFixed(0);
        }

        if (typeof _this2.progressEvent === 'function') {
          _this2.progressEvent(loaded, total, percent);
        }
      }); //start
      // xhr.addEventListener('loadstart',()=>{
      //     ot = new Date().getTime();
      //     oloaded = 0;
      // });

      xhr.responseType = 'json';
      xhr.send(data);
    }
  }]);

  return Upload;
}();

exports.Upload = Upload;
var _default = Upload;
exports["default"] = _default;
//# sourceMappingURL=Upload.js.map
