import React from 'react';
import './css/Button.less';
import { ComponentProps, StrObject, Theme } from './components/common';
import { Tooltip } from 'bootstrap';
interface Props extends ComponentProps {
    theme?: Theme | string;
    outline?: boolean;
    icon?: string;
    tip?: string;
    loading?: boolean;
    block?: boolean;
    role?: string;
    onClick?: (event: React.MouseEvent) => void;
}
interface State {
    content: any;
    show: boolean;
    autoHide: number;
    width: string;
    theme: string;
    isClose: boolean;
}
export declare class Button extends React.PureComponent<Props, State> {
    domId: string;
    tip: Tooltip;
    static defaultProps: {
        theme: Theme;
        outline: boolean;
        size: string;
        loading: boolean;
    };
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    getClasses(): string;
    getStyles(): StrObject;
    clickHandler: (e: React.MouseEvent) => void;
    render(): JSX.Element;
    renderTip(): {
        'data-toggle'?: undefined;
        'data-placement'?: undefined;
    } | {
        'data-toggle': string;
        'data-placement': string;
    };
    renderIcon(): JSX.Element | null;
}
export default Button;
//# sourceMappingURL=Button.d.ts.map