import React from 'react';
import './css/Modal.less';
import { ComponentProps } from './components/common';
interface Options {
    title?: string;
    content: any;
    close?: boolean;
    header?: boolean;
    center?: boolean;
    width?: string;
    btns?: {
        [propsName: string]: string;
    };
    shadowClose?: boolean;
    fade?: boolean;
    callback?: any;
    empty?: boolean;
}
interface ViewOptions extends Options {
    size?: string;
    onClose?: () => void;
}
interface Props extends ComponentProps {
    onOpen?: () => void;
    onClose?: () => void;
    center?: boolean;
    fade?: boolean;
    header?: boolean;
    blurSelector?: string;
    isCloseBtn?: boolean;
    shadowClose?: boolean;
    id?: string;
    btns?: {
        [propsName: string]: string;
    };
}
interface State {
    content: any;
    title: string;
    isCloseBtn?: boolean;
    header?: boolean;
    type: number;
    center?: boolean;
    fade?: boolean;
    show: boolean;
    width: string | null;
    size: string;
    btns: {
        [propName: string]: string;
    };
    shadowClose?: boolean;
    empty: boolean;
}
export declare class CKModal extends React.Component<Props, State> {
    static defaultProps: {
        isCloseBtn: boolean;
        header: boolean;
        center: boolean;
        fade: boolean;
        shadowClose: boolean;
    };
    domId: string;
    modalType: number;
    callback: any;
    evtClosed: any;
    evtOpened: any;
    offsetIndex: number;
    is_open: boolean;
    _modal: HTMLDivElement;
    _shadow: HTMLDivElement;
    constructor(props: any);
    shouldComponentUpdate(nextProps: Props, nextState: State): boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    hasScrollbar(): boolean;
    open(): void;
    close(): void;
    closeHandler: () => void;
    openHandler: () => void;
    alert(opt: Options | any, cb?: () => void): void;
    /**
     * modal confirm method
     * opt example
     * {
     *      title:'',
     *      content:'',
     *      [callback: func]
     * }
     * @param opt
     */
    confirm(opt: Options | any, cb?: (flag: number) => void): void;
    /**
     * modal loading method
     * @param opt
     */
    loading(opt: Options | string): void;
    /**
     * modal view method
     * opt example
     * {
     *      title:'',
     *      content:flex,
     *      [callback:func]
     * }
     * @param opt
     */
    view(opts: ViewOptions): void;
    getClasses(): string;
    getDialogClasses(): string;
    getDialogStyles(): {
        [propName: string]: string;
    };
    getShadowClasses(): string;
    renderFooter(): JSX.Element | null;
    render(): React.ReactPortal;
}
declare const Modal: typeof CKModal;
export default Modal;
//# sourceMappingURL=CKModal.d.ts.map