import React from 'react';
import './css/Calender.less';
import { ComponentProps } from './components/common';
interface Props extends ComponentProps {
    none?: boolean;
    shadow?: boolean;
    value?: string;
    lang?: string;
    onSelect?: any;
    triangular?: 'up' | 'left' | 'bottom' | 'right';
    format?: string;
    sm?: boolean;
    timeBar?: boolean;
    target?: HTMLElement;
    limit?: {
        lt?: any;
        gt?: any;
    };
}
interface State {
    days: any[][];
    month: boolean;
    year: boolean;
    time: boolean;
    hour: string;
    minute: string;
    second: string;
}
export declare class Calendar extends React.PureComponent<Props, State, any> {
    static defaultProps: {
        lang: string;
        format: string;
    };
    year: {
        start: number;
        end: number;
    };
    isClose: boolean;
    hours: string[];
    minute: string[];
    sec: string[];
    current_date: Date;
    parentDom: HTMLElement;
    failRange?: {
        start: any;
        end: any;
    };
    domId: string;
    show_date: Date;
    mainTable: HTMLTableElement;
    clientWidth: number;
    mainDom: HTMLDivElement;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(): void;
    UNSAFE_componentWillReceiveProps(nextProp: Props): void;
    isTimeBar(): boolean | undefined;
    initFailRange(limit?: {
        lt?: any;
        gt?: any;
    }): {
        start: Date | null;
        end: Date | null;
    } | undefined;
    keyPressHandler: (e: any) => void;
    setCurrentDate(value: any): void;
    fillDateList(): ({
        value: number;
        disabled: boolean;
    } | undefined)[][];
    privMonth(): void;
    nextMonth(): void;
    setMonth(month: any): void;
    setYear(year: any, show: any): void;
    setFailRange(start_date: Date, days: number): boolean;
    choseDay(year: any, month: any, day: any): void;
    selectTimeHandler: () => void;
    format(formatStr?: string): string;
    hide: (e?: Event | undefined) => void;
    show(dom: HTMLElement): void;
    refreshWidth(): void;
    fixPosition(): void;
    checkShow: () => void;
    autoComplete(val: string): void;
    getClasses(): string;
    touchStartX: number;
    touchStartY: number;
    touchScrollX: number;
    touchScrollY: number;
    touchStartHandler: (e: TouchEvent) => void;
    touchMoveHandler: (e: TouchEvent) => void;
    touchScrollHandler(): void;
    unTouchScrollHandler(): void;
    renderMonth(): JSX.Element;
    renderYear(): JSX.Element;
    renderDays(): JSX.Element;
    render(): JSX.Element;
    renderTimeBar(): JSX.Element;
    renderTime(): JSX.Element;
    renderContent(): JSX.Element;
}
export declare function format(formatStr: string, date: Date): string;
export default Calendar;
//# sourceMappingURL=Calendar.d.ts.map