import React from 'react';
import './css/Input.less';
import './css/CalendarRange.less';
import { Calendar } from "./index";
import { ComponentProps } from './components/common';
interface Props extends ComponentProps {
    id?: string;
    label?: string;
    minData?: string;
    maxData?: string;
    days?: number;
    readOnly?: boolean;
    placeholderMin?: string;
    placeholderMax?: string;
    onChange?: (min: any, max: any) => void;
    format?: string;
    time?: boolean;
    disabled?: boolean;
    disableClear?: boolean;
    labelClass?: string;
    className?: string;
    textClass?: string;
    width?: string;
    data?: string;
    limit?: {
        lt?: any;
        gt?: any;
    };
}
interface State {
    value: string;
    min: string;
    max: string;
    validate: boolean;
    disabled: boolean;
    icon: string;
}
export declare class CalendarRange extends React.PureComponent<Props, State> {
    static defaultProps: {
        id: string;
        size: string;
        label: string;
        minData: string;
        maxData: string;
        days: number;
        summary: string;
        readOnly: boolean;
        disabled: boolean;
        disableClear: boolean;
        format: string;
    };
    domId: string;
    isFocus: boolean;
    inputDom: HTMLDivElement;
    inputMin: HTMLInputElement;
    inputMax: HTMLInputElement;
    calendar_panel: HTMLDivElement;
    mainDom: HTMLDivElement;
    maxCalendar: Calendar;
    minCalendar: Calendar;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    UNSAFE_componentWillReceiveProps(nextProps: Props): void;
    getClasses(): string;
    getMainStyles(): any;
    getInputClasses(append: string): string;
    show: () => void;
    hide: () => void;
    changeHandler: () => void;
    clearHandler: () => void;
    render(): JSX.Element;
    renderLabel(): JSX.Element | null;
    renderCalendar(): JSX.Element;
}
export default CalendarRange;
//# sourceMappingURL=CalendarRange.d.ts.map