import React from 'react';
import Table from './Table';
import "./css/Combo.less";
import { ComponentProps, StrObject } from './components/common';
export interface ComboProps extends ComponentProps {
    searchColumn?: string;
    data?: any;
    showRows?: number;
    search?: string;
    onSearch?: (search: string, callback: (data: any) => void) => void;
    onSelect?: (val: any, row: any) => void;
    onClose?: () => void;
    onShow?: () => void;
    sm?: boolean;
    multi?: boolean;
    multiDef?: any;
    filterColumns?: any[];
    noSearch?: boolean;
    header?: boolean;
    searchType?: string;
    triangular?: string;
    empty?: string;
}
interface State {
    data: any;
    loading: boolean;
    emptyText: string;
}
export declare class Combo extends React.Component<ComboProps, State> {
    static defaultProps: {
        showRows: number;
        data: never[];
        search: string;
        multi: boolean;
        multiDef: null;
        header: boolean;
        searchType: string;
    };
    isRemote: boolean;
    parentDom: HTMLElement;
    search: string;
    isClose: boolean;
    table: Table;
    nodeList?: NodeListOf<HTMLElement>;
    mainDom: HTMLElement;
    conDom: HTMLElement;
    currentSelect?: number;
    filterTime?: any;
    isMobile: boolean;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    UNSAFE_componentWillReceiveProps(nextProps: ComboProps): void;
    componentDidUpdate(): void;
    setSelectRows(key: any, val: any): void;
    setSearchText(text: string): void;
    show(search: any, dom: HTMLElement): void;
    checkShow: () => void;
    keyDownHandler: (e: KeyboardEvent) => void;
    clearSelect(): void;
    moveItem(step?: number): void;
    selectItem(): void;
    fixPosition(): void;
    hide: () => void;
    selectHandler: (row: any, i: string) => void;
    multiSelectHandler: () => void;
    clearMulti(): void;
    filter(search: string): void;
    filterColumns(): any[];
    getClasses(): string;
    getStyles(): StrObject;
    render(): JSX.Element;
    renderLoading(): JSX.Element;
    renderNotResult(): JSX.Element;
    renderList(): JSX.Element;
    filterFormat: (val: any) => any;
}
export default Combo;
//# sourceMappingURL=Combo.d.ts.map