import React from 'react';
import './css/Complex.less';
import { IconRef } from './Icon';
import Combo, { ComboProps } from "./Combo";
import { ComponentProps, StrObject, Theme } from './components/common';
interface Props extends ComponentProps {
    inputWidth?: string;
    onChange?: (data: any, list: any) => void;
    onSelect?: (val: any, row: any) => void;
    list?: any[];
    dataType?: string;
    dataField?: string;
    data?: any[];
    placeholder?: string;
    combo?: ComboProps;
    comboData?: any;
    duplicate?: boolean;
    readOnly?: boolean;
}
interface State {
    list: any[];
    value: string;
    icon: string;
}
export declare class Complex extends React.Component<Props, State> {
    static defaultProps: {
        inputWidth: string;
        dataType: string;
        dataField: string;
        data: never[];
        duplicate: boolean;
        Theme: Theme;
    };
    combo: Combo;
    input: HTMLInputElement;
    isFocus: boolean;
    clearIcon: IconRef;
    main: HTMLDivElement;
    constructor(props: any);
    componentDidMount(): void;
    UNSAFE_componentWillReceiveProps(nextProps: Props): void;
    getClasses(): string;
    getInputCss(): StrObject;
    /*********************
     * Event
     *********************/
    focusClearHandler: () => void;
    blurClearHandler: () => void;
    searchHandler: (e: any) => void;
    selectHandler: (val: any, row: any) => void;
    clickHandler: () => void;
    keyUpHandler: (e: React.KeyboardEvent) => void;
    deleteHandler(idx: number): (e: React.MouseEvent) => void;
    addNewData(val: any, row?: any): void;
    render(): JSX.Element;
    renderCombo(): JSX.Element | null;
}
export default Complex;
//# sourceMappingURL=Complex.d.ts.map