import React from 'react';
import './css/Menu.less';
import { ComponentProps, StrObject } from './components/common';
interface MenuItemProps extends ComponentProps {
    step?: boolean;
    field: string;
    onClick?: (e: any, field: string, data?: any) => void;
    child?: boolean;
    text?: string;
    icon?: string;
    parent?: Menu;
}
export declare class MenuItem extends React.Component<MenuItemProps, any> {
    parent: Menu;
    childMenu: Menu;
    constructor(props: any);
    componentDidMount(): void;
    clickHandler: (e: React.MouseEvent) => void;
    showChildHandler: (e: any) => void;
    closeChildHandler: (e: React.MouseEvent) => void;
    getClasses(): string;
    render(): JSX.Element;
    renderIcon(): JSX.Element;
    renderChildMenu(): JSX.Element;
}
interface MenuProps extends ComponentProps {
    onClick?: (field: any, data?: any) => void;
    onClose?: (e: any) => void;
    onShow?: () => void;
    zIndex?: number;
}
interface State {
    menu_list: any[];
}
export declare class Menu extends React.Component<MenuProps, State> {
    static Item: typeof MenuItem;
    static defaultProps: {
        zIndex: number;
    };
    domId: string;
    data: any;
    childMenus: any[];
    evt_close?: (e: any) => void;
    mainDom: HTMLDivElement;
    height: number;
    width: number;
    constructor(props: any);
    initMenuData(): any[];
    componentDidMount(): void;
    componentWillUnmount(): void;
    clickHandler: (e: any, key?: any) => void;
    show(option: any): void;
    showHandler(option: any): void;
    position(option: any): void;
    fixPositionScreen(x: number, y: number, offx?: number, offy?: number): {
        x: number;
        y: number;
    };
    hide: (e: any) => void;
    closeChild(e: any): void;
    getClasses(): string;
    getStyles(): StrObject;
    render(): React.ReactPortal;
}
export default Menu;
//# sourceMappingURL=Menu.d.ts.map