import React from 'react';
import TableHeader from './TableHeader';
import TableHeaderRow from "./TableHeaderRow";
import CCheckbox from "./CCheckbox";
import './css/Table.less';
import HScroll from "./HScroll";
import Menu from "./Menu";
import { AnyObject, ComponentProps, StrObject, Theme } from './components/common';
import Drag from './components/Drag';
interface Props extends ComponentProps {
    theme?: Theme;
    headerTheme?: Theme;
    headerAlign?: string;
    headClass?: string;
    data?: any[];
    dataCount?: number;
    select?: boolean;
    header?: boolean;
    center?: boolean;
    currentPage?: number;
    striped?: boolean;
    bordered?: boolean;
    hover?: boolean;
    sm?: boolean;
    fontSm?: boolean;
    responsive?: boolean;
    align?: string;
    tree?: boolean;
    onClickTree?: (row: any, callback: (data: any) => any) => void;
    onClick?: (row: any, i: string) => void;
    onCheck?: (chk: boolean, row: any) => void;
    onCheckAll?: (chk: boolean, rows: any[]) => void;
    move?: boolean;
    onRefresh?: () => void;
    refreshText?: string;
    scroll?: boolean;
    emptyText?: string;
    fixed?: boolean;
    serialNumber?: boolean;
    truncate?: boolean;
    menu?: any;
    sticky?: boolean;
    columnStyle?: StrObject;
    loading?: boolean;
}
interface State {
    data: any[];
    select: boolean;
    tree: AnyObject;
    refresh: boolean;
    selectRows: any;
    selectAll: boolean;
    selectHalf: boolean;
}
export declare class Table extends React.Component<Props, State> {
    static Header: typeof TableHeader;
    static HeaderRow: typeof TableHeaderRow;
    static defaultProps: Props;
    treeOpens: AnyObject;
    select_all: boolean;
    selectRows: any[];
    treeHeader: AnyObject;
    sortList: AnyObject;
    afterFields: any[];
    beforeFields: any[];
    tableHeaderRows: any[];
    headers: TableHeader[];
    width: number;
    beforeHoldWidth: number;
    afterHoldWidth: number;
    domId: string;
    mainDom: HTMLDivElement;
    rootDom: HTMLDivElement;
    stickyDom: HTMLElement;
    tableHeader?: HTMLElement;
    afterHeader?: HTMLElement;
    beforeHeader?: HTMLElement;
    beforeBody?: HTMLTableElement;
    afterBody?: HTMLTableElement;
    tableBody: HTMLTableElement;
    hScroll: HScroll;
    menu: any;
    mainMenu: Menu;
    allchk: CCheckbox;
    renderCheckes: any[];
    drag: Drag;
    headerSplits: any[];
    dragColumnLeft: number;
    dragWidth: number;
    split: HTMLElement;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    sticky(): void;
    unSticky(): void;
    stickyHeader: () => void;
    syncRowsHeight(): void;
    setRowsHeight(rows: any, heightRows: any): void;
    holdShow: () => void;
    componentDidUpdate(): void;
    UNSAFE_componentWillReceiveProps(nextProps: Props): void;
    shouldComponentUpdate(nextProps: Props, nextState: State): boolean;
    initTreeData(data: any[], treeData: AnyObject): AnyObject;
    initTableWidth(children: any): void;
    initTableHeaderRow(row: any): void;
    /**
    * binding column split
    */
    bindSplit(): void;
    changeHandler(row: any, i: string): (checked: boolean) => void;
    checkAllCheckHalf(): boolean[];
    setRowCheck(checked: boolean, rowIdx: string): void;
    refCheck(row: any, rowIdx: string): (c: any) => void;
    clickHandler(row: any, i: string): () => void;
    sortHandler(field: string, callback: (field: string, type: string) => void): (e: React.MouseEvent) => void;
    selectAll: (checked: boolean) => void;
    /**
     * 得到所有选中的行
     */
    getSelectRows(): any[];
    /**
     * 设置选中的行
     */
    setSelectRows(key: string, list: any[]): void;
    getClasses(css?: string): string;
    getMainClass(): string;
    getStyles(): StrObject;
    getMainStyle(): any;
    getTableStyles(width?: number): StrObject;
    getHeaderClasses(): string;
    scrollHandler: (e: Event) => void;
    touchStartX: number;
    touchStartY: number;
    touchScrollX: number;
    touchScrollY: number;
    touchStartHandler: (e: TouchEvent) => void;
    touchMoveHandler: (e: TouchEvent) => void;
    touchScrollHandler(): void;
    unTouchScrollHandler(): void;
    holdShadow(): void;
    setHeight(height: string): void;
    render(): JSX.Element;
    renderCol(filter?: string[], filter_type?: string): JSX.Element;
    renderHeaderRow(filter?: string[], filter_type?: string): any[] | null;
    renderHeader(filter?: string[], filter_type?: string): JSX.Element;
    renderBody(filter?: string[], filter_type?: string): JSX.Element | JSX.Element[];
    formatSn(i: string | number): string | number;
    hoverAuthorRow: (e: React.MouseEvent) => void;
    renderRow(row: any, i: string, parentRow: any, indent: number, filter?: string[], filter_type?: string): JSX.Element;
    renderTreeRow(row: any, i: string, indent: number, filter?: string[], filter_type?: string): any;
    renderHoldBefore(): JSX.Element | null;
    renderHoldAfter(): JSX.Element | null;
}
export default Table;
//# sourceMappingURL=Table.d.ts.map