import React from 'react';
import './css/TextArea.less';
import { AnyObject, ComponentProps } from './components/common';
interface Props extends ComponentProps {
    label?: string;
    data?: any;
    summary?: string;
    readOnly?: boolean;
    placeholder?: string;
    plaintext?: boolean;
    onChange?: (val: any, obj: any, evt?: any) => void;
    row?: number;
    htmlMode?: boolean;
    htmlBar?: boolean;
}
interface State {
    html: any;
    value: any;
    isFull: boolean;
}
export declare class TextArea extends React.Component<Props, State> {
    static defaultProps: {
        label: string;
        data: null;
        summary: string;
        readOnly: boolean;
        htmlMode: boolean;
        htmlBar: boolean;
    };
    domId: string;
    input: HTMLElement;
    resizeImg: HTMLElement;
    resizeRB: HTMLElement;
    resize: AnyObject;
    currentResize: HTMLElement | null;
    mainDom: HTMLElement;
    isFull: boolean;
    fullBtn: HTMLElement;
    constructor(props: any);
    componentDidMount(): void;
    UNSAFE_componentWillReceiveProps(nextProp: Props): void;
    shouldComponentUpdate(nextProps: Props, nextState: State): boolean;
    componentDidUpdate(): void;
    resizeContent(): void;
    getValue(): any;
    setValue(val: string): void;
    getMainClasses(): string;
    getMainStyles(): any;
    getInputClasses(): string;
    /*********************
     * Event
     *********************/
    changeHandler: (e: any) => void;
    inputHandler: () => void;
    pasteHandler: (e: React.ClipboardEvent) => void;
    dropHandler: (e: React.DragEvent) => void;
    fullHandler: () => void;
    /*********************
     * edit html process method
     *********************/
    insertImage(file: File): void;
    insertHtmlNode(node: any): false | undefined;
    execCommand(cmd: string, args?: string): void;
    initImageResize(): void;
    bindingResize: (e: Event) => void;
    unBindingResize: (e: Event) => void;
    /*********************
     * render method
     *********************/
    renderLabel(): JSX.Element | null;
    renderSummary(): JSX.Element | null;
    render(): JSX.Element;
    renderTextArea(): JSX.Element;
    renderHtmlEdit(): JSX.Element;
    getContent(): any;
    renderHtmlEditIcon(): JSX.Element | null;
    renderFullButton(): JSX.Element;
}
export default TextArea;
//# sourceMappingURL=TextArea.d.ts.map