import React from 'react';
import './css/Tree.less';
import { ComponentProps } from './components/common';
interface Props extends ComponentProps {
    data?: any;
    onClick?: (event: React.MouseEvent, data: any, id: string) => void;
    onDbClick?: (data: any, id: string) => boolean;
    onMenu?: (event: React.MouseEvent, data: any, id: string) => void;
    showSelected?: boolean;
    check?: boolean;
    onSelect?: (checked: boolean, data: any) => void;
}
interface State {
    data: any;
}
export declare class Tree extends React.PureComponent<Props, State> {
    domId: string;
    parents: any;
    currentSelected: any;
    checkObjList: any;
    checkSelectList: any;
    checkItems: any;
    svgList: any[];
    checkedList: any[];
    mainDom: HTMLElement;
    constructor(props: any);
    componentDidMount(): void;
    UNSAFE_componentWillReceiveProps(nextProps: Props): void;
    /**
     * 选择事件
     */
    selectHandler: (item: any, id: string) => (e: React.MouseEvent) => void;
    dbClickHandler: (item: any, id: string) => () => void;
    iconHandler: (item: any, id: string) => () => void;
    menuHandler: (item: any, id: string) => (e: React.MouseEvent) => void;
    changeHandler(item: any, id: string, parent: string): (check: boolean) => void;
    setCheckObj(check: boolean, item: any, id: string, parent: string): void;
    showChild(id: string): void;
    getSelected(): any[];
    /**
     * get main div class name
     * @returns {*}
     */
    getClasses(): string;
    getStyles(): any;
    drawLines(item: any): void;
    renderItem(list: any, parent: any, level: number, parent_key: any): JSX.Element[] | null;
    renderSvg(children: any): JSX.Element;
    render(): JSX.Element;
}
export default Tree;
//# sourceMappingURL=Tree.d.ts.map